{
Copyright (C)2006 JesTheOnlyOne
A part of the code in this unit is based on eMule source code Copyright (C)2002-2006 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}


{ conditionals
  ------------

- viewer:
must be defined when compiling the viewer, undefined when compiling the recorder

}

{$WARN SYMBOL_PLATFORM OFF}
{$IFDEF debug}
	{$R+,I+,Q+}
{$ELSE}
	{$R-,I-,Q-}
{$ENDIF}
unit basicDefsUnit;

interface

uses
	classes, windows, sysUtils, registry, forms, dateUtils, shellAPI, strUtils
	{$IFDEF viewer}, Graphics, math {$ENDIF}, activeX, shFolder;

resourceString
	appFullName = 'Emule file stats';

	msgErrEMuleNotFound =
		  'Cannot find known.met or preferences.ini.'#13#10#13#10
		+ 'Please make sure that:'#13#10#13#10
		+ '- %s executables are installed in an "%s" subfolder inside your eMule directory.'#13#10
		+ 'Typically: "C:\Program files\eMule\%s"'#13#10#13#10
		+ '- Emule has been started at least once with the currently selected setting in Options > Extended > Sharing eMule with other computer users (or simply that eMule has been started at least once, if older than v0.48a)';
	msgErrLogsNotFound =
		  'Cannot find or create logs directory "%s"';
	errInvalidHash = 'Invalid hash';
	rsModifiedWhileReadingError = 'The "%s" file has been modified while trying to read it.';

	errDuplicateLogs = 'Duplicate log files: "%s" (*%s used)';
	errCreateLogObject = 'Cannot create log object from the file "%s": %s';
	errInvalidLogFile = 'Invalid log file: "%s"';
	{$IFDEF viewer}
	errLoadLog = 'Cannot load the "%s" log file: %s';
	errSaveLog = 'Cannot save the "%s" log file: %s';
	errCreateLog = 'Cannot create the "%s" log file: %s';
	errNoLicense = '%s not found (GNU GENERAL PUBLIC LICENSE). Please make sure that you have downloaded this software from a trusted source.';
	{$ELSE}
	errLogIniUnexpectedType = 'Cannot update "%s" log from ini file: unexpected data type';
	errLogIniNoSuchValue = 'Cannot update "%s" log from ini file: value not found';
	errLogKFNoSuchHash = 'Cannot update "%s" log from known.met file: hash not found';
	errLogCantReadData = 'An unexpected error occurred while reading data to update the "%s" log: %s';
	errAppendLog = 'Cannot append a value to the "%s" log file: %s';
	errInvalidOnlineSig = 'Invalid data in onlinesig.dat';
	errLoadOnlineSig = 'An error occurred while reading "onlinesig.dat": %s';
	errOnlineSigDisabled = 'Cannot read the number of queued clients: online signature is disabled and/or the "onlinesig.dat" file does not exist';
	{$ENDIF}

const
	delayAfterDateChange = 2000;
	{ Wait at least this nb of milliseconds after an eMule file date has changed before trying to access it
	(the file modification date is not updated when the file is closed, but each time data is written to the file,
	so it's safer to wait some time after emule has written to a file before trying to open it) }

const
	kmSaveInterval =		11; { emule saves known.met every 11 minutes }

	timer_init =			1; {milliseconds} { when an update is needed as soon as possible }
	timer_retry =			delayAfterDateChange; {milliseconds} { after a failed attempt to read known.met (or other) }
	timer_default =			kmSaveInterval; {minutes} { normal delay }

const

	{ dir names }
	dnEFS =				'EFS\';
	dnLogs =			'EFS logs\';
	dnEmuleConfig =		'config\';
//	dnEmuleIncoming =	'incoming\';
	dnEmule =			'eMule\';
	dnEmuleDownloads =	'eMule Downloads\';

{ 12 may 07: 0.48a support (new folders) >>> }
var
	pnEmuleExe, { replaces eMulePath }
	pnEmuleData, { replaces eMulePath }
	pnEmuleConfig, { replaces eMulePath + dnEmuleConfig }
	pnEFSExe, { replaces appPath }
	pnEFSConfig, { replaces appPath }
	pnEFSLogs: string; { replaces logsPath (= appPath + dnLogs) }
{ <<< 12 may 07: 0.48a support (new folders) }

const
	{ file names }
	fnEFSConfig =		'EFS.ini';
	fnRecErrorsLog =	'errors.log';
	fnLicense =			'license.txt';

	{ eMule file names }
	fnKnownMet =		'known.met';
	fnCancelledMet =	'cancelled.met';
	fnPreferencesIni =	'preferences.ini';
	fnSharedDirDat =	'shareddir.dat';
	fnCategoryIni =		'Category.ini';
	fnStatisticsIni =	'statistics.ini';
	fnWebServicesDat =	'webservices.dat';
	fnOnlineSigDat =	'onlinesig.dat';
	{ 14 feb 09: emule0.49c: Share/unshare single files >>> }
	fnSharedFilesDat =	'sharedfiles.dat';
	{ 14 feb 09: emule0.49c: Share/unshare single files >>> }

	max_eMule_file_size = $4000000000; // = 2^38 = 256GB

	{ file extensions }
	enLogExt =			'.efs_on';
	disLogExt =			'.efs_off';
	permLogExt =		'.efs';

	{ inifile sections }
	isEmule =			'eMule';
	isStatistics =		'statistics';
	isEFS =				'EFS';

	{ inifile keys }
	ikIncoming =				'IncomingDir';
	ikRuntime =					'ConnRunTime';
	ikTotalULed =				'TotalUploadedBytes';
	ikUpData_File =				'UpData_File';
	ikMaxUpload =				'MaxUpload';
	ikUSSEnabled =				'USSEnabled';
	ikOnlineSig =				'OnlineSignature';
	ikTCPPort =					'Port';
	ikResolveLinks =			'ResolveSharedShellLinks';

	ikLastCompressDate =		'lastCompressDate';
	ikCompressionThreshold =	'compressionThreshold';
	ikResampleThreshold =		'pointsPerPixel';
	ikShowTips =				'showTips';
	ikColor =					'color%d';
	ikDeltaLum =				'deltaLum';
	ikCopyFormat =				'copyFormat';

	{ private messages }
	uuid = 'dbed2574-6c42-4b54-8165-ddb3421b4d86';
	msgClose =			uuid + '_close';
	msgSuspend =		uuid + '_suspend';
	msgSuspended =		uuid + '_suspended';
	msgResume =			uuid + '_resume';
	msgResumed =		uuid + '_resumed';
	msgNewLogs =		uuid + '_newLogs';
	msgErrorsViewed =	uuid + '_errorsViewed';

	eMuleGuid =	'EMULE-{4EADC6FC-516F-4b7c-9066-97D893649570}';

var
	closeMsg,					{ sent to the viewer on exit }
	suspendMsg,					{ received from the viewer when it needs write access to the logs }
	suspendedMsg,				{ sent back to the viewer when the suspendMsg message has been received }
	resumeMsg,					{ received from the viewer when it no longer needs write access to the logs }
	resumedMsg,					{ sent back to the viewer when the resumeMsg message has been received }
	newLogsMsg,					{ sent by the viewer when new logs have been created and need to be updated }
	errorsViewedMsg: dWord;		{ sent by the viewer when the recorder's errors log has been viewed }
	{$IFNDEF viewer}
	taskBarCreatedMsg: dWord;	{ received from the system when the taskbar has been (re-)created -> (re-)load the tray icon }
	{$ENDIF}

const
	{ mutex names }
	mnRecorder =		uuid + '_recorder';
	mnViewer =			uuid + '_viewer';

var
//	eMulePath,
//	appPath: string;
	mutexPath: string;
	{ mutexPath = eMule config folder path, so:
	- two instances cannot run from inside the same emule folder
	- two instances using the same config (ie "Documents and settings\etc"...) files cannot run simultaneously }

type
	{ to avoid confusion... }
	tFileDate = integer;
	pFileDate = ^tFileDate;
	tEmuleRuntime = integer;

type
	tLogState = (
		lsNone,			{ No log for this known file }
		lsInactive,		{ inactive log (disLogExt extension) }
		lsActive,		{ active log (enLogExt extension) }
		lsPermanent		{ cannot be disabled nor deleted (permLogExt extension); used by default for the connRuntime log }
		);

	tLogWhat = (
		lwKnownFile,	{ log file name = <hash>.* }
		lwIniFile,		{ log file name = <iniFileName>-<sectionName>,<valueName>.* }
		lwQueuedClients,{ log file name = "Queued clients.*" }
		lwCombinedLogs	{ log file name = 'virtual,<log title>.* }
		);

	tLogTag = packed array[0..2] of char;

const
	{ log flags }
	lfCumulativeValue =		$01; {	if set, show the delta value / delta time rate; if not set, show the actual values }
	lfSavedOnChange =		$02; {	must be set for preferences.ini or any other ini file which is not saved on a regular basis;
									must not be set for statistics.ini or any other ini file which is saved on a regular basis.
									If not set, the graph will show extrapolated value between two modifications of the ini file;
									if set, the graph will show the same value between two consecutive modifications of the ini file.
									NOTE: I believe that the preferences.ini has been saved on a regular basis in old emule versions;
									maybe when the statistics were saved in preferences.ini (<0.43a)?
									In that case, this flag should not be set for preferences.ini }
	lfShowWithRequests =	$04; {	If not set, the graphic is displayed with the transfers chart;
									If set, the graphic is displayed with the requests chart; }
	{$IFNDEF viewer}
	lfEmptyLog =			$80; {	set by the constructor to identify any new empty log -> append a new value ASAP }
	{$ENDIF}

type
	{ type of data recorded in the log }
	tLogType = (
		ltNone,			{ -> an error occured while loading the log header }
		ltByte,
		ltWord,
		ltInteger,
		ltInt64,
		ltReal,
		ltKnownFile		{ two dWords for requests and accepted, one int64 for transferred }
		);

	tLogHeaderBase = packed record
		tag: tLogTag;	{ const logTag }
		version: byte;	{ const logVersion }
		what: byte;		{ type tLogWhat: 0 = known file; 1 = ini file }
		end;

	{ for ini file logs and Queued clients log }
	tLogHeaderXtra = packed record
		recType: byte;			{ type tLogType }
		flags: byte;			{ lfXXX constants }
		multiplier: double;		{ How to convert... }
		units: string[63];		{ ... to this units }
		end;

	tCombineOp = ( coAddition, coSubstract1, coSubstract2, coRatio1, coRatio2, coPercent1, coPercent2 );

	tCombinedLogsDataNames = array[0..1] of shortString;
	tCombinedLogsData = packed record
		operation: tCombineOp;
		logNames: tCombinedLogsDataNames;
		maxValue: double;
		end;

const
	logTag: tLogTag = 'EFS';
	logVersion = 0;

const
	iniLogFmt = '%s-%s,%s'; { log file name := format( iniLogFmt, [iniFileName, sectionName, valueName] ); }
	combinedLogFmt = 'virtual;%s';
	fnQueueLog = 'Queued clients';

type
	tLogFile = class;

	{ various types to access the log records, depending on the tLogHeaderBase.what and tLogHeaderXtra.recType values }
	tLogRec = packed record
		date: tFileDate;
		data: packed array[0..0] of byte;
		end;
	pLogRec = ^tLogRec;

	tLogRecByte = packed record
		date: tFileDate;
		data: shortInt;
		end;
	pLogRecByte = ^tLogRecByte;
	tLogDataByte = packed array[0..0] of tLogRecByte;
	pLogDataByte = ^tLogDataByte;

	tLogRecWord = packed record
		date: tFileDate;
		data: smallInt;
		end;
	pLogRecWord = ^tLogRecWord;
	tLogDataWord = packed array[0..0] of tLogRecWord;
	pLogDataWord = ^tLogDataWord;

	tLogRecInteger = packed record
		date: tFileDate;
		data: integer;
		end;
	pLogRecInteger = ^tLogRecInteger;
	tLogDataInteger = packed array[0..0] of tLogRecInteger;
	pLogDataInteger = ^tLogDataInteger;

	tLogRecInt64 = packed record
		date: tFileDate;
		data: int64;
		end;
	pLogRecInt64 = ^tLogRecInt64;
	tLogDataInt64 = packed array[0..0] of tLogRecInt64;
	pLogDataInt64 = ^tLogDataInt64;

	tLogRecReal = packed record
		date: tFileDate;
		data: double;
		end;
	pLogRecReal = ^tLogRecReal;
	tLogDataReal = packed array[0..0] of tLogRecReal;
	pLogDataReal = ^tLogDataReal;

	tLogRecKnownMetData = packed record
		requested,
		accepted: dWord;
		transferred: int64;
		end;
	tLogRecKnownMet = packed record
		date: tFileDate;
		data: tLogRecKnownMetData;
		end;
	pLogRecKnownMet = ^tLogRecKnownMet;
	tLogDataKnownMet = packed array[0..0] of tLogRecKnownMet;
	pLogDataKnownMet = ^tLogDataKnownMet;

	tCombinedLogs = array[0..1] of tLogFile;
	tCombinedLogNames = array[0..1] of string;

	tLogFile = class( tObject )
		protected
								fName: string;
								fState: tLogState;
								fWhat: tLogWhat;
								fDataType: tLogType;
								fFlags: byte;
								fMultiplier: double;
								fUnits: string;
			{$IFNDEF viewer}	fLastRec: pLogRec; {$ENDIF}
			{$IFDEF viewer}		fLogSize: integer; {$ENDIF}
			{$IFDEF viewer}		fLog: pointer; {$ENDIF}
			{$IFDEF viewer}		fColor: tColor; {$ENDIF}
			{$IFDEF viewer}		fLogs: tCombinedLogs; {$ENDIF}
			{$IFDEF viewer}		fLogNames: tCombinedLogNames; {$ENDIF}
			{$IFDEF viewer}		fOperation: tCombineOp; {$ENDIF}
			{$IFDEF viewer}		fMaxValue: double; {$ENDIF}
								function getExt: string;
								function getIniFile: string;
								function getIniSection: string;
								function getIniKey: string;
			{$IFDEF viewer}		function getLogLen: integer; {$ENDIF}
			{$IFDEF viewer}		function getIniCaption: string; {$ENDIF}
			{$IFDEF viewer}		procedure setName( const aName: string ); {$ENDIF}
		public
								constructor create( const aName: string ); { aName = log file name, without path and without extension; reads the log header }
								destructor destroy; override;
			{$IFNDEF viewer}	procedure append; {$ENDIF} { appends to the log the value previously stored in the lastRec property (if lastRec.date <> -1) }
			{$IFDEF viewer}		procedure load; {$ENDIF} { read the data array from the log file -> log and logSize properties }
			{$IFDEF viewer}		procedure unload; {$ENDIF}
			{$IFDEF viewer}		procedure save( data: pointer; dataSize: integer ); {$ENDIF} { data must point to the new data array, excluding the header(s) which are not modified }
			{$IFDEF viewer}		procedure setProperties( aFlags: byte; aMultiplier: double; const aUnits: string; aOperation: tCombineOp = coAddition; aMaxValue: double = nan ); {$ENDIF} { updates the log file header }
								property name: string read fName {$IFDEF viewer} write setName {$ENDIF}; { log file name, without path and without extension; reads the log header; Note: Read-only, except for combined logs }
								property ext: string read getExt; { returns extension based on log state }
								property state: tLogState read fState {$IFDEF viewer} write fState {$ENDIF}; { only changes the fState field. To actually update the file, use the tLogFiles.state[ index ] property (the tLogFile object could not handle the lsNone state...) }
								property what: tLogWhat read fWhat; { knownn file / ini file }
								property flags: byte read fFlags;
								property multiplier: double read fMultiplier;
								property units: string read fUnits;
								property dataType: tLogType read fDataType; { byte, word, etc... }
								property iniFile: string read getIniFile;       { ini file name, }
								property iniSection: string read getIniSection; { section name, }
								property iniKey: string read getIniKey;         { and value name }
			{$IFNDEF viewer}	property lastRec: pLogRec read fLastRec; {$ENDIF} { If lastRec.date <> -1, this date/value pair will be added to the log on the next append call }
			{$IFDEF viewer}		property logSize: integer read fLogSize; {$ENDIF} { size in bytes of the data array }
			{$IFDEF viewer}		property logLen: integer read getLogLen; {$ENDIF} { number of records in the data array }
			{$IFDEF viewer}		property log: pointer read fLog; {$ENDIF}		  { the data array }
			{$IFDEF viewer}		property color: tColor read fColor write fColor; {$ENDIF} { not used internally; used by the main unit to store the color of the graph when the log is selected }
			{$IFDEF viewer}		property iniCaption: string read getIniCaption; {$ENDIF} { short log name (iniKey, "Queued clients" or combined logs title) }
			{$IFDEF viewer}		property logs: tCombinedLogs read fLogs; {$ENDIF}
			{$IFDEF viewer}		property logNames: tCombinedLogNames read fLogNames; {$ENDIF}
			{$IFDEF viewer}		property operation: tCombineOp read fOperation; {$ENDIF}
			{$IFDEF viewer}		property maxValue: double read fMaxValue; {$ENDIF}
		end;

	tLogFiles = class( tStringList )
		protected
			{$IFNDEF viewer}	fKnownMetDate: tFileDate; {$ENDIF}
								fRuntimeLog: tLogFile;
								function getLog( index: integer ): tLogFile;
			{$IFDEF viewer}		function getLogFromName( const aName: string ): tLogFile; {$ENDIF}
			{$IFDEF viewer}		function getState( const name: string ): tLogState; {$ENDIF}
			{$IFDEF viewer}		procedure setState( const name: string; aState: tLogState ); {$ENDIF}
			{$IFDEF viewer}		function getRuntimeAt( date: tFileDate ): tEmuleRuntime; {$ENDIF}
			{$IFDEF viewer}		function getRealTimeAt( runtime: tEmuleRuntime ): tFileDate; {$ENDIF}
		public
								constructor create; { just creates an empty list }
								destructor destroy; override;
								procedure load; { initialize the list from all the log files found in the log dir (only reads log headers, does not load logs data); initializes the runtimeLog property (but does not load this log either) }
								procedure unload; { clears the list and resets the runtimeLog property }
			{$IFDEF viewer}
								{ Only creates the file, not the tLogFile object... }
								procedure createLogFile( const name: string; aState: tLogState;
									dataType: tLogType = ltInt64; flags: byte = 0; multiplier: double = 1; const units: string = '';
									operation: tCombineOp = coAddition; const log1: shortString = ''; const log2: shortString = ''; maxValue: double = nan );
			{$ENDIF}
								property log[ index: integer ]: tLogFile read getLog; { the log objects }
			{$IFDEF viewer}		property logFromName[ const aName: string ]: tLogFile read getLogFromName; {$ENDIF} { the log object for the specified file (no path nor extension) }
			{$IFNDEF viewer}	property knownMetDate: tFileDate read fKnownMetDate write fKnownMetDate; {$ENDIF}
			{$IFDEF viewer}		property state[ const name: string ]: tLogState read getState write setState; {$ENDIF} { when set, creates/deletes/renames the log file according to the specified state }
								property runtimeLog: tLogFile read fRuntimeLog; { the log object for the connRuntime log file; nil if the file does not exists }
								{ eMule runtime / real date-time conversion.
								The logs list and the runtimeLog must have been both loaded.
								The date must be between the first and the last dates recorded in the runtime log
								error = -1
								}
			{$IFDEF viewer}		property runtimeAt[ date: tFileDate ]: tEmuleRuntime read getRuntimeAt; {$ENDIF} { eMule runtime at the given date/time. The logs list and the runtimeLog must have been both loaded }
			{$IFDEF viewer}		property realTimeAt[ runtime: tEmuleRuntime ]: tFileDate read getRealTimeAt; {$ENDIF} { real date/time at the given eMule runtime. The logs list and the runtimeLog must have been both loaded }
			{$IFDEF viewer}		procedure setLogName( const oldName, newName: string ); {$ENDIF} { only for combined logs }
		end;

var
//	logsPath: string;
	logFiles: tLogFiles;

type
	tHashRec = packed record
		case integer of
			0:(
				bytes: packed array [0..15] of byte;
			);
			1:(
				lo, hi: int64;
			);
		end;

	tHash = class( tObject )
		protected
			fHash: tHashRec;
			function getHashStr: string;
		public
			constructor createStr( const aHash: string );
			constructor readFromStream( var f: tStream );
			{$IFDEF viewer}
			procedure writeToStream( var f: tStream );
			{$ENDIF}
			function compare( const aHash: tHashRec ): integer;
			function compareStr( const aHash: string ): integer;
			property hash: tHashRec read fHash write fHash;
			property hashStr: string read getHashStr;
		end;

{$IFNDEF viewer}
const
	debugLogMaxLines = 1000;

var
	errorsLogged: boolean = false; { set to true after an error has been logged -> show a red ! on the tray icon }
	onErrorLogged: procedure ( cmd: dWord ) of object;
{$ENDIF}

procedure errorMsg( const msg: string );

{$IFDEF viewer}
function unicodeFileToString( const path: string; var s: string ): boolean;
{$ENDIF}
function execCommand( const path, args: string; aShowWindow: integer ): tHandle;
procedure registerMessages;

{ from emule source code ;o) }
function adjustNTFSDaylightDateTime( var dt: tDateTime; const path: string ): boolean;
function adjustNTFSDaylightFileDate( var date: tFileDate; const path: string ): boolean;

function iniLogNameToCaption( const name: string ): string;

const
	_WINVER_NT4_	= $0004;
	_WINVER_95_		= $0004;
	_WINVER_98_		= $0A04;
	_WINVER_ME_		= $5A04;
	_WINVER_2K_		= $0005;
	_WINVER_XP_		= $0105;
	_WINVER_2003_	= $0205;
	_WINVER_VISTA_	= $0006;

type
	tOSVersionInfoEx = packed record
		dwOSVersionInfoSize: dWord;
		dwMajorVersion: dWord;
		dwMinorVersion: dWord;
		dwBuildNumber: dWord;
		dwPlatformId: dWord;
		szCSDVersion: array[0..127] of char;
		wServicePackMajor: word;
		wServicePackMinor: word;
		wSuiteMask: word;
		wProductType: byte;
		wReserved: byte;
		end;

function detectWinVersion: word; { Note: returns the same value for win95 and NT4 (_WINVER_NT4_ and _WINVER_95_ have the same value! }

var
	winVersion: word;

implementation

{$IFDEF viewer}
uses
	eventsLogEditUnit;
{$ENDIF}

procedure registerMessages;
begin
	closeMsg := registerWindowMessage( pChar( mutexPath + msgClose ) );
	suspendMsg := registerWindowMessage( pChar( mutexPath + msgSuspend ) );
	suspendedMsg := registerWindowMessage( pChar( mutexPath + msgSuspended ) );
	resumeMsg := registerWindowMessage( pChar( mutexPath + msgResume ) );
	resumedMsg := registerWindowMessage( pChar( mutexPath + msgResumed ) );
	newLogsMsg := registerWindowMessage( pChar( mutexPath + msgNewLogs ) );
	errorsViewedMsg := registerWindowMessage( pChar( mutexPath + msgErrorsViewed ) );
	{$IFNDEF viewer}
	taskBarCreatedMsg := registerWindowMessage( 'TaskbarCreated' );
	{$ENDIF}
end;

constructor tHash.createStr( const aHash: string );
var
	i: integer;
	k: char;
begin
	inherited create;
	if length( aHash ) <> 32 then raise eConvertError.create( errInvalidHash );
	for i := 15 downTo 0 do
		begin
		k := upCase( aHash[ 1 + i * 2 ] );
		if (k >= '0') and (k <= '9') then fHash.bytes[ i ] := ord( k ) - ord( '0' )
		else if (k >= 'A') and (k <= 'F') then fHash.bytes[ i ] := ord( k ) - ord( 'A' ) + $A
		else raise eConvertError.create( errInvalidHash );
		k := upCase( aHash[ 2 + i * 2 ] );
		if (k >= '0') and (k <= '9') then fHash.bytes[ i ] := fHash.bytes[ i ] shL 4 + ord( k ) - ord( '0' )
		else if (k >= 'A') and (k <= 'F') then fHash.bytes[ i ] := fHash.bytes[ i ] shL 4 + ord( k ) - ord( 'A' ) + $A
		else raise eConvertError.create( errInvalidHash );
		end;
end;

constructor tHash.readFromStream( var f: tStream );
begin
	inherited create;
	f.read( fHash, sizeOf( fHash ) );
end;

{$IFDEF viewer}
procedure tHash.writeToStream( var f: tStream );
begin
	f.write( fHash, sizeOf( fHash ) );
end;
{$ENDIF}

function tHash.compare( const aHash: tHashRec ): integer;
begin
	if fHash.hi < aHash.hi then result := -1
	else if fHash.hi > aHash.hi then result := 1
	else if fHash.lo < aHash.lo then result := -1
	else if fHash.lo > aHash.lo then result := 1
	else result := 0;
end;

function tHash.compareStr( const aHash: string ): integer;
var
	h: tHash;
begin
	h := tHash.createStr( aHash );
	result := compare( h.fHash );
	h.free;
end;

function tHash.getHashStr: string;
var
	i: integer;
begin
	result := '';
	for i := 0 to pred( sizeOf( fHash ) ) do
		result := result + intToHex( fHash.bytes[ i ], 2 );
end;

{ 12 may 07: 0.48a support (new folders) >>> }
(* old code:
{ searches for a folder containing a config\known.met and a config\preferences.ini files in the EFS folder or any of its parent folders }
function getEmuleFolder: string;
var
	path: string;

	function testIt: boolean;
	begin
		result := (path <> '') and fileExists( path + dnEmuleConfig + fnKnownMet ) and fileExists( path + dnEmuleConfig + fnPreferencesIni );
	end;

begin
	path := pnEFSExe;
//	path := extractFilePath( application.exeName );
	while not testIt and not sameText( includeTrailingPathDelimiter( extractFileDrive( path ) ), path ) do
		path := extractFilePath( excludeTrailingPathDelimiter( path ) );

	if not testIt then result := ''
	else result := path;
end;
*){ <<< 12 may 07: 0.48a support (new folders) }

{ returns the expected value for the what property }
function whatFromName( const name: string ): tLogWhat;
begin
	if sameText( name, fnQueueLog ) then result := lwQueuedClients
	else if ansiStartsText( format( combinedLogFmt, [''] ), name ) then result := lwCombinedLogs
	else if pos( '.', name ) > 0 then result := lwIniFile
	else result := lwKnownFile;
end;

constructor tLogFile.create( const aName: string );
var
	f: tFileStream;
	h: tLogHeaderBase;
	hx: tLogHeaderXtra;
	l: integer;
	{$IFDEF viewer}
	i: integer;
	cld: tCombinedLogsData;
	{$ENDIF}
begin
	inherited create;
	{$IFDEF viewer}
	fLogSize := -1;
	fLog := nil;
	{$ENDIF}
	fName := aName;

	{$IFDEF viewer}
	for i := 0 to 1 do if fLogs[ i ] <> nil then fLogs[ i ] := nil;
	{$ENDIF}

	if fileExists( pnEFSLogs + fName + permLogExt ) then fState := lsPermanent
	else if fileExists( pnEFSLogs + fName + enLogExt ) then fState := lsActive
	else if fileExists( pnEFSLogs + fName + disLogExt ) then fState := lsInactive
	else fState := lsNone;
(*	if fileExists( logsPath + fName + permLogExt ) then fState := lsPermanent
	else if fileExists( logsPath + fName + enLogExt ) then fState := lsActive
	else if fileExists( logsPath + fName + disLogExt ) then fState := lsInactive
	else fState := lsNone;
*)
	fWhat := whatFromName( fName );
	fDataType := ltNone;

	if (fState <> lsNone) {$IFNDEF viewer} and (fWhat <> lwCombinedLogs) {$ENDIF} then
		begin
		try
			f := tFileStream.create( pnEFSLogs + fName + ext, fmOpenRead or fmShareDenyWrite );
//			f := tFileStream.create( logsPath + fName + ext, fmOpenRead or fmShareDenyWrite );
			try
				f.read( h, sizeOf( h ) );
				if (h.tag = logTag) and (h.version <= logVersion) and (tLogWhat( h.what ) = fWhat) then
					begin
					case tLogWhat( h.what ) of
						lwIniFile,
						lwQueuedClients,
						lwCombinedLogs:
							begin
							f.read( hx, sizeOf( hx ) );
							fDataType := tLogType( hx.recType );
							fFlags := hx.flags;
							fMultiplier := hx.multiplier;
							fUnits := trim( hx.units );
							end;
						else
							fDataType := ltKnownFile;
						end;
					{$IFDEF viewer}
					if fWhat = lwCombinedLogs then
						begin
						l := f.size - f.position;
						f.read( cld, l );
						fOperation := cld.operation;
						for i := 0 to 1 do fLogNames[ i ] := cld.logNames[ i ]; 
						if l < sizeOf( cld ) then fMaxValue := nan { for logs from v1.1, with maxValue setting }
						else fMaxValue := cld.maxValue;
						end;
					{$ENDIF}
					{$IFNDEF viewer}
					case fDataType of
						ltByte:		l := sizeOf( tLogRecByte );
						ltWord:		l := sizeOf( tLogRecWord );
						ltInteger:	l := sizeOf( tLogRecInteger );
						ltInt64:	l := sizeOf( tLogRecInt64 );
						ltReal:		l := sizeOf( tLogRecReal );
						else		l := sizeOf( tLogRecKnownMet );
						end;
					getMem( fLastRec, l );
					if f.position < f.size then
						begin
						f.seek( -l, soFromEnd );
						f.read( fLastRec^, l );
						end
					else
						begin
						fLastRec.date := -1;
						fFlags := fFlags or lfEmptyLog;
						end;
					{$ENDIF}
					end
				else
					errorMsg( format( errInvalidLogFile, [fName + ext] ) );
				finally f.free;
				end;
			except on e: exception do
				errorMsg( format( errCreateLogObject, [fName, e.message] ) );
			end;
		end;
end;

destructor tLogFile.destroy;
begin
	{$IFNDEF viewer}
	if fLastRec <> nil then freeMem( fLastRec );
	{$ENDIF}
	{$IFDEF viewer}
	unload;
	{$ENDIF}
	inherited destroy;
end;

{$IFNDEF viewer}
procedure tLogFile.append;
var
	f: tFileStream;
	h: tLogHeaderBase;
	l: integer;
begin
	if (fLastRec <> nil) and (fLastRec.date <> -1) then
		begin
		try
			f := tFileStream.create( pnEFSLogs + fName + ext, fmOpenReadWrite or fmShareDenyWrite );
//			f := tFileStream.create( logsPath + fName + ext, fmOpenReadWrite or fmShareDenyWrite );
			try
				f.read( h, sizeOf( h ) );
				if (h.tag = logTag) and (h.version <= logVersion) and (tLogWhat( h.what ) = fWhat) then
					begin
					f.seek( 0, soFromEnd );
					case fDataType of
						ltByte:		l := sizeOf( tLogRecByte );
						ltWord:		l := sizeOf( tLogRecWord );
						ltInteger:	l := sizeOf( tLogRecInteger );
						ltInt64:	l := sizeOf( tLogRecInt64 );
						ltReal:		l := sizeOf( tLogRecReal );
						else		l := sizeOf( tLogRecKnownMet );
						end;
					if fFlags and lfSavedOnChange <> 0 then
						{ to avoid exptrapolated graph points, we need to record points with the current date/time rather than with the preferences.ini modification date }
						fLastRec^.date := logFiles.fKnownMetDate;
					f.write( fLastRec^, l );
					end
				else
					errorMsg( format( errInvalidLogFile, [fName + ext] ) );
				finally f.free;
				end;
			except on e: exception do
				errorMsg( format( errAppendLog, [fName, e.message] ) );
			end;
		end;
end;
{$ENDIF}

{$IFDEF viewer}
function tLogFile.getLogLen: integer;
begin
	if fLogSize <= 0 then
		result := 0
	else
		case fDataType of
			ltNone:		result := 0;
			ltByte:		result := fLogSize div sizeOf( tLogRecByte );
			ltWord:		result := fLogSize div sizeOf( tLogRecWord );
			ltInteger:	result := fLogSize div sizeOf( tLogRecInteger );
			ltInt64:	result := fLogSize div sizeOf( tLogRecInt64 );
			ltReal:		result := fLogSize div sizeOf( tLogRecReal );
			else		result := fLogSize div sizeOf( tLogRecKnownMet );
			end;
end;
{$ENDIF}

{$IFDEF viewer}
function tLogFile.getIniCaption: string;
begin
	case what of
		lwQueuedClients:	result := fnQueueLog;
		lwCombinedLogs:		result := copy( name, succ( length( format( combinedLogFmt, [''] ) ) ), maxInt );
		else				result := iniKey;
		end;
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFile.load;
var
	f: tFileStream;
	h: tLogHeaderBase;
	i, j: integer;
	logData: pLogDataInteger;
	logCount: integer;
	dw: dWord;
begin
	unload;
	try
		f := tFileStream.create( pnEFSLogs + fName + ext, fmOpenRead or fmShareDenyWrite );
//		f := tFileStream.create( logsPath + fName + ext, fmOpenRead or fmShareDenyWrite );
		try
			f.read( h, sizeOf( h ) );
			if (h.tag = logTag) and (h.version <= logVersion) and (tLogWhat( h.what ) = fWhat) then
				begin
				if fWhat in [lwIniFile, lwQueuedClients, lwCombinedLogs] then f.seek( sizeOf( tLogHeaderXtra ), soFromCurrent );
				if fWhat = lwCombinedLogs then
					begin
					for i := 0 to 1 do
						begin
						fLogs[ i ] := tLogFile.create( logNames[ i ] );
						fLogs[ i ].load;
						end;
					end
				else
					begin
					fLogSize := f.size - f.position;
					if fLogSize > 0 then
						begin
						getMem( fLog, fLogSize );
						try
							f.read( fLog^, fLogSize );
							except
								unload;
								errorMsg( format( errInvalidLogFile, [fName + ext] ) );
							end;
						end;
					end;
				end
			else
				errorMsg( format( errInvalidLogFile, [fName + ext] ) );
			finally f.free;
			end;
		except on e: exception do
			errorMsg( format( errLoadLog, [fName, e.message] ) );
		end;
	{ 29 apr 07: bug fix: Support for ConnRunTime reset >>> }
	if self = logFiles.runtimeLog then
		begin
		logData := pLogDataInteger( log );
		logCount := logLen;
		for i := pred( logCount ) downTo 1 do
			begin
			if (logData^[ pred( i ) ].data > logData^[ i ].data) then
				begin
				for j := i to pred( logCount ) do { update the end of the log }
					logData^[ j ].data := logData^[ j ].data + logData^[ pred( i ) ].data;
				{ suspend the log recorder before saving the log }
				dw := bsm_applications;
				broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, suspendMsg, 1, 0 );
				break;
				end;
			end;
		end;
	{ <<< 29 apr 07: bug fix: Support for ConnRunTime reset }
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFile.unload;
var
	i: integer;
begin
	for i := 0 to 1 do if fLogs[ i ] <> nil then freeAndNil( fLogs[ i ] );
	if fLog <> nil then
		begin
		freeMem( fLog );
		fLog := nil;
		end;
	fLogSize := -1;
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFile.save( data: pointer; dataSize: integer );
var
	f: tFileStream;
	h: tLogHeaderBase;
begin
	try
		f := tFileStream.create( pnEFSLogs + fName + ext, fmOpenReadWrite or fmShareDenyWrite );
//		f := tFileStream.create( logsPath + fName + ext, fmOpenReadWrite or fmShareDenyWrite );
		try
			f.read( h, sizeOf( h ) );
			if (h.tag = logTag) and (h.version <= logVersion) and (tLogWhat( h.what ) = fWhat) then
				begin
				if fWhat in [lwIniFile, lwQueuedClients] then f.seek( sizeOf( tLogHeaderXtra ), soFromCurrent );
				f.write( data^, dataSize );
				f.size := f.position;
				end
			else
				errorMsg( format( errInvalidLogFile, [fName + ext] ) );
			finally f.free;
			end;
		except on e: exception do
			errorMsg( format( errSaveLog, [fName, e.message] ) );
		end;
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFile.setName( const aName: string );
begin
	if (what <> lwCombinedLogs) or (aName = fName) then exit;
	renameFile( pnEFSLogs + fName + ext, pnEFSLogs + aName + ext );
//	renameFile( logsPath + fName + ext, logsPath + aName + ext );
	fName := aName;
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFile.setProperties( aFlags: byte; aMultiplier: double; const aUnits: string; aOperation: tCombineOp = coAddition; aMaxValue: double = nan );
var
	f: tFileStream;
	h: tLogHeaderBase;
	hx: tLogHeaderXtra;
begin
	if fWhat in [lwIniFile, lwQueuedClients, lwCombinedLogs] then
		begin
		try
			f := tFileStream.create( pnEFSLogs + fName + ext, fmOpenReadWrite or fmShareDenyWrite );
//			f := tFileStream.create( logsPath + fName + ext, fmOpenReadWrite or fmShareDenyWrite );
			try
				f.read( h, sizeOf( h ) );
				if (h.tag = logTag) and (h.version <= logVersion) and (tLogWhat( h.what ) = fWhat) then
					begin
					f.read( hx, sizeOf( hx ) );
					f.seek( -sizeOf( hx ), soFromCurrent );
					fFlags := aFlags;
					hx.flags := aFlags;
					fMultiplier := aMultiplier;
					hx.multiplier := aMultiplier;
					fUnits := aUnits;
					hx.units := aUnits;
					if length( hx.units ) = high( hx.units ) then hx.units[ high( hx.units ) ] := #0
					else hx.units := hx.units + #0;
					f.write( hx, sizeOf( hx ) );

					if fWhat = lwCombinedLogs then
						begin
						fOperation := aOperation;
						f.write( aOperation, sizeOf( aOperation ) );
						fMaxValue := aMaxValue;
						f.seek( sizeOf( tCombinedLogsDataNames ), soFromCurrent );
						f.write( aMaxValue, sizeOf( aMaxValue ) );
						end;

					end
				else
					errorMsg( format( errInvalidLogFile, [fName + ext] ) );
				finally f.free;
				end;
			except on e: exception do
				errorMsg( format( errSaveLog, [fName, e.message] ) );
			end;
		end;
end;
{$ENDIF}

function tLogFile.getExt: string;
begin
	case fState of
		lsInactive:	result := disLogExt;
		lsActive:	result := enLogExt;
		else		result := permLogExt;
		end;
end;

function tLogFile.getIniFile: string;
begin
	if fWhat = lwIniFile then result := copy( fName, 1, pred( pos( '-', fName ) ) )
	else result := '';
end;

function tLogFile.getIniSection: string;
var
	p1: integer;
begin
	if fWhat = lwIniFile then
		begin
		p1 := succ( pos( '-', fName ) );
		result := copy( fName, p1, pos( ',', fName ) - p1 );
		end
	else
		result := '';
end;

function tLogFile.getIniKey: string;
begin
	if fWhat = lwIniFile then result := copy( fName, succ( pos( ',', fName ) ), maxInt )
	else result := '';
end;

function iniLogNameToCaption( const name: string ): string;
var
	lw: tLogWhat;
begin
	lw := whatFromName( name );
	case lw of
		lwIniFile:			result := copy( name, succ( pos( ',', name ) ), maxInt );
		lwQueuedClients:	result := fnQueueLog;
		lwCombinedLogs:		result := copy( name, succ( length( format( combinedLogFmt, [''] ) ) ), maxInt );
		else result := '';
		end;
end;

constructor tLogFiles.create;
begin
	inherited create;
	sorted := true;
	caseSensitive := false;
	duplicates := dupIgnore;
end;

destructor tLogFiles.destroy;
begin
	unload;
	inherited destroy;
end;

function tLogFiles.getLog( index: integer ): tLogFile;
begin
	result := tLogFile( objects[ index ] );
end;

{$IFDEF viewer}
function tLogFiles.getLogFromName( const aName: string ): tLogFile;
var
	p: integer;
begin
	if find( aName, p ) then
		result := tLogFile( objects[ p ] )
	else
		result := nil;
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFiles.setLogName( const oldName, newName: string );
var
	p: integer;
	lf: tLogFile;
begin
	if find( oldName, p ) then
		lf := tLogFile( objects[ p ] )
	else
		lf := nil;
	if (lf <> nil) and (lf.what = lwCombinedLogs) then
		begin
		sorted := false;
		strings[ p ] := newName;
		lf.name := newName;
		sorted := true;
		end;
end;
{$ENDIF}

procedure tLogFiles.load;
var
	sr: tSearchRec;
	err: integer;
	name, ext: string;
	lf: tLogFile;
	p: integer;
begin
	unload;
	{$IFNDEF viewer}
	fKnownMetDate := -1;
	{$ENDIF}
	err := findFirst( pnEFSLogs + '*.*', faArchive, sr );
//	err := findFirst( logsPath + '*.*', faArchive, sr );
	try
		while err = 0 do
			begin
			ext := lowerCase( extractFileExt( sr.name ) );
			if (ext = enLogExt) or (ext = permLogExt) {$IFDEF viewer} or (ext = disLogExt) {$ENDIF} then
				begin
				name := copy( sr.name, 1, length( sr.name ) - length( ext ) );
				lf := tLogFile.create( name );
				if (lf.dataType > ltNone) {$IFNDEF viewer} and (lf.what <> lwCombinedLogs) {$ENDIF} then
					begin
					if find( name, p ) then
						begin
						if sameText( ext, log[ p ].ext ) then
							begin
							errorMsg( format( errDuplicateLogs, [name, lf.ext] ) );
							objects[ p ].free;
							delete( p );
							end
						else
							begin
							errorMsg( format( errDuplicateLogs, [name, log[ p ].ext] ) );
							freeAndNil( lf );
							end;
						end;
					if lf <> nil then
						begin
						addObject( name, lf );
						if sameText( lf.iniFile, fnStatisticsIni ) and sameText( lf.iniSection, isStatistics ) and sameText( lf.iniKey, ikRuntime )
						and ((lf.state = lsPermanent) or (fRuntimeLog = nil)) then
							fRuntimeLog := lf;
						{$IFNDEF viewer}
						if (lf.what = lwKnownFile) and (lf.lastRec <> nil) and (lf.lastRec.date > fKnownMetDate) then
							fKnownMetDate := lf.lastRec.date;
						{$ENDIF}
						end;
					end
				else
					lf.free;
				end;
			err := findNext( sr );
			end;
		finally findClose( sr );
		end;
end;

procedure tLogFiles.unload;
var
	i: integer;
begin
	fRuntimeLog := nil;
	for i := 0 to pred( count ) do if objects[ i ] <> nil then objects[ i ].free;
	clear;
end;

{$IFDEF viewer}
procedure tLogFiles.createLogFile( const name: string; aState: tLogState;
	dataType: tLogType = ltInt64; flags: byte = 0; multiplier: double = 1; const units: string = '';
	operation: tCombineOp = coAddition; const log1: shortString = ''; const log2: shortString = ''; maxValue: double = nan );
var
	f: tFileStream;
	lh: tLogHeaderBase;
	lhx: tLogHeaderXtra;
	cld: tCombinedLogsData;
	path: string;
begin
	case aState of
		lsInactive:		path := pnEFSLogs + name + disLogExt;
		lsActive:		path := pnEFSLogs + name + enLogExt;
		lsPermanent:	path := pnEFSLogs + name + permLogExt;
		else			exit;
		end;
(*	case aState of
		lsInactive:		path := logsPath + name + disLogExt;
		lsActive:		path := logsPath + name + enLogExt;
		lsPermanent:	path := logsPath + name + permLogExt;
		else			exit;
		end;
*)	try
		f := tFileStream.create( path, fmCreate );
		try
			lh.tag := logTag;
			lh.version := logVersion;
			lh.what := ord( whatFromName( name ) );
			f.write( lh, sizeOf( lh ) );
			if tLogWhat( lh.what ) in [lwIniFile, lwQueuedClients, lwCombinedLogs] then
				begin
				lhx.recType := ord( dataType );
				lhx.flags := flags;
				lhx.multiplier := multiplier;
				lhx.units := units;
				if length( lhx.units ) = high( lhx.units ) then lhx.units[ high( lhx.units ) ] := #0
				else lhx.units := lhx.units + #0;
				f.write( lhx, sizeOf( lhx ) );
				end;
			if tLogWhat( lh.what ) = lwCombinedLogs then
				begin
				cld.operation := operation;
				cld.logNames[ 0 ] := log1;
				cld.logNames[ 1 ] := log2;
				cld.maxValue := maxValue;
				f.write( cld, sizeOf( cld ) );
				end;
			finally
				f.free;
			end;
		except on e: exception do
			errorMsg( format( errCreateLog, [name, e.message] ) );
		end;
end;
{$ENDIF}

{$IFDEF viewer}
function tLogFiles.getState( const name: string ): tLogState;
var
	p: integer;
begin
	if find( name, p ) then
		result := log[ p ].state
	else
		result := lsNone;
end;
{$ENDIF}

{$IFDEF viewer}
procedure tLogFiles.setState( const name: string; aState: tLogState );
var
	p: integer;
	lf: tLogFile;
begin
	if find( name, p ) then
		begin
		if not (log[ p ].state in [lsPermanent, aState]) then
			begin
			case aState of
				lsNone:
					begin
					deleteFile( pnEFSLogs + name + enLogExt );
					deleteFile( pnEFSLogs + name + disLogExt );
(*					deleteFile( logsPath + name + enLogExt );
					deleteFile( logsPath + name + disLogExt );
*)					if log[ p ].what = lwKnownFile then
						removeFileEvents( log[ p ].name ); { remove from "events.log" any event associated to this file }
					if objects[ p ] <> nil then objects[ p ].free;
					delete( p );
					exit;
					end;
				lsInactive:
					begin
					{ if both enabled and disabled files exists, enabled is used by default,
					so a disabled file may already exist here }
					deleteFile( pnEFSLogs + name + disLogExt );
					renameFile( pnEFSLogs + name + enLogExt, pnEFSLogs + name + disLogExt );
(*					deleteFile( logsPath + name + disLogExt );
					renameFile( logsPath + name + enLogExt, logsPath + name + disLogExt );
*)					end;
				lsActive:
					{ the enabled file cannot already exist here, otherwise the log state would already be enabled }
					renameFile( pnEFSLogs + name + disLogExt, pnEFSLogs + name + enLogExt );
//					renameFile( logsPath + name + disLogExt, logsPath + name + enLogExt );
				end;
			log[ p ].state := aState;
			end;
		end
	else
		begin
		lf := tLogFile.create( name );
		if lf.dataType > ltNone then
			begin
			addObject( name, lf );
			if lf.state <> aState then setState( name, aState );
			end
		else
			lf.free;
		end;
end;
{$ENDIF}

{$IFDEF viewer}
function tLogFiles.getRuntimeAt( date: tFileDate ): tEmuleRuntime;
var
	data: pLogDataInteger;
	len: integer;
	p: integer;
	dt1, dt2, dt3: tDateTime;

	function find( var index: integer): boolean;
	var
		l, h, i, c: integer;
	begin
		result := false;
		l := 0;
		h := pred( len );
		while l <= h do
			begin
			i := (l + h) shr 1;
			{$R-}
			c := data^[ i ].date - date;
			{$IFDEF debug} {$R+} {$ENDIF}
			if c < 0 then
				l := succ( i )
			else
				begin
				h := pred( i );
				if c = 0 then
					begin
					result := true;
					l := i;
					end;
				end;
			end;
		index := l;
	end;

begin
	if (fRuntimeLog = nil) or (fRuntimeLog.logSize <= 0) then
		result := -1
	else
		begin
		data := pLogDataInteger( fRuntimeLog.log );
		len := fRuntimeLog.logLen;
		{$R-}
		if find( p ) then
			result := data^[ p ].data
		else
			begin
			if p <= 0 then
				result := data^[ 0 ].data
			else if p >= pred( len ) then
				result := data^[ pred( len ) ].data
			else
				begin
				dt1 := fileDateToDateTime( data^[ pred( p ) ].date );
				dt2 := fileDateToDateTime( date );
				dt3 := fileDateToDateTime( data^[ p ].date );
				result := round( data^[ pred( p ) ].data + (data^[ p ].data - data^[ pred( p ) ].data) * secondsBetween( dt2, dt1 ) / secondsBetween( dt3, dt1 ) );
				end;
			end;
		{$IFDEF debug} {$R+} {$ENDIF}
		end;
end;
{$ENDIF}

{$IFDEF viewer}
function tLogFiles.getRealTimeAt( runtime: tEmuleRuntime ): tFileDate;
var
	data: pLogDataInteger;
	len: integer;
	p: integer;

	function find( var index: integer): boolean;
	var
		l, h, i, c: integer;
	begin
		result := false;
		l := 0;
		h := pred( len );
		while l <= h do
			begin
			i := (l + h) shr 1;
			{$R-}
			c := data^[ i ].data - runtime;
			{$IFDEF debug} {$R+} {$ENDIF}
			if c < 0 then
				l := succ( i )
			else
				begin
				h := pred( i );
				if c = 0 then
					begin
					result := true;
					l := i;
					end;
				end;
			end;
		index := l;
	end;

begin
	if (fRuntimeLog = nil) or (fRuntimeLog.logSize <= 0) then
		result := -1
	else
		begin
		data := pLogDataInteger( fRuntimeLog.log );
		len := fRuntimeLog.logLen;
		find( p );
		if p >= len then p := pred( len );
		{$R-}
		result := data^[ p ].date;
		{$IFDEF debug} {$R+} {$ENDIF}
		end;
end;
{$ENDIF}

{$IFDEF viewer}
function unicodeFileToString( const path: string; var s: string ): boolean;
var
	f: tFileStream;
	ws: pWideChar;
	l: int64;
	bhfi: by_handle_file_information;
	ft: tFileTime;
begin
	result := false;
	s := '';
	if fileExists( path ) then
		begin
		try
			f := tFileStream.create( path, fmOpenRead or fmShareDenyNone ); { don't deny write access to emule -> verify that the file's lastWriteTime has not changed while reading }
			try
				getFileInformationByHandle( f.handle, bhfi );
				ft := bhfi.ftLastWriteTime;
				l := f.size;
				getMem( ws, l + 2 );
				try
					{ 07 may 07: Optimizations >>> }
					ws[ l div 2 ] := #0;
{ old code:
					fillChar( ws^, l + 2, 0 );
}					{ <<< 07 may 07: Optimizations }
					f.read( ws^, l );
					getFileInformationByHandle( f.handle, bhfi );
					if int64( ft ) <> int64( bhfi.ftLastWriteTime ) then
						{ if the file has been modified, assume that the read content is erroneous }
						raise exception.createFmt( rsModifiedWhileReadingError, [path] );
					if (pWord( ws )^ = $FEFF) then s := copy( wideCharToString( ws ), 2, maxInt )
					else s := pChar( ws );
					result := true;
					finally freeMem( ws );
					end;
				finally f.free;
				end;
			except ;
			end;
		end;
end;
{$ENDIF}

function execCommand( const path, args: string; aShowWindow: integer ): tHandle;
var
	si: tStartUpInfo;
	pi: tProcessInformation;
	sz1, sz2: array[0..767] of char;
begin
	strCat( strCat( strPCopy( sz1, path ), ' ' ), strPCopy( sz2, args ) );
	with si do
		begin
		cb := sizeOf( si );
		lpReserved := nil;
		lpDesktop := nil;
		lpTitle := nil;
		dwX := 0;
		dwY := 0;
		dwXSize := 0;
		dwYSize := 0;
		dwXCountChars := 0;
		dwYCountChars := 0;
		dwFillAttribute := 0;
		dwFlags := startf_useShowWindow;
		wShowWindow := aShowWindow;
		cbReserved2 := 0;
		lpReserved2 := nil;
		hStdInput := 0;
		hStdOutput := 0;
		hStdError := 0;
		end;
	if createProcess( nil, sz1, nil, nil, false, normal_Priority_Class, nil, nil, si, pi ) then result := pi.hProcess
	else result := 0;
end;

function isNTFSVolume( const volume: string ): boolean;
var
	maxCompLen: dWord;
	flags: dWord;
	fsName: array[0..127] of char;
begin
	setErrorMode( sem_failCriticalErrors ); { just in case... }
	try
		if getVolumeInformation( pChar( volume ), nil, 0, nil, maxCompLen, flags, pChar( @fsName ), sizeOf( fsName ) ) then
			result := (strIComp( fsName, 'NTFS' ) = 0)
		else
			result := false
		finally setErrorMode( 0 );
		end;
end;

function isFileOnNTFSVolume( const path: string ): boolean;
begin
	result := isNTFSVolume( includeTrailingPathDelimiter( extractFileDrive( path ) ) );
end;

function isDaylightSavingTimeActive( var daylightBias: integer ): boolean;
var
	tzi: time_zone_information;
begin
	if getTimeZoneInformation( tzi ) <> time_zone_id_daylight then
		result := false
	else
		begin
		daylightBias := tzi.daylightBias;
		result := true;
		end;
end;

function isAutoDaylightTimeSetActive: boolean;
var
	r: tRegistry;
begin
	result := true;
	r := tRegistry.create;
	try
		r.rootKey := HKEY_LOCAL_MACHINE;
		if r.openKey( 'SYSTEM\CurrentControlSet\Control\TimeZoneInformation', false ) then
			begin
			if r.valueExists( 'disableAutoDaylightTimeSet' ) then
				if r.readInteger( 'disableAutoDaylightTimeSet' ) <> 0 then
					result := false;
			r.closeKey;
			end;
		finally r.free;
		end;
end;

function adjustNTFSDaylightDateTime( var dt: tDateTime; const path: string ): boolean;
var
	daylightBias: integer;
begin
	if isDaylightSavingTimeActive( daylightBias ) and isAutoDaylightTimeSetActive and isFileOnNTFSVolume( path ) then
		begin
		dt := incMinute( dt, daylightBias );
		result := true;
		end
	else
		result := false;
end;

function adjustNTFSDaylightFileDate( var date: tFileDate; const path: string ): boolean;
var
	dt: tDateTime;
begin
	if date <> -1 then
		begin
		dt := fileDateToDateTime( date );
		result := adjustNTFSDaylightDateTime( dt, path );
		date := dateTimeToFileDate( dt );
		end
	else
		result := false;
end;

procedure errorMsg( const msg: string );
{$IFDEF viewer}
begin
	application.messageBox( pChar( msg ), pChar( appFullName ), mb_ok or mb_iconError ); 
end;
{$ELSE}
var
	sl: tStringList;
	fs: tFormatSettings;
begin
	sl := tStringList.create;
	try
		sl.sorted := false;
		sl.caseSensitive := false;
		if fileExists( pnEFSConfig + fnRecErrorsLog ) then sl.loadFromFile( pnEFSConfig + fnRecErrorsLog );
//		if fileExists( appPath + fnRecErrorsLog ) then sl.loadFromFile( appPath + fnRecErrorsLog );
		while sl.count >= debugLogMaxLines do sl.delete( 0 );
		getLocaleFormatSettings( $409, fs );
		sl.add( dateTimeToStr( now, fs ) + '|' + msg );
		sl.saveToFile( pnEFSConfig + fnRecErrorsLog );
//		sl.saveToFile( appPath + fnRecErrorsLog );
		finally sl.free;
		end;
	if not errorsLogged then
		begin
		errorsLogged := true;
		onErrorLogged( nim_modify );
		end;
end;
{$ENDIF}

{ 12 may 07: 0.48a support (new folders) >>> }
function detectWinVersion: word; { Note: returns the same value for win95 and NT4 (_WINVER_NT4_ and _WINVER_95_ have the same value! }
var
	osvi: tOSVersionInfoEx;
begin
	result := _WINVER_95_; { there should'nt be anything lower than this }

	zeroMemory( @osvi, sizeOf( osvi ) );
	osvi.dwOSVersionInfoSize := sizeOf( osvi );
	if not getVersionEx( pOSVersionInfo( @osvi )^ ) then
		begin
		osvi.dwOSVersionInfoSize := sizeOf( tOSVersionInfo );
		if not getVersionEx( pOSVersionInfo( @osvi )^ ) then
			begin
			result := 0;
			exit;
			end;
		end;

	case osvi.dwPlatformId of
		VER_PLATFORM_WIN32_NT:
			begin
			if osvi.dwMajorVersion <= 4 then
				result := _WINVER_NT4_
			else if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
				result := _WINVER_2K_
			else if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then
				result := _WINVER_XP_
			else if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
				result := _WINVER_2003_
			else if (osvi.dwMajorVersion = 6) and (osvi.dwMinorVersion = 0) then
				result := _WINVER_VISTA_
			else
				result := _WINVER_VISTA_; { never return Win95 if we get the info about a NT system }
			end;
		VER_PLATFORM_WIN32_WINDOWS:
			begin
			if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 0) then
				result := _WINVER_95_
			else if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 10) then
				result := _WINVER_98_
			else if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 90) then
				result := _WINVER_ME_;
			end;
		end;
end;

const
	FOLDERID_ProgramData: tGuid = '{62AB5D82-FDC1-4DC3-A9DD-070D1D495D97}';
	FOLDERID_LocalAppData: tGuid = '{F1B32785-6FBA-4FCF-9D55-7B8E7F157091}';
	FOLDERID_Downloads: tGuid = '{374DE290-123F-4565-9164-39C4925E467B}';
	FOLDERID_PublicDownloads: tGuid = '{3D644C9B-1FB8-4f30-9B45-F670235F79C0}';

	SHGFP_TYPE_CURRENT = 0;

type
	tSHGetKnownFolderPath = function( const rfId: tGuid; dwFlags: dWord; hToken: tHandle; out ppszPath: pWideChar ) : hResult; stdcall;

(*function shGetKnownFolderPath( const rfid: tGuid; dwFlags: dWord; hToken: tHandle; out ppszPath: pWideChar ): hResult;
var
	shell: hModule;
	fn: tShGetKnownFolderPath;
begin
	shell := loadLibrary( 'shell32.dll' );
	win32Check( shell <> 0 );
	try
		@fn := getProcAddress( shell, 'SHGetKnownFolderPath' );
		win32Check( assigned( fn ) );
		result := fn( rfid, dwFlags, hToken, ppszPath );
		finally freeLibrary( shell );
		end;
end;

function getKnownFolderPath( const rfid: tGuid; dwFlags: dWord; hToken: tHandle ): wideString;
var
	buffer: pWideChar;
	ret: hResult;
begin
	ret := shGetKnownFolderPath( rfid, dwFlags, hToken, buffer );
	oleCheck( ret );
	try
		result := buffer;
		finally coTaskMemFree( buffer );
		end;
end;
*)
procedure getFolders;
var
	strSelectedDataBaseDirectory,
	strSelectedConfigBaseDirectory,
	strSelectedExpansionBaseDirectory,
	strEFSConfigBaseDirectory: string;
	m_nCurrentUserDirMode: integer;
	bConfigAvailableExecuteable: boolean;
	reg: tRegistry;
	nRegistrySetting: integer;
	hShell32: tHandle;
	pszLocalAppData,
	pszPersonalDownloads,
	pszPublicDownloads,
	pszProgrammData: pWideChar;
	strLocalAppData,
	strPersonalDownloads,
	strPublicDownloads,
	strProgrammData: string;
	shGetKnownFolderPath: tSHGetKnownFolderPath;
	wchAppData,
	wchPersonal: array[0..MAX_PATH] of wideChar;
	strPersonal,
	strAppData: string;
begin
	pnEFSExe := extractFilePath( application.exeName );

	pnEmuleExe := extractFilePath( excludeTrailingPathDelimiter( pnEFSExe ) );

	strSelectedDataBaseDirectory := pnEmuleExe;
	strSelectedConfigBaseDirectory := strSelectedDataBaseDirectory;
	strSelectedExpansionBaseDirectory := strSelectedDataBaseDirectory;
	strEFSConfigBaseDirectory := pnEFSExe;

//	m_nCurrentUserDirMode := 2;

	if (winVersion <> _WINVER_95_) and (winVersion <> _WINVER_NT4_) then
		begin
		bConfigAvailableExecuteable := fileExists( strSelectedConfigBaseDirectory + dnEmuleConfig + fnPreferencesIni );

		nRegistrySetting := -1;
		reg := tRegistry.create;
		try
			reg.rootKey := HKEY_CURRENT_USER;
			if reg.openKey( 'Software\eMule', false ) then
				begin
				if reg.valueExists( 'UsePublicUserDirectories' ) then
					nRegistrySetting := reg.readInteger( 'UsePublicUserDirectories' );
				reg.closeKey;
				end;
			finally reg.free;
			end;
		if (nRegistrySetting < -1) or (nRegistrySetting > 2) then nRegistrySetting := -1;

		if (nRegistrySetting = 0)
		  or (nRegistrySetting = 1) and (winVersion = _WINVER_VISTA_)
		  or (nRegistrySetting = -1) and (not bConfigAvailableExecuteable or (winVersion = _WINVER_VISTA_)) then
			begin
			hShell32 := loadLibrary( 'shell32.dll' );
			if hShell32 <> 0 then
				begin
				try
					if (winVersion = _WINVER_VISTA_) then
						begin
						pszLocalAppData := nil;
						pszPersonalDownloads := nil;
						pszPublicDownloads := nil;
						pszProgrammData := nil;

						@shGetKnownFolderPath := getProcAddress( hShell32, 'SHGetKnownFolderPath' );
						if (@shGetKnownFolderPath <> nil)
						  and (shGetKnownFolderPath( FOLDERID_LocalAppData, 0, 0, pszLocalAppData ) = S_OK)
						  and (shGetKnownFolderPath( FOLDERID_Downloads, 0, 0, pszPersonalDownloads ) = S_OK)
						  and (shGetKnownFolderPath( FOLDERID_PublicDownloads, 0, 0, pszPublicDownloads ) = S_OK)
						  and (shGetKnownFolderPath( FOLDERID_ProgramData, 0, 0, pszProgrammData ) = S_OK) then
							begin
							if (length( pszLocalAppData ) < MAX_PATH - 30) and (length( pszPersonalDownloads ) < MAX_PATH - 40)
							  and (length( pszProgrammData ) < MAX_PATH - 30) and (length( pszPublicDownloads ) < MAX_PATH - 40) then
								begin
								strLocalAppData := includeTrailingPathDelimiter( pszLocalAppData );
								strPersonalDownloads := includeTrailingPathDelimiter( pszPersonalDownloads );
								strPublicDownloads := includeTrailingPathDelimiter( pszPublicDownloads );
								strProgrammData := includeTrailingPathDelimiter( pszProgrammData );

								if (nRegistrySetting = -1) then
									begin
									if fileExists( strLocalAppData + dnEmule + dnEmuleConfig + fnPreferencesIni ) then
										m_nCurrentUserDirMode := 0
									else if fileExists( strProgrammData + dnEmule + dnEmuleConfig + fnPreferencesIni ) then
										m_nCurrentUserDirMode := 1
									else if bConfigAvailableExecuteable then
										m_nCurrentUserDirMode := 2
									else
										m_nCurrentUserDirMode := 0;
									end
								else
									m_nCurrentUserDirMode := nRegistrySetting;

								if (m_nCurrentUserDirMode = 0) then // multiuser
									begin
									strSelectedDataBaseDirectory := strPersonalDownloads + dnEmule;
									strSelectedConfigBaseDirectory := strLocalAppData + dnEmule;
									strSelectedExpansionBaseDirectory := strProgrammData + dnEmule;
									strEFSConfigBaseDirectory := strLocalAppData + dnEFS;
									//m_nCurrentUserDirMode := 0;
									end
								else if (m_nCurrentUserDirMode = 1) then // public user
									begin
									strSelectedDataBaseDirectory := strPublicDownloads + dnEmule;
									strSelectedConfigBaseDirectory := strProgrammData + dnEmule;
									strSelectedExpansionBaseDirectory := strProgrammData + dnEmule;
									strEFSConfigBaseDirectory := strProgrammData + dnEFS;
									//m_nCurrentUserDirMode := 1;
									end
								(*else if (m_nCurrentUserDirMode = 2) then // programm directory
									begin
									//m_nCurrentUserDirMode := 2;
									end*);
								end
							else
								;{!! paths too long }
							end
						else
							;{!! shGetKnownFolderPath failed }

						if pszLocalAppData <> nil then coTaskMemFree( pszLocalAppData );
						if pszPersonalDownloads <> nil then coTaskMemFree( pszPersonalDownloads );
						if pszPublicDownloads <> nil then coTaskMemFree( pszPublicDownloads );
						if pszProgrammData <> nil then coTaskMemFree( pszProgrammData );
						end
					else {if (winVersion <> _WINVER_VISTA_) then}
						begin
						if (shGetFolderPathW( 0, CSIDL_APPDATA, 0, SHGFP_TYPE_CURRENT, @wchAppData ) = S_OK)
						  and (shGetFolderPathW( 0, CSIDL_PERSONAL, 0, SHGFP_TYPE_CURRENT, @wchPersonal ) = S_OK) then
							begin
							if (length( pWideChar( @wchAppData ) ) < MAX_PATH - 30) and (length( pWideChar( @wchPersonal ) ) < MAX_PATH - 40) then
								begin
								strPersonal := includeTrailingPathDelimiter( wchPersonal );
								strAppData := includeTrailingPathDelimiter( wchAppData );
								if (nRegistrySetting = 0) then
									begin
									strSelectedDataBaseDirectory := strPersonal + dnEmuleDownloads;
									strSelectedConfigBaseDirectory := strAppData + dnEmule;
									strEFSConfigBaseDirectory := strAppData + dnEFS;
//									m_nCurrentUserDirMode := 0;
									end
								else if (nRegistrySetting = -1) and not bConfigAvailableExecuteable then
									begin
//									if fileExists( wchAppData + dnEmule + dnEmuleConfig + fnPreferencesIni ) then
									if fileExists( strAppData + dnEmule + dnEmuleConfig + fnPreferencesIni ) then
										begin
										strSelectedDataBaseDirectory := strPersonal + dnEmuleDownloads;
										strSelectedConfigBaseDirectory := strAppData + dnEmule;
										strEFSConfigBaseDirectory := strAppData + dnEFS;
//										m_nCurrentUserDirMode := 0;
										end;
									end;
								end
							else
								;{!! paths too long }
							end
						else
							;{!! shGetFolderPathW failed }
						end;
					finally freeLibrary( hShell32 );
					end;
				end
			else
				;{!! loadLibrary failed }
			end;
		end;

	pnEmuleData := strSelectedConfigBaseDirectory;
	pnEmuleConfig := strSelectedConfigBaseDirectory + dnEmuleConfig;
	pnEFSConfig := strEFSConfigBaseDirectory;
	pnEFSLogs := pnEFSConfig + dnLogs;

	{ 13 may 07: 0.48a support (new folders): don't allow two EFS instances with the same config files >>> }
	mutexPath := stringReplace( pnEmuleConfig, '\', '/', [rfReplaceAll] );
{ old code:
	mutexPath := stringReplace( pnEmuleExe, '\', '/', [rfReplaceAll] );
}	{ <<< 13 may 07: 0.48a support (new folders): don't allow two EFS instances with the same config files }

	if not fileExists( pnEmuleConfig + fnKnownMet ) or not fileExists( pnEmuleConfig + fnPreferencesIni ) then
		begin
		application.messageBox( pChar( format( msgErrEMuleNotFound, [appFullName, excludeTrailingPathDelimiter( dnEFS ), dnEFS] ) ), pChar( appFullName ), mb_Ok or mb_iconError );
		halt;
		end;

	if not directoryExists( pnEFSConfig ) then createDir( pnEFSConfig );
	if not directoryExists( pnEFSConfig ) then
		begin
		application.messageBox( pChar( format( msgErrLogsNotFound, [ pnEFSConfig ] ) ), pChar( appFullName ), mb_Ok or mb_iconError );
		halt;
		end;
	if not directoryExists( pnEFSLogs ) then createDir( pnEFSLogs );
	if not directoryExists( pnEFSLogs ) then
		begin
		application.messageBox( pChar( format( msgErrLogsNotFound, [ pnEFSLogs ] ) ), pChar( appFullName ), mb_Ok or mb_iconError );
		halt;
		end;
end;
{ <<< 12 may 07: 0.48a support (new folders) }

initialization
	{ 12 may 07: 0.48a support (new folders) >>> }
	winVersion := detectWinVersion;
	getFolders;

{ old code:
	appPath := extractFilePath( application.exeName );

	eMulePath := getEmuleFolder;
	if eMulePath = '' then
		begin
		application.messageBox( pChar( format( msgErrEMuleNotFound, [appFullName] ) ), pChar( appFullName ), mb_Ok or mb_iconError );
		halt;
		end;

	mutexPath := stringReplace( eMulePath, '\', '/', [rfReplaceAll] );

	logsPath := appPath + dnLogs;
	if not directoryExists( logsPath ) then createDir( logsPath );
	if not directoryExists( logsPath ) then
		begin
		application.messageBox( pChar( format( msgErrLogsNotFound, [ logsPath ] ) ), pChar( appFullName ), mb_Ok or mb_iconError );
		halt;
		end;
}	{ <<< 12 may 07: 0.48a support (new folders) }

end.
