{
Copyright (C)2006 JesTheOnlyOne
A part of the code in this unit is based on eMule source code Copyright (C)2002-2006 Merkur ( strEmail.Format("%s@%s", "devteam", "emule-project.net") / http://www.emule-project.net )

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}


{ conditionals
  ------------

- viewer:
must be defined when compiling the viewer, undefined when compiling the recorder

}

{$WARN SYMBOL_PLATFORM OFF}
{$IFDEF debug}
	{$R+,I+,Q+}
{$ELSE}
	{$R-,I-,Q-}
{$ENDIF}
unit knownMetUnit;

interface

uses
	classes, windows, sysUtils, dateUtils,
	{$IFDEF viewer}Graphics, {$ENDIF}
	basicDefsUnit;

resourceString
	rsKnownMetLoadError = 'Unexpected known.met version';
	rsCancelledMetLoadError = 'Unexpected cancelled.met version';
	rsKnownMetSaveError = 'An error occurred while saving known.met: %s';
	rsCancelledMetSaveError = 'An error occurred while saving cancelled.met: %s';
	rsUnknownTagType = 'Unknown tag type';
	rsInvalidTag = 'Invalid tag';

const
	TAGTYPE_HASH =		$01;
	TAGTYPE_STRING =	$02;
	TAGTYPE_UINT32 =	$03;
	TAGTYPE_FLOAT32 =	$04;
	TAGTYPE_BOOL =		$05;
	TAGTYPE_BOOLARRAY =	$06;
	TAGTYPE_BLOB =		$07;
	TAGTYPE_UINT16 =	$08;
	TAGTYPE_UINT8 =		$09;
	TAGTYPE_BSOB =		$0A;
	TAGTYPE_UINT64 =	$0B;

	TAGTYPE_STR1 =		$11;
	TAGTYPE_STR16 =		$20;

	FT_FILENAME =			$01;
	FT_FILESIZE =			$02;
//	FT_TRANSFERRED =		$08;
	FT_PARTFILENAME =		$12;
	FT_FILESIZE_HI =		$3A;
	FT_ATTRANSFERRED =		$50;
	FT_ATREQUESTED =		$51;
	FT_ATACCEPTED =			$52;
	FT_ATTRANSFERREDHI =	$54;
	FT_AICH_HASH =			$27;
	FT_FILEHASH =			$28;

	tagNames: array[1..$FF] of string = (
{00}							'FILENAME',				'FILESIZE',				'FILETYPE',
		'FILEFORMAT',			'LASTSEENCOMPLETE',		'',						'',
		'TRANSFERRED',			'GAPSTART',				'GAPEND',				'DESCRIPTION',
		'',						'',						'',						'',
{10}	'',						'',						'PARTFILENAME',			'',
		'STATUS',				'SOURCES',				'PERMISSIONS',			'',
		'DLPRIORITY',			'ULPRIORITY',			'COMPRESSION',			'CORRUPTED',
		'',						'',						'',						'',
{20}	'KADLASTPUBLISHKEY',	'KADLASTPUBLISHSRC',	'FLAGS',				'DL_ACTIVE_TIME',
		'CORRUPTEDPARTS',		'DL_PREVIEW',			'KADLASTPUBLISHNOTES',	'AICH_HASH',
		'FILEHASH',				'',						'',						'',
		'',						'',						'',						'',
{30}	'COMPLETE_SOURCES',		'COLLECTIONAUTHOR',		'COLLECTIONAUTHORKEY',	'',
		'',						'',						'',						'',
		'',						'',						'FILESIZE_HI',			'',
		'',						'',						'',						'',
{40}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{50}	'ATTRANSFERRED',		'ATREQUESTED',			'ATACCEPTED',			'CATEGORY',
		'ATTRANSFERREDHI',		'MAXSOURCES',			'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{60}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{70}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{80}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{90}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{A0}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{B0}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{C0}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{D0}	'MEDIA_ARTIST',			'MEDIA_ALBUM',			'MEDIA_TITLE',			'MEDIA_LENGTH',
		'MEDIA_BITRATE',		'MEDIA_CODEC',			'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{E0}	'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
		'',						'',						'',						'',
{F0}	'',						'',						'',						'',
		'',						'',						'FILECOMMENT',			'FILERATING',
		'',						'',						'',						'',
		'',						'',						'',						''
	);

type
	tCFileDate = dWord;

	{$IFDEF viewer}
	tPartsHash = array[0..0] of tHashRec;
	pPartsHash = ^tPartsHash;
	{$ENDIF}

	tKnownMetTag = class( tObject )
		{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
		private
			fM_pstrVal: string;
			function getM_pstrVal: string;
			procedure setM_pstrVal( const newValue: string );
		{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }
		public
			m_uType: byte;
			m_uName: byte;
			m_pszName: pChar;
			m_nBlobSize: dWord;
			{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
{			m_pstrVal: string;
}			{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }
			m_uVal: int64;
			m_fVal: single;
			m_pData: pointer;
			constructor create( var f: tStream ); { create and load }
			{$IFDEF viewer}
			constructor reCreate( aName: integer; aValue: int64; const aStrValue: string = '' );
			{$ENDIF}
			destructor destroy; override;
			{$IFDEF viewer}
			function write( var f: tStream ): boolean;
			{$ENDIF}
			{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
			property m_pstrVal: string read getM_pstrVal write setM_pstrVal; { See note in the needUtf8 function }
			{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }
		end;

	tKnownMetTags = class( tList )
		public
			constructor create( var f: tStream; countWidth: integer = 4 ); { create and load; countWidth = 4 bytes for known.met, 1 byte for cancelled.met }
			{$IFDEF viewer}
			constructor reCreate( const aFileName: string; aTransferred: int64; aRequested, aAccepted: dWord; aFileSize: int64 = 0; const aAICH: string = '' );
			{$ENDIF}
			{$IFDEF viewer}
			constructor createEmpty;
			{$ENDIF}
			destructor destroy; override;
			{$IFDEF viewer}
			procedure write( var f: tStream; countWidth: integer = 4 ); { countWidth = 4 bytes for known.met, 1 byte for cancelled.met }
			{$ENDIF}
		end;

	tKnownMetRecord = class( tObject )
		protected
			function getTagCount: integer;
			function getTag( index: integer ): tKnownMetTag;
			function getNamedTag( aName: integer ): tKnownMetTag;
			function getFileName: string;
			procedure setFileName( const aFileName: string );
			function getFileSize: int64;
			function getTransferred: int64;
			function getRequested: dWord;
			function getAccepted: dWord;
			{$IFDEF viewer}
			function getAICH: string;
			procedure setAICH( const aAICH: string );
			procedure setTransferred( newValue: int64 );
			procedure setRequested( newValue: dWord );
			procedure setAccepted( newValue: dWord );
			procedure setFileSize( newValue: int64 );
			{$ENDIF}
			function getIsDownloadedFile: boolean;
		public
			utcLastModified: tCFileDate;
			hash: tHash;
			{$IFDEF viewer}
			partsCount: word;
			parts: pPartsHash;
			{$ENDIF}
			tags: tKnownMetTags;
			{$IFDEF viewer}
			color: tColor;
			{$ENDIF}
			constructor create( var f: tStream ); { create and load }
			{$IFDEF viewer}
			constructor reCreate( const aFileName, aFileHash: string; aTransferred: int64; aRequested, aAccepted: dWord; aFileSize: int64 = 0; const aAICH: string = '' );
			{$ENDIF}
			destructor destroy; override;
			{$IFDEF viewer}
			procedure write( var f: tStream );
			{$ENDIF}
			property tagCount: integer read getTagCount;
			property tag[ index: integer ]: tKnownMetTag read getTag;
			property namedTag[ aName: integer ]: tKnownMetTag read getNamedTag;
			{ some useful tags: }
			property fileName: string read getFileName write setFileName;
			property fileSize: int64 read getFileSize {$IFDEF viewer} write setFileSize {$ENDIF};
			property transferred: int64 read getTransferred {$IFDEF viewer} write setTransferred {$ENDIF};
			property requested: dWord read getRequested {$IFDEF viewer} write setRequested {$ENDIF};
			property accepted: dWord read getAccepted {$IFDEF viewer} write setAccepted {$ENDIF};
			property isDownloadedFile: boolean read getIsDownloadedFile; { true(=yes) if there's a PARTFILENAME tag, false(=don't know) otherwise }
			{$IFDEF viewer}
			property AICH: string read getAICH write setAICH;
			{$ENDIF}
		end;

	tKnownMetList = class( tStringList )
		protected
			function getRecords( index: integer ): tKnownMetRecord;
			{$IFDEF viewer}
			procedure setRecords( index: integer; aRec: tKnownMetRecord );
			{$ENDIF}
		public
			function findByHash( const aHash: string; var index: integer ): boolean;
			property records[ index: integer ]: tKnownMetRecord read getRecords {$IFDEF viewer} write setRecords {$ENDIF};
		end;

	tKnownMet = class( tObject )
		protected
			fPath: string;
			fList: tKnownMetList;
			fVersion: byte;
			fDate: tFileDate;
			{$IFDEF viewer}
			function getNeedUpdate: boolean;
			{ 08 may 07: disable known.met editing features if known.met has been modified since last reload >>> }
			function getIsUpTodate: boolean;
			{ <<< 08 may 07: disable known.met editing features if known.met has been modified since last reload }
			{$ENDIF}
		public
			constructor create( const aPath: string );
			destructor destroy; override;
			procedure load;
			procedure unload;
			{$IFDEF viewer}
			procedure save;
			{$ENDIF}
			property path: string read fPath;
			property version: byte read fVersion;
			property list: tKnownMetList read fList;
			property date: tFileDate read fDate write fDate;
			{$IFDEF viewer}
			property needUpdate: boolean read getNeedUpdate; { True if known.met has been modified at least 2 seconds ago }
			{ 08 may 07: disable known.met editing features if known.met has been modified since last reload >>> }
			property isUpTodate: boolean read getIsUpTodate; { True if known.met has not been modified; To be used only when eMule is not running }
			{ <<< 08 may 07: disable known.met editing features if known.met has been modified since last reload }
			{$ENDIF}
		end;

	{$IFDEF viewer}
	tCancelledMetRecord = class( tObject )
		protected
		public
			hash: tHash;
			tags: tKnownMetTags;
			constructor create( var f: tStream ); { create and load }
			constructor createFromHash( aHash: tHash );
			destructor destroy; override;
			procedure write( var f: tStream );
		end;

	tCancelledMetList = class( tList )
		protected
		public
			function find( aHash: tHash; var index: integer ): boolean;
		end;

	tCancelledMet = class( tObject )
		protected
			fPath: string;
			fList: tCancelledMetList;
			fVersion: byte;
			fSubVersion: byte;
			fSeed: dWord;
		public
			constructor create( const aPath: string );
			destructor destroy; override;
			procedure load;
			procedure unload;
			procedure save;
			procedure add( const aHash: string );
			property path: string read fPath;
			property version: byte read fVersion;
			property list: tCancelledMetList read fList;
		end;
	{$ENDIF}

{$IFDEF viewer}
function knownCompareHashes( list: tStringList; index1, index2: integer ): Integer;
{$ENDIF}

implementation

{$IFDEF viewer}
uses MessageDigests;
{$ENDIF}

{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
function tKnownMetTag.getM_pstrVal: string;
begin
	{ SafeFile.cpp -> CString CFileDataIO::ReadString(bool bOptUTF8, UINT uRawSize) }
	if (length( fM_pstrVal ) >= 3) and (ord( fM_pstrVal[ 1 ] ) = $EF) and (ord( fM_pstrVal[ 2 ] ) = $BB) and (ord( fM_pstrVal[ 3 ] ) = $BF) then
		begin
		result := utf8ToAnsi( fM_pstrVal );
		if (length( result ) > 0) and (result[ 1 ] = '?') then
			result := copy( result, 2, maxInt );
		end
	else
		result := fM_pstrVal;
end;

procedure tKnownMetTag.setM_pstrVal( const newValue: string );

	function needUtf8: boolean;
	{ Note: may return false for some strings that were utf8 encoded, and true for some strings that were not utf8 encoded.
	That's why the encoding is now done here, and not in tKnownMetTag.write }
	var
		ws: wideString;
		i: integer;
	begin
		ws := newValue;
		for i := 1 to length( ws ) do
			if word( ws[ i ] ) >= $100 then
				begin
				result := true;
				exit;
				end;
		result := false;
	end;

begin
	if needUtf8 then
		fM_pstrVal := #$EF#$BB#$BF + ansiToUtf8( newValue )
	else
		fM_pstrVal := newValue;
end;
{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }

{ Repair known.met >>> }
{$IFDEF viewer}
constructor tKnownMetTag.reCreate( aName: integer; aValue: int64; const aStrValue: string = '' );
begin
	inherited create;
	m_uName := aName;
	case aName of
		FT_FILENAME:	begin
						m_uType := TAGTYPE_STRING;
						m_pstrVal := aStrValue;
						end;
		{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
		FT_AICH_HASH:	begin
						m_uType := TAGTYPE_STRING;
						m_pstrVal := aStrValue;
						end;
		{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
		{ 30 apr 07: bug fix: FT_TRANSFERRED is not the 64bits version of FT_ATTRANSFERRED / FT_ATTRANSFERREDHI!... >>> }
{		FT_TRANSFERRED:
						begin
						m_uType := TAGTYPE_UINT64;
						m_uVal := aValue;
						end;
}		{ <<< 30 apr 07: bug fix: FT_TRANSFERRED is not the 64bits version of FT_ATTRANSFERRED / FT_ATTRANSFERREDHI!... }
		FT_FILESIZE:
						begin
						if aValue > $FFFFFFFF then m_uType := TAGTYPE_UINT64
						else m_uType := TAGTYPE_UINT32;
						m_uVal := aValue;
						end;
		else			begin
						m_uType := TAGTYPE_UINT32;
						m_uVal := aValue;
						end;
		end;
end;
{$ENDIF}
{ <<< Repair known.met }

constructor tKnownMetTag.create( var f: tStream );
{ packets.cpp   ->   CTag::CTag(CFileDataIO* data, bool bOptUTF8) }
var
	dw: dWord;
	w: word;
	b: byte;
//	s: string;
begin
	inherited create;

	m_pszName := nil;
	m_pData := nil;

	f.read( m_uType, sizeOf( m_uType ) );
	if (m_uType and $80 <> 0) then
		begin
		m_uType := m_uType and $7F;
		f.read( m_uName, sizeOf( m_uName ) );
		m_pszName := nil;
		end
	else
		begin
		f.read( w, sizeOf( w ) );
		if (w = 1) then
			begin
			f.read( m_uName, sizeOf( m_uName ) );
			m_pszName := nil;
			end
		else
			begin
			m_uName := 0;
			getMem( m_pszName, succ( w ) );
			try
				if w > 0 then f.read( m_pszName^, w );
				except
					freeMem( m_pszName );
					m_pszName := nil;
					raise;
				end;
			if m_pszName <> nil then (m_pszName + w)^ := #0;
			end;
		end;

	m_nBlobSize := 0;

	case m_uType of
		TAGTYPE_STRING:
			begin
			f.read( w, sizeOf( w ) );
			{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
			setLength( fM_pstrVal, w );
			f.read( fM_pstrVal[ 1 ], w );
(* old code:
			setLength( s, w );
			{ SafeFile.cpp -> CString CFileDataIO::ReadString(bool bOptUTF8, UINT uRawSize) }
			f.read( s[ 1 ], w );
			{ 28 apr 07: bug fix: known files with a name with less than 3 characters caused a runtime error >>> }
			if (w >= 3) and (ord( s[ 1 ] ) = $EF) and (ord( s[ 2 ] ) = $BB) and (ord( s[ 3 ] ) = $BF) then
{ old code:
			if (ord( s[ 1 ] ) = $EF) and (ord( s[ 2 ] ) = $BB) and (ord( s[ 3 ] ) = $BF) then
}			{ <<< 28 apr 07: bug fix: known files with a name with less than 3 characters caused a runtime error }
				begin
				m_pstrVal := utf8ToAnsi( s );
				if (length( m_pstrVal ) > 0) and (m_pstrVal[ 1 ] = '?') then
					m_pstrVal := copy( m_pstrVal, 2, maxInt );
				end
			else
				m_pstrVal := s;
*)			{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }
			end;
		TAGTYPE_UINT32:
			begin
			f.read( dw, sizeOf( dw ) );
			m_uVal := dw;
			end;
		TAGTYPE_UINT64:
			f.read( m_uVal, sizeOf( m_uVal ) );
		TAGTYPE_UINT16:
			begin
			f.read( w, sizeOf( w ) );
			m_uVal := w;
			m_uType := TAGTYPE_UINT32;
			end;
		TAGTYPE_UINT8:
			begin
			f.read( b, sizeOf( b ) );
			m_uVal := w;
			m_uType := TAGTYPE_UINT32;
			end;
		TAGTYPE_FLOAT32:
			f.read( m_fVal, sizeOf( m_fVal ) );
		TAGTYPE_HASH:
			begin
			getMem( m_pData, sizeOf( tHashRec ) );
			try
				f.read( m_pData^, sizeOf( tHashRec ) );
				except
					freeMem( m_pData );
					m_pData := nil;
					raise;
				end;
			end;
		TAGTYPE_BOOL:
			f.seek( 1, soFromCurrent );
		TAGTYPE_BOOLARRAY:
			begin
			f.read( w, sizeOf( w ) );
			f.seek( w div 8 + 1, soFromCurrent );
			end;
		TAGTYPE_BLOB:
			begin
			f.read( m_nBlobSize, sizeOf( m_nBlobSize ) );
			if (m_nBlobSize <= f.size - f.position) then
				begin
				getMem( m_pData, m_nBlobSize );
				try
					f.read( m_pData^, m_nBlobSize );
					except
						freeMem( m_pData );
						m_pData := nil;
						raise;
					end;
				end
			else
				begin
				m_nBlobSize := 0;
				raise exception.create( rsInvalidTag );
				end;
			end;
		else
			if (m_uType >= TAGTYPE_STR1) and (m_uType <= TAGTYPE_STR16) then
				begin
				dw := m_uType - TAGTYPE_STR1 + 1;
				{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
				setLength( fM_pstrVal, dw );
				f.read( fM_pstrVal[ 1 ], dw );
{ old code:
				setLength( m_pstrVal, dw );
				f.read( m_pstrVal[ 1 ], dw );
}				{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }
				m_uType := TAGTYPE_STRING;
				end
			else
				raise exception.create( rsUnknownTagType );
		end;
end;

destructor tKnownMetTag.destroy;
begin
	if m_pData <> nil then freeMem( m_pData );
	if m_pszName <> nil then freeMem( m_pszName );
	inherited destroy;
end;

{$IFDEF viewer}
function tKnownMetTag.write( var f: tStream ): boolean;
{ packets.cpp   ->   CTag::WriteTagToFile(CFileDataIO* file, EUtf8Str eStrEncode) }
var
	dw: dWord;
	w: word;
//	s: string;

	{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
(* old code:
	function needUtf8: boolean;
	var
		ws: wideString;
		i: integer;
	begin
		{!! bug: returns false for some strings that were utf8 encoded, and true for some strings that were not utf8 encoded }
		ws := m_pstrVal;
		for i := 1 to length( ws ) do
			if word( ws[ i ] ) >= $100 then
				begin
				result := true;
				exit;
				end;
		result := false;
	end;
*)	{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }

begin
	result := false;
	if (m_uType in [TAGTYPE_STRING, TAGTYPE_UINT32, TAGTYPE_UINT64, TAGTYPE_FLOAT32, TAGTYPE_BLOB]) then
		begin

		f.write( m_uType, sizeOf( m_uType ) );

		if m_pszName <> nil then
			begin
			w := strLen( m_pszName );
			f.write( w, sizeOf( w ) );
			if w > 0 then f.write( m_pszName^, w );
			end
		else
			begin
			w := 1;
			f.write( w, sizeOf( w ) );
			f.write( m_uName, sizeOf( m_uName ) );
			end;

		case m_uType of
			TAGTYPE_STRING:
				begin
				{ 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user >>> }
				w := length( fM_pstrVal );
				f.write( w, sizeOf( w ) );
				if w > 0 then f.write( fM_pstrVal[ 1 ], w );
{ old code:
				if needUtf8 then
					begin
					s := ansiToUtf8( m_pstrVal );
					s := #$EF#$BB#$BF + s;
					end
				else
					s := m_pstrVal;
				w := length( s );
				f.write( w, sizeOf( w ) );
				if w > 0 then f.write( s[ 1 ], w );
}				{ <<< 08 may 07: bug fix: never change utf8 encoding for known file names, unless explicitely renamed by the user }
				end;
			TAGTYPE_UINT32:
				begin
				dw := m_uVal;
				f.write( dw, sizeOf( dw ) );
				end;
			TAGTYPE_UINT64:
				f.write( m_uVal, sizeOf( m_uVal ) );
			TAGTYPE_FLOAT32:
				f.write( m_fVal, sizeOf( m_fVal ) );
			TAGTYPE_BLOB:
				begin
				f.write( m_nBlobSize, sizeOf( m_nBlobSize ) );
				if m_nBlobSize > 0 then f.write( m_pData^, m_nBlobSize );
				end;
			end;
		result := true;
		end;
end;
{$ENDIF}

{ Repair known.met >>> }
{$IFDEF viewer}
{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
constructor tKnownMetTags.reCreate( const aFileName: string; aTransferred: int64; aRequested, aAccepted: dWord; aFileSize: int64 = 0; const aAICH: string = '' );
{ old code:
constructor tKnownMetTags.reCreate( const aFileName: string; aTransferred: int64; aRequested, aAccepted: dWord; aFileSize: int64 = 0 );
}{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
begin
	inherited create;
	add( tKnownMetTag.reCreate( FT_FILENAME, 0, aFileName ) );
	if aFileSize > 0 then add( tKnownMetTag.reCreate( FT_FILESIZE, aFileSize ) );
	if aTransferred > 0 then
		begin
		add( tKnownMetTag.reCreate( FT_ATTRANSFERRED, int64Rec( aTransferred ).lo ) );
		add( tKnownMetTag.reCreate( FT_ATTRANSFERREDHI, int64Rec( aTransferred ).hi ) );
		end;
	if aRequested > 0 then add( tKnownMetTag.reCreate( FT_ATREQUESTED, aRequested ) );
	if aAccepted > 0 then add( tKnownMetTag.reCreate( FT_ATACCEPTED, aAccepted ) );
	{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
	if aAICH <> '' then add( tKnownMetTag.reCreate( FT_AICH_HASH, 0, aAICH ) );
	{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
end;
{$ENDIF}
{ <<< Repair known.met }

constructor tKnownMetTags.create( var f: tStream; countWidth: integer = 4 );
{ knownFile.cpp   ->   CKnownFile::LoadTagsFromFile(CFileDataIO* file) }
{ knownFileList.cpp   ->   CKnownFileList::LoadCancelledFiles() }
var
	dw: dWord;
	b: byte;
	i, n: integer;
begin
	inherited create;

	if countWidth = 4 then
		begin
		f.read( dw, sizeOf( dw ) );
		count := dw;
		end
	else
		begin
		f.read( b, sizeOf( b ) );
		count := b;
		end;
	n := -1;
	try
		for i := 0 to pred( count ) do
			begin
			items[ i ] := tKnownMetTag.create( f );
			n := i;
			end;
		except
			for i := 0 to n do
				begin
				tKnownMetTag( items[ i ] ).free;
				items[ i ] := nil;
				end;
			count := 0;
			raise;
		end;
end;

{$IFDEF viewer}
constructor tKnownMetTags.createEmpty;
begin
	inherited create;
end;
{$ENDIF}

destructor tKnownMetTags.destroy;
var
	i: integer;
begin
	for i := pred( count ) downTo 0 do
		if items[ i ] <> nil then tKnownMetTag( items[ i ] ).free;
	inherited destroy;
end;

{$IFDEF viewer}
procedure tKnownMetTags.write( var f: tStream; countWidth: integer = 4 );
var
	dw: dWord;
	b: byte;
	i: integer;
	p, p1: int64;
begin
	p := f.position;
	dw := 0;
	f.write( dw, countWidth ); { count will be written afterwards, because some tags may be skipped (BOOL, BOOLARRAY) }
	for i := 0 to pred( count ) do
		if tKnownMetTag( items[ i ] ).write( f ) then inc( dw );
	p1 := f.position;
	f.seek( p, soFromBeginning );
	if countWidth = 4 then
		f.write( dw, sizeOf( dw ) )
	else
		begin
		b := dw;
		f.write( b, sizeOf( b ) );
		end;
	f.seek( p1, soFromBeginning );
end;
{$ENDIF}

{ Repair known.met >>> }
{$IFDEF viewer}
{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
constructor tKnownMetRecord.reCreate( const aFileName, aFileHash: string; aTransferred: int64; aRequested, aAccepted: dWord; aFileSize: int64 = 0; const aAICH: string = '' );
{ old code:
constructor tKnownMetRecord.reCreate( const aFileName, aFileHash: string; aTransferred: int64; aRequested, aAccepted: dWord; aFileSize: int64 = 0 );
}{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
begin
	inherited create;
	color := clWindow;
	utcLastModified := 0;
	hash := tHash.createStr( aFileHash );
	partsCount := 0;
	parts := nil;
	{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
	tags := tKnownMetTags.reCreate( aFileName, aTransferred, aRequested, aAccepted, aFileSize, aAICH );
{ old code:
	tags := tKnownMetTags.reCreate( aFileName, aTransferred, aRequested, aAccepted, aFileSize );
}	{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
end;
{$ENDIF}
{ <<< Repair known.met }

constructor tKnownMetRecord.create( var f: tStream );
{ knownFile.cpp   ->   CKnownFile::LoadFromFile(CFileDataIO* file) }
{$IFNDEF viewer}
var
	partsCount: word;
{$ENDIF}
begin
	inherited create;
	{$IFDEF viewer}
	color := clWindow;
	{$ENDIF}
	f.read( utcLastModified, sizeOf( utcLastModified ) );
	hash := tHash.readFromStream( f );
	f.read( partsCount, sizeOf( partsCount ) );
	{$IFDEF viewer}
	{ 28 apr 07: bug fix for known files with partcount = 0 >>> }
	if partsCount > 0 then
		begin
		getMem( parts, integer( partsCount ) * sizeOf( tHashRec ) );
		try
			f.read( parts^, integer( partsCount ) * sizeOf( tHashRec ) );
			except
				freeMem( parts );
				parts := nil;
				raise;
			end;
		end
	else
		parts := nil;
{ old code:
	getMem( parts, integer( partsCount ) * sizeOf( tHashRec ) );
	try
		f.read( parts^, integer( partsCount ) * sizeOf( tHashRec ) );
		except
			freeMem( parts );
			parts := nil;
			raise;
		end;
}	{ <<< 28 apr 07: bug fix for known files with partcount = 0 }
	{$ELSE}
	f.seek( integer( partsCount ) * sizeOf( tHashRec ), soFromCurrent );
	{$ENDIF}
	tags := tKnownMetTags.create( f );
end;

destructor tKnownMetRecord.destroy;
begin
	tags.free;
	{$IFDEF viewer}
	freeMem( parts );
	{$ENDIF}
	hash.free;
	inherited destroy;
end;

{$IFDEF viewer}
procedure tKnownMetRecord.write( var f: tStream );
{ knownFile.cpp   ->   CKnownFile::WriteToFile(CFileDataIO* file) }
begin
	f.write( utcLastModified, sizeOf( utcLastModified ) );
	hash.writeToStream( f );
	f.write( partsCount, sizeOf( partsCount ) );
	{ 28 apr 07: bug fix for known files with partcount = 0 >>> }
	if parts <> nil then f.write( parts^, integer( partsCount ) * sizeOf( tHashRec ) );
{ old code:
	f.write( parts^, integer( partsCount ) * sizeOf( tHashRec ) );
}	{ <<< 28 apr 07: bug fix for known files with partcount = 0 }
	tags.write( f );
end;
{$ENDIF}

function tKnownMetRecord.getTagCount: integer;
begin
	result := tags.count;
end;

function tKnownMetRecord.getTag( index: integer ): tKnownMetTag;
begin
	result := tKnownMetTag( tags[ index ] );
end;

function tKnownMetRecord.getNamedTag( aName: integer ): tKnownMetTag;
var
	i: integer;
begin
	for i := 0 to pred( tagCount ) do
		if tag[ i ].m_uName = aName then
			begin
			result := tag[ i ];
			exit;
			end;
	result := nil;
end;

function tKnownMetRecord.getFileName: string;
var
	i: integer;
begin
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uName = FT_FILENAME) and (m_uType = TAGTYPE_STRING) then
			begin
			result := m_pstrVal;
			exit;
			end;
	result := '';
end;

procedure tKnownMetRecord.setFileName( const aFileName: string );
var
	i: integer;
begin
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uName = FT_FILENAME) and (m_uType = TAGTYPE_STRING) then
			begin
			m_pstrVal := aFileName;
			exit;
			end;
end;

{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
{$IFDEF viewer}
function tKnownMetRecord.getAICH: string;
var
	i: integer;
begin
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uName = FT_AICH_HASH) and (m_uType = TAGTYPE_STRING) then
			begin
			result := m_pstrVal;
			exit;
			end;
	result := '';
end;

procedure tKnownMetRecord.setAICH( const aAICH: string );
var
	i: integer;
begin
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uName = FT_AICH_HASH) and (m_uType = TAGTYPE_STRING) then
			begin
			m_pstrVal := aAICH;
			exit;
			end;
end;
{$ENDIF}
{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }

function tKnownMetRecord.getFileSize: int64;
var
	i: integer;
	l, h: boolean;
begin
	result := 0;
	l := false;
	h := false;
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uName = FT_FILESIZE) and (m_uType = TAGTYPE_UINT64) then
			begin
			result := m_uVal;
			exit;
			end
		else if m_uType = TAGTYPE_UINT32 then
			begin
			case m_uName of
				FT_FILESIZE:
					begin
					int64Rec( result ).lo := m_uVal;
					l := true;
					end;
				FT_FILESIZE_HI:
					begin
					int64Rec( result ).hi := m_uVal;
					h := true;
					end;
				end;
			if l and h then exit;
			end;
end;

function tKnownMetRecord.getTransferred: int64;
var
	i: integer;
	l, h: boolean;
begin
	result := 0;
	l := false;
	h := false;
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uType = TAGTYPE_UINT32) or (m_uType = TAGTYPE_UINT64) then
			begin
			case m_uName of
				{ 30 apr 07: bug fix: FT_TRANSFERRED is not the 64bits version of FT_ATTRANSFERRED / FT_ATTRANSFERREDHI!... >>> }
{				FT_TRANSFERRED:
					begin
					result := m_uVal;
					exit;
					end;
}				{ <<< 30 apr 07: bug fix: FT_TRANSFERRED is not the 64bits version of FT_ATTRANSFERRED / FT_ATTRANSFERREDHI!... }
				FT_ATTRANSFERRED:
					begin
					int64Rec( result ).lo := m_uVal;
					l := true;
					end;
				FT_ATTRANSFERREDHI:
					begin
					int64Rec( result ).hi := m_uVal;
					h := true;
					end;
				end;
			if l and h then exit;
			end;
end;

function tKnownMetRecord.getRequested: dWord;
var
	nt: tKnownMetTag;
begin
	nt := namedTag[ FT_ATREQUESTED ];
	if nt <> nil then result := nt.m_uVal else result := 0;
end;

function tKnownMetRecord.getAccepted: dWord;
var
	nt: tKnownMetTag;
begin
	nt := namedTag[ FT_ATACCEPTED ];
	if nt <> nil then result := nt.m_uVal else result := 0;
end;

{ Repair known.met >>> }
{$IFDEF viewer}
procedure tKnownMetRecord.setFileSize( newValue: int64 );
var
	i: integer;
	l, h: boolean;
begin
	l := false;
	h := false;
	for i := pred( tagCount ) downTo 0 do with tag[ i ] do
		begin
		if (m_uName = FT_FILESIZE) then
			begin
			if newValue > $FFFFFFFF then m_uType := TAGTYPE_UINT64
			else m_uType := TAGTYPE_UINT32;
			m_uVal := newValue;
			l := true;
			end
		else if (m_uName = FT_FILESIZE_HI) then
			begin
			tag[ i ].free;
			tags.delete( i );
			h := true;
			end;
		if l and h then exit;
		end;
	if not l then
		tags.add( tKnownMetTag.reCreate( FT_FILESIZE, newValue ) );
end;

procedure tKnownMetRecord.setTransferred( newValue: int64 );
var
	i: integer;
	l, h: boolean;
begin
	l := false;
	h := false;
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uType = TAGTYPE_UINT32) or (m_uType = TAGTYPE_UINT64) then
			begin
			case m_uName of
				{ 30 apr 07: bug fix: FT_TRANSFERRED is not the 64bits version of FT_ATTRANSFERRED / FT_ATTRANSFERREDHI!... >>> }
{				FT_TRANSFERRED:
					begin
					m_uVal := newValue;
					exit;
					end;
}				{ <<< 30 apr 07: bug fix: FT_TRANSFERRED is not the 64bits version of FT_ATTRANSFERRED / FT_ATTRANSFERREDHI!... }
				FT_ATTRANSFERRED:
					begin
					m_uVal := int64Rec( newValue ).lo;
					l := true;
					end;
				FT_ATTRANSFERREDHI:
					begin
					m_uVal := int64Rec( newValue ).hi;
					h := true;
					end;
				end;
			if l and h then exit;
			end;
	if not l then tags.add( tKnownMetTag.reCreate( FT_ATTRANSFERRED, int64Rec( newValue ).lo ) );
	if not h then tags.add( tKnownMetTag.reCreate( FT_ATTRANSFERREDHI, int64Rec( newValue ).hi ) );
end;

procedure tKnownMetRecord.setRequested( newValue: dWord );
var
	nt: tKnownMetTag;
begin
	nt := namedTag[ FT_ATREQUESTED ];
	if nt <> nil then nt.m_uVal := newValue
	else tags.add( tKnownMetTag.reCreate( FT_ATREQUESTED, newValue ) );
end;

procedure tKnownMetRecord.setAccepted( newValue: dWord );
var
	nt: tKnownMetTag;
begin
	nt := namedTag[ FT_ATACCEPTED ];
	if nt <> nil then nt.m_uVal := newValue
	else tags.add( tKnownMetTag.reCreate( FT_ATACCEPTED, newValue ) );
end;
{$ENDIF}
{ <<< Repair known.met }

function tKnownMetRecord.getIsDownloadedFile: boolean;
var
	i: integer;
begin
	for i := 0 to pred( tagCount ) do with tag[ i ] do
		if (m_uType = TAGTYPE_STRING) and (m_uName = FT_PARTFILENAME) then
			begin
			result := true;
			exit;
			end;
	result := false;
end;

function tKnownMetList.getRecords( index: integer ): tKnownMetRecord;
begin
	result := tKnownMetRecord( objects[ index ] );
end;

{ Repair known.met >>> }
{$IFDEF viewer}
procedure tKnownMetList.setRecords( index: integer; aRec: tKnownMetRecord );
begin
	objects[ index ] := aRec;
end;
{$ENDIF}
{ <<< Repair known.met }

function tKnownMetList.findByHash( const aHash: string; var index: integer ): boolean;
var
	l, h, i, c: integer;
	hash: tHash;
begin
	result := false;
	hash := tHash.createStr( aHash );
	try
		l := 0;
		h := count - 1;
		while l <= h do
			begin
			i := (l + h) shr 1;
			c := records[ i ].hash.compare( hash.hash );
			if c < 0 then
				l := i + 1
			else
				begin
				h := i - 1;
				if c = 0 then
					begin
					result := true;
					if duplicates <> dupAccept then l := i;
					end;
				end;
			end;
		index := l;
		finally hash.free;
		end;
end;

constructor tKnownMet.create( const aPath: string );
begin
	inherited create;
	fPath := aPath;
	fList := nil;
	fDate := -1;
end;

destructor tKnownMet.destroy;
var
	i: integer;
begin
	if fList <> nil then
		begin
		for i := pred( fList.count ) downTo 0 do if fList.objects[ i ] <> nil then fList.objects[ i ].free;
		fList.free;
		end;
	inherited destroy;
end;

function knownCompareHashes( list: tStringList; index1, index2: integer ): Integer;
begin
	result := tKnownMetRecord( list.objects[ index1 ] ).hash.compare( tKnownMetRecord( list.objects[ index2 ] ).hash.hash );
end;

procedure tKnownMet.load;
{ knownFileList.cpp   ->   bool CKnownFileList::LoadKnownFiles() }
var
	f: tFileStream;
	i: integer;
	dw: dWord;
	r: tKnownMetRecord;
	bhfi: by_handle_file_information;
	ft: tFileTime;
begin
	unload;
	fList := tKnownMetList.create;
	try
		fList.sorted := false;
		fList.duplicates := dupAccept;
		fList.caseSensitive := false;
		f := tFileStream.create( fPath, fmOpenRead or fmShareDenyNone ); { don't deny write access to emule -> verify that the file's lastWriteTime has not changed while reading }
		try
			getFileInformationByHandle( f.handle, bhfi );
			ft := bhfi.ftLastWriteTime;
			f.read( fVersion, sizeOf( fVersion ) );
			if (fVersion <> $0E) and (fVersion <> $0F) then raise exception.create( rsKnownMetLoadError );
			f.read( dw, sizeOf( dw ) );
			for i := 0 to pred( dw ) do
				begin
				r := tKnownMetRecord.create( tStream( f ) );
				fList.addObject( r.fileName, r );
//if i = 0 then ;
				getFileInformationByHandle( f.handle, bhfi );
				if int64( ft ) <> int64( bhfi.ftLastWriteTime ) then
					{ if the file has been modified, assume that the read content is erroneous }
					raise exception.createFmt( rsModifiedWhileReadingError, [fPath] );
				end;
			if int64( ft ) <> int64( bhfi.ftLastWriteTime ) then
				{ if the file has been modified, assume that the read content is erroneous }
				raise exception.createFmt( rsModifiedWhileReadingError, [fPath] );
			finally f.free;
			end;
		fList.customSort( knownCompareHashes );
		fDate := fileAge( fPath );
		except
			for i := 0 to pred( fList.count ) do if fList.objects[ i ] <> nil then fList.objects[ i ].free;
			fList.free;
			fList := nil;
			raise;
		end;
end;

procedure tKnownMet.unload;
var
	i: integer;
begin
	if fList <> nil then
		begin
		for i := pred( fList.count ) downTo 0 do if fList.objects[ i ] <> nil then fList.objects[ i ].free;
		freeAndNil( fList );
		fDate := -1;
		end;
end;

{$IFDEF viewer}
function tKnownMet.getNeedUpdate: boolean;
var
	fa: integer;
begin
	fa := fileAge( fPath );
	result := ((fList = nil) or (fDate <> fa)) and (millisecondsBetween( now, fileDateToDateTime( fa ) ) > delayAfterDateChange);
end;

{ 08 may 07: disable known.met editing features if known.met has been modified since last reload >>> }
function tKnownMet.getIsUpTodate: boolean;
var
	fa: integer;
begin
	fa := fileAge( fPath );
	result := ((fList <> nil) and (fDate = fa));
end;
{ <<< 08 may 07: disable known.met editing features if known.met has been modified since last reload }
{$ENDIF}

{$IFDEF viewer}
{ emule must not be running! }
procedure tKnownMet.save;
var
	f: tFileStream;
	i: integer;
	dw: dWord;
	rec: tKnownMetRecord;
	b: boolean;
begin
	try
		f := tFileStream.create( fPath, fmOpenWrite or fmShareDenyWrite );
		try
			{ Repair known.met >>> }
			f.seek( sizeOf( fVersion ), soFromBeginning );
{ old code:
			f.write( fVersion, sizeOf( fVersion ) );
}			{ <<< 29 apr 07: Repair known.met }
			dw := fList.count;
			f.write( dw, sizeOf( dw ) );
			b := false;
			for i := 0 to pred( dw ) do
				{ Repair known.met >>> }
				begin
				rec := fList.records[ i ];
				rec.write( tStream( f ) );
				if rec.fileSize > $FFFFFFFF then b := true;
				end;
{ old code:
				fList.records[ i ].write( tStream( f ) );
}				{ <<< 29 apr 07: Repair known.met }
			f.size := f.position;
			{ Repair known.met >>> }
			f.seek( 0, soFromBeginning );
			if b then fVersion := $0F else fVersion := $0E;
			f.write( fVersion, sizeOf( fVersion ) );
			{ <<< Repair known.met }
			finally f.free;
			end;
		fDate := fileAge( fPath );
		except on e: exception do raise exception.createFmt( rsKnownMetSaveError, [e.message] );
		end;
end;
{$ENDIF}

{$IFDEF viewer}
constructor tCancelledMetRecord.create( var f: tStream );
{ knownFileList.cpp   ->   CKnownFileList::LoadCancelledFiles() }
begin
	inherited create;
	hash := tHash.readFromStream( f );
	tags := tKnownMetTags.create( f, 1 );
end;

constructor tCancelledMetRecord.createFromHash( aHash: tHash );
begin
	inherited create;
	hash := aHash;
	tags := tKnownMetTags.createEmpty;
end;

destructor tCancelledMetRecord.destroy;
begin
	tags.free;
	hash.free;
	inherited destroy;
end;

procedure tCancelledMetRecord.write( var f: tStream );
begin
	hash.writeToStream( f );
	tags.write( f, 1 );
end;

constructor tCancelledMet.create( const aPath: string );
begin
	inherited create;
	fPath := aPath;
	fList := nil;
end;

destructor tCancelledMet.destroy;
var
	i: integer;
begin
	if fList <> nil then
		begin
		for i := pred( fList.count ) downTo 0 do if fList[ i ] <> nil then tObject( fList[ i ] ).free;
		fList.free;
		end;
	inherited destroy;
end;

function cancelledCompareHashes( item1, item2: pointer ): Integer;
begin
	result := tCancelledMetRecord( item1 ).hash.compare( tCancelledMetRecord( item2 ).hash.hash );
end;

procedure tCancelledMet.load;
{ knownFileList.cpp   ->   CKnownFileList::LoadCancelledFiles() }
var
	f: tFileStream;
	i: integer;
	dw: dWord;
	r: tCancelledMetRecord;
	bhfi: by_handle_file_information;
	ft: tFileTime;
begin
	unload;
	fList := tCancelledMetList.create;
	try
		f := tFileStream.create( fPath, fmOpenRead or fmShareDenyNone ); { don't deny write access to emule -> verify that the file's lastWriteTime has not changed while reading }
		try
			getFileInformationByHandle( f.handle, bhfi );
			ft := bhfi.ftLastWriteTime;
			f.read( fVersion, sizeOf( fVersion ) );
			{ 02 may 07: support for cancelled.met version $0F >>> }
			if (fVersion <> $0E) and (fVersion <> $0F) then raise exception.create( rsCancelledMetLoadError );
			if (fVersion = $0F) then
				begin
				f.read( fSubVersion, sizeOf( fSubVersion ) );
				if (fSubVersion <> $01) then raise exception.create( rsCancelledMetLoadError );
				f.read( fSeed, sizeOf( fSeed ) );
				end;
{ old code:
			if (fVersion <> $0E) then raise exception.create( rsCancelledMetLoadError );
}			{ <<< 02 may 07: support for cancelled.met version $0F }
			f.read( dw, sizeOf( dw ) );
			for i := 0 to pred( dw ) do
				begin
				r := tCancelledMetRecord.create( tStream( f ) );
				fList.add( r );
				if int64( ft ) <> int64( bhfi.ftLastWriteTime ) then
					{ if the file has been modified, assume that the read content is erroneous }
					raise exception.createFmt( rsModifiedWhileReadingError, [fPath] );
				end;
			if int64( ft ) <> int64( bhfi.ftLastWriteTime ) then
				{ if the file has been modified, assume that the read content is erroneous }
				raise exception.createFmt( rsModifiedWhileReadingError, [fPath] );
			finally f.free;
			end;
		fList.sort( cancelledCompareHashes );
		except
			for i := 0 to pred( fList.count ) do if fList[ i ] <> nil then tObject( fList[ i ] ).free;
			fList.free;
			fList := nil;
			raise;
		end;
end;

procedure tCancelledMet.unload;
var
	i: integer;
begin
	if fList <> nil then
		begin
		for i := pred( fList.count ) downTo 0 do if fList[ i ] <> nil then tObject( fList[ i ] ).free;
		freeAndNil( fList );
		end;
end;

{ eMule must not be running! }
procedure tCancelledMet.save;
var
	f: tFileStream;
	i: integer;
	dw: dWord;
begin
	try
		if not fileExists( fPath ) then
			f := tFileStream.create( fPath, fmCreate or fmShareDenyWrite )
		else
			f := tFileStream.create( fPath, fmOpenWrite or fmShareDenyWrite );
		try
			f.write( fVersion, sizeOf( fVersion ) );
			{ 02 may 07: support for cancelled.met version $0F >>> }
			if (fVersion = $0F) then
				begin
				f.write( fSubVersion, sizeOf( fSubVersion ) );
				f.write( fSeed, sizeOf( fSeed ) );
				end;
			{ <<< 02 may 07: support for cancelled.met version $0F }
			dw := fList.count;
			f.write( dw, sizeOf( dw ) );
			for i := 0 to pred( dw ) do
				tCancelledMetRecord( fList[ i ] ).write( tStream( f ) );
			f.size := f.position;
			finally f.free;
			end;
		except on e: exception do raise exception.createFmt( rsCancelledMetSaveError, [e.message] );
		end;
end;

procedure tCancelledMet.add( const aHash: string );
var
	h: tHash;
	i: integer;
	pachSeedHash: packed array[0..19] of byte;
	md5: tMD5;
	hr: tHashRec;
begin
	h := tHash.createStr( aHash );
	try

		{ 02 may 07: support for cancelled.met version $0F >>> }
		if (fVersion = $0F) then
			begin
			move( fSeed, pachSeedHash, sizeOf( fSeed ) );
			move( h.hash, pachSeedHash[ 4 ], sizeOf( h.hash ) );
			md5 := tMD5.create;
			md5.transform( pachSeedHash, sizeof( pachSeedHash ) );
			md5.complete;
			move( md5.hashValueBytes^, hr, sizeOf( hr ) );
			md5.free;
			h.hash := hr;
			end;
		{ <<< 02 may 07: support for cancelled.met version $0F }

		if not list.find( h, i ) then
			begin
			fList.insert( i, tCancelledMetRecord.createFromHash( h ) );
			h := nil; { if inserted, the object will be destroyed with the list }
			end;
		finally
			if h <> nil then h.free;
		end;
end;

function tCancelledMetList.find( aHash: tHash; var index: integer ): boolean;
var
	l, h, i, c: integer;
begin
	result := false;
	l := 0;
	h := pred( count );
	while l <= h do
		begin
		i := (l + h) shr 1;
		c := tCancelledMetRecord( list^[I] ).hash.compare( aHash.hash );
		if c < 0 then
			l := succ( i )
		else
			begin
			h := pred( i );
			if c = 0 then
				begin
				result := true;
				l := i;
				end;
			end;
		end;
	index := l;
end;
{$ENDIF}

end.
