{
Copyright (C)2006 JesTheOnlyOne

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

{$WARN SYMBOL_PLATFORM OFF}
{$IFDEF debug}
	{$R+,I+,Q+}
{$ELSE}
	{$R-,I-,Q-}
{$ENDIF}
unit bugsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

resourceString
	bugs1 =
		  'Please do not delete the ConnRunTime log ("statistics.ini-statistics,ConnRunTime.efs"), unless you want to delete ALL your logs.\n\n'
		+ 'This log is required to display the graphics with the "%s" on the horizontal axis (default setting).';
(*	bugs2 =
		  'Resetting eMule statistics is not supported.\n\n'
		+ 'If you need to reset the stats, I think you will have to delete all the log files... (I did not test this...)';
*)(*	bugs3 =
		  'When saving known.met, it can happen that some strings that were UTF8 encoded will not be UTF8 encoded and vice-versa.\n'
		+ 'I think this is due to differences between Delphi and C++ conversion routines, but I believe this should not be a problem anyway...';
*)	bugs4 =
		  'With eMule v0.48a and above, If you want to change eMule multi-users settings once EFS is installed, you should proceed as following:'#13#10#13#10
		+ '- First close EFS (both viewer and recorder)'#13#10
		+ '- Change eMule settings'#13#10
		+ '- Close eMule'#13#10
		+ '- Copy or move your emule files (known.met, cancelled.met, statistics.ini, shared files, temp files...) to their new locations (unless you want a fresh eMule install, of course)'#13#10
		+ '- Restart eMule and make sure it''s correctly configured'#13#10
		+ '- Start EFS (New config files and new default logs will be created)'#13#10
		+ '- Close EFS (both viewer and recorder)'#13#10
		+ '- Copy or move your EFS logs and config files (EFS.ini, events.log and content of EFS\logs folder) to their new locations (If you haved moved your old eMule files, of course)'#13#10
		+ '- Restart EFS';
{		  'Multiple windows account may not be fully supported.\n'
		+ 'I have not thought about this, and I have not performed any test.\n\n'
		+ 'I don''t know either how EFS will behave under Windows Vista...';
}	bugs5 =
		  'eMule versions prior to 0.43a saved the statistics in preferences.ini; from 0.43a, the stats are saved in statistics.ini.\n'
		+ 'Both old and new versions are supported, but if ever you reinstall an old version in place of a new one, you will have to:\n'
		+ '- copy the stats from statistics.ini to preferences.ini, to update the old style stats;\n'
		+ '- delete (or rename) the statistics.ini file, because EFS does not test the eMule version number; it always uses statistics.ini if found...';

type
  tbugsForm = class(TForm)
	topPanel: TPanel;
	bottomPanel: TPanel;
	closeBtn: TButton;
	prevBtn: TButton;
	nextBtn: TButton;
    bugsBox: TMemo;
    tipsBtn: TButton;
	procedure FormCreate(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure nextBtnClick(Sender: TObject);
	procedure prevBtnClick(Sender: TObject);
	procedure showBugs;
	procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
  public
	bugsList: tStringList;
	bugsIndex: integer;
  end;

var
  bugsForm: tbugsForm;

implementation

{$R *.dfm}

uses
	mainUnit;

procedure tbugsForm.FormCreate(Sender: TObject);
begin
	bugsList := tStringList.create;
	bugsList.sorted := false;
	bugsList.caseSensitive := false;
	bugsList.duplicates := dupIgnore;
	bugsList.add( format( bugs1, [rsRuntimeXAxis] ) );
//	bugsList.add( bugs2 );
//	bugsList.add( bugs3 );
	bugsList.add( bugs4 );
	bugsList.add( bugs5 );
	bugsIndex := 0;
	showBugs;
end;

procedure tbugsForm.FormDestroy(Sender: TObject);
begin
	bugsList.free;
end;

procedure tbugsForm.nextBtnClick(Sender: TObject);
begin
	if bugsIndex < pred( bugsList.count ) then inc( bugsIndex ) else bugsIndex := 0;
	showBugs;
end;

procedure tbugsForm.prevBtnClick(Sender: TObject);
begin
	if bugsIndex > 0 then dec( bugsIndex ) else bugsIndex := pred( bugsList.count );
	showBugs;
end;

procedure tbugsForm.showBugs;
begin
	bugsBox.lines.text := stringReplace( bugsList[ bugsIndex ], '\n', #13, [rfReplaceAll] );
end;

procedure tbugsForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
	if (key = #13) and bugsBox.focused then nextBtn.click
	else if key = #27 then modalResult := mrCancel; 
end;

end.
