{
Copyright (C)2006 JesTheOnlyOne

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

{$WARN SYMBOL_PLATFORM OFF}
{$IFDEF debug}
	{$R+,I+,Q+}
{$ELSE}
	{$R-,I-,Q-}
{$ENDIF}
unit confirmKMEditUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ActnList, Buttons;

type
  tConfirmKMEditForm = class(TForm)
	topPanel: TPanel;
	bottomPanel: TPanel;
	okBtn: TButton;
	cancelBtn: TButton;
	delLogBox: TCheckBox;
	textBox: TMemo;
	ActionList1: TActionList;
	aBackupKM: TAction;
	aBackupCM: TAction;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    dontAskBox: TCheckBox;
	procedure aBackupKMExecute(Sender: TObject);
	procedure aBackupCMExecute(Sender: TObject);
	procedure FormCreate(Sender: TObject);
  private
	backupKMCaption,
	backupCMCaption: string;
  public
  end;

function confirmKMEdit( const aTitle, aText: string; editCancelled: boolean; var deleteLog, dontAskAgain: boolean ): boolean;
{ Note: The initial value of deleteLog indicates whether the delete log checkbox must be enabled.
The final value of deleteLog indicates whether the delete log checkbox was ticked }

var
  confirmKMEditForm: tConfirmKMEditForm;
  delLogChecked: boolean = true;

implementation

{$R *.dfm}

uses
	mainUnit;

function confirmKMEdit( const aTitle, aText: string; editCancelled: boolean; var deleteLog, dontAskAgain: boolean ): boolean;
begin
	confirmKMEditForm := tConfirmKMEditForm.create( mainForm );
	with confirmKMEditForm do
		begin
		aBackupCM.enabled := editCancelled;
		delLogBox.enabled := deleteLog;
		delLogBox.checked := deleteLog and delLogChecked;
		caption := aTitle;
		textBox.lines.text := aText;
		try
			result := (showModal = mrOk);
			if deleteLog then
				begin
				deleteLog := delLogBox.checked;
				delLogChecked := deleteLog;
				end;
			dontAskAgain := dontAskBox.checked;
			finally free;
			end;
		end;
end;

procedure tConfirmKMEditForm.aBackupKMExecute(Sender: TObject);
var
	reply: integer;
begin
	mainForm.backupMet( reply );
	if reply <> idCancel then aBackupKM.caption := backupKMCaption + ' (' + rsDone + ')';
end;

procedure tConfirmKMEditForm.aBackupCMExecute(Sender: TObject);
var
	reply: integer;
begin
	mainForm.backupMet( reply, true );
	if reply <> idCancel then aBackupCM.caption := backupCMCaption + ' (' + rsDone + ')';
end;

procedure tConfirmKMEditForm.FormCreate(Sender: TObject);
begin
	backupKMCaption := aBackupKM.caption;
	backupCMCaption := aBackupCM.caption;
	if backupKnownMetDone then aBackupKM.caption := backupKMCaption + ' (' + rsDone + ')';
	if backupCancelledMetDone then aBackupCM.caption := backupCMCaption + ' (' + rsDone + ')';
end;

end.
