{
Copyright (C)2006 JesTheOnlyOne

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

{$WARN SYMBOL_PLATFORM OFF}
{$IFDEF debug}
	{$R+,I+,Q+}
{$ELSE}
	{$R-,I-,Q-}
{$ENDIF}
unit mainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, Menus, ActnList, StdActns, dateUtils, ImgList,
  TeEngine, Series, TeeProcs, Chart, StdCtrls, AppEvnts, math, iniFiles, clipBrd, shellApi,
  strUtils, shlObj, comObj, activeX,
  basicDefsUnit, knownMetUnit, sharedFoldersUnit, newLogWizardUnit, compressUnit, tipsUnit,
  bugsUnit, eventsLogEditUnit, errorsLogUnit, colorUnit, creditsUnit, licenseUnit, combineUnit,
  graphOptionsUnit, confirmKMEditUnit;

resourceString
	rsActiveLogCaption =		'Active';
	rsInactiveLogCaption =		'Inactive';
	rsNoLogCaption =			'None';
	rsPermanentLogCaption =		'Permanent';
	rsYes =						'Yes';
	rsNo =						'No';
	rsMaybeYes =				'Maybe';
	rsMaybeNo =					'Unlikely';
	rsDays =					'd';
	rsHours =					'h';
	rsMinutes =					'mn';
	rsDateXAxis =				'Real date';
	rsRuntimeXAxis =			'eMule runtime days';
	rsRequestsPerHour =			'requests / hour';
	rsRequestsGraph =			'Requests';
	rsTransfersGraph =			'Transfers';
	rsHoursPerDay =				'Hours / day';
	rsKBytesPerSec =			'kBytes / sec';
	rsBoolUnits =				'1 = enabled; 0 = disabled';
	rsNeverSince =				'Never since %s';
	rsNever =					'Never';
//	rsBackMetFilesFilter =		'Backed-up met files (*.~met)|*.~met';
	rsBackupFilesFilter =		'Backup files (*.~met; *.bak)|*.~met;*.bak';
//	rsMetFilesFilter =			'Met files (*.met)|*.met';
	rsAllFilesFilter =			'Any file (*.*)|*.*';
	rsEvents =					'Events';
	rsNoLastEvent =				'none';
	rsQueuedClientsUnits =		'Clients';
	rsIniLegend =				'%s (%s)'#13#10;
	rsKFLegendTransferred =		'"%s" (Uploaded in kBytes/sec)'#13#10;
	rsKFLegendReq1 =			'"%s" (';
	rsKFLegendReq2 =			'Requests / hour';
	rsKFLegendReq3 =			'; ';
	rsKFLegendReq4 =			'Accepted requests / hour';
	rsKFLegendReq5 =			')'#13#10;
	rsLegendCaption =			'Legend';
	rsRepairedKF =				'Unknown filename';
	rsBackupMetDlgTitle =		'Backup your %s file as';
	rsOpenBackupMetDlgTitle =	'Open the backup copy to import data from';
	rsDone =					'Done';
	rsNoWebServices =			'No filename based webservices found';

	msgAskDeleteLogs =
		  'Do you really want to delete the log file(s) of the selected item(s)?';
	msgAskDeleteLog =
		  'Do you really want to delete the log file of this item?';
(*	msgAskEditKnownMet1 =
		  'Warning: this feature is not guaranteed to be safe, although it seems to work fine with my official mules v0.47a to 0.47c.'#13
		+ 'Use at your own risk!'#13#13;
	msgAskEditKnownMet2 =
		  'Additionally, please note that any log file associated with the selected item(s) will be deleted.'#13#13;
	msgAskKnownMetBackup =
		  'Do you want to create a backup copy of the known.met file before proceeding?';
	msgAskCancelledMetBackup =
		  'Do you want to create a backup copy of the cancelled.met file before proceeding?';
*)	msgConfirmSetAsUnknownFile =
		  'Do you really want to set the selected item(s) as unknown file(s)?';
	msgConfirmSetAsCancelledFile =
		  'Do you really want to set the selected item(s) as cancelled file(s)?';
	msgConfirmRename =
		  'Before proceeding, you may want to backup known.met...';
	msgBackupFailed =
		  'Backup failed.';
//		  'Backup failed; action cancelled.';
	msgAskCompressLogs =
		  'This will drop some values in the old parts of the logs to reduce their size, so the left part of the graphics will become a bit less accurate (at least when zoomed).'#13
		+ 'In the oldest parts, only one value every %u hours will remain.'#13#13
		+ 'This cannot be undone, so if you''re not sure, please first make a backup of your logs folder.'#13#13
		+ 'Last compression date: %s';
	msgInvalidChars =
		  'The following characters are not allowed in windows filenames:'#13
		+ '\/:*?"<>|';

const
	fnRecorder = 'EFS.exe';

var
	daysCompressThreshold: integer = 30;	{ When compressing logs, only parts older than this are affected }
	resampleThreshold: integer = 4;			{ graphics are resampled to display at most one point every resampleThreshold pixel }

const
	hoursCompressMax = 6;					{ When compressing logs, at least one value every hoursCompressMax is kept }
	maxDisplayedKF = 3;						{ max number of known files that can be displayed simultaneously in graphs }
	maxDisplayedTags = 10;					{ max number of known files that can be displayed simultaneously in tags tab }
	maxDisplayedIni = 6;					{ max number of emule stats or settings displayed simultaneously in each graph }

	minDLSecs = 30;							{ assume that if modif time - creation time < minDLSecs, the file has probably not been downloaded with emule }

var
	{ set these to true whenever the graphics or the tags page need to be updated }
	graphsNeedRedraw: boolean = false;
	tagsNeedRedraw: boolean = false;

const
	{ knownFiles columns }
	kfColName =			0;
	kfColLog =			1;
	kfColSize =			2;
	kfColShared =		3;
	kfColTransferred =	4;
	kfColHash =			5;
	kfColDownloaded =	6;
	kfColDate =			7;
	kfColPath =			8;
	kfColDLTime =		9;
	kfColMax =			9;

var
	kfSortOrder: array[0..kfColMax] of integer;
	kfCompleteSort: boolean = false;
	kfColumnRightClicked: boolean = false;

	kfChangingListItem: tListItem = nil;
	kfChangingListItemChecked: boolean;
	kfSkipOnCheckItem: boolean = false;

const
	{ iniFiles columns }
	iniColValue =		0;
	iniColLog =			1;
	iniColFileName =	2;
	iniColSection =		3;
	iniColUnits =		4;
	iniColGraphic =		5;
	iniColMax =			5;

var
	iniSortOrder: array[0..iniColMax] of integer;
	iniCompleteSort: boolean = false;
	iniColumnRightClicked: boolean = false;

	iniChangingListItem: tListItem = nil;
	iniChangingListItemChecked: boolean;
	iniSkipOnCheckItem: boolean = false;

type
	tLogDates = array of tFileDate;
	tLogTimes = array of tEmuleRuntime;

{ 02 may 07: Quick zoom and center >>> }
const
	crZoom = 1;
	crUnZoom = 2;
{ <<< 02 may 07: Quick zoom and center }

type
  tMainForm = class(TForm)
	mainMenu: TMainMenu;
	actions: TActionList;
	aFileExit: TFileExit;
	fileMenu: TMenuItem;
	Exit1: TMenuItem;
	topPanel: TPanel;
	bottomPanel: TPanel;
	mainSplitter: TSplitter;
	knownFilesList: TListView;
	tabs: TPageControl;
	timer: TTimer;
	aKFReload: TAction;
	knownFilesMenu: TMenuItem;
	Reload1: TMenuItem;
	knownFilesImages: TImageList;
	aKFDelLog: TAction;
	N1: TMenuItem;
	Deletelog1: TMenuItem;
	knownFilesPopup: TPopupMenu;
	Reload2: TMenuItem;
	N2: TMenuItem;
	DeletelogCtrlUncheck1: TMenuItem;
    aKFShowShared: TAction;
	aKFShowLogged: TAction;
    Filter1: TMenuItem;
    Showall1: TMenuItem;
	Showsharedfilesonly1: TMenuItem;
    Showloggedfilesonly1: TMenuItem;
	aKFShowAll: TAction;
    Filter2: TMenuItem;
    Showallknownfiles1: TMenuItem;
	Showsharedfilesonly2: TMenuItem;
    Showloggedfilesonly2: TMenuItem;
    statsTab: TTabSheet;
    requestsChart: TChart;
    PointSeries1: TLineSeries;
    Series2: TLineSeries;
    Series5: TLineSeries;
    Series6: TLineSeries;
    transferredChart: TChart;
	Series1: TLineSeries;
	Series4: TLineSeries;
    Series10: TLineSeries;
    Series3: TLineSeries;
	Series7: TLineSeries;
    aGrEmuleRuntime: TAction;
	graphicsMenu: TMenuItem;
    HorizontalaxiseMuleruntime1: TMenuItem;
	graphicsPopup: TPopupMenu;
	HorizontalaxiseMuleruntime2: TMenuItem;
    tagsTab: TTabSheet;
	aNavNextTab: TAction;
    aNavPrevTab: TAction;
	tagsBox: TMemo;
    appEvents: TApplicationEvents;
    listsSplitter: TSplitter;
	eMuleStatsList: TListView;
    iniFilesPopup: TPopupMenu;
	iniFilesMenu: TMenuItem;
    aIniDelLog: TAction;
    DeletelogCtrlUntickcheckbox1: TMenuItem;
	DeletelogCtrlUntickcheckbox2: TMenuItem;
    Series8: TLineSeries;
    Series9: TLineSeries;
    Series11: TLineSeries;
	aIniNewLog: TAction;
    New1: TMenuItem;
    Newlog1: TMenuItem;
	Series12: TLineSeries;
    Series13: TLineSeries;
    Series14: TLineSeries;
    Series15: TLineSeries;
    Series16: TLineSeries;
    Series17: TLineSeries;
	Series18: TLineSeries;
    Series19: TLineSeries;
	Series20: TLineSeries;
    aIniEditLog: TAction;
	Logproperties1: TMenuItem;
	Logproperties2: TMenuItem;
    Reload3: TMenuItem;
	N3: TMenuItem;
    Reload4: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    aKFDelKnownFile: TAction;
	RemovefromknownmeteMulemustnotberunning1: TMenuItem;
	RemovefromknownmeteMulemustnotberunning2: TMenuItem;
	zoomBar: TScrollBar;
    scrollBar: TScrollBar;
	aHlpTips: TAction;
    helpMenu: TMenuItem;
    ips1: TMenuItem;
    aFileCompressLogs: TAction;
    Compresslogs1: TMenuItem;
    aHlpBugs: TAction;
    Knownbugsandlimitations1: TMenuItem;
    aKFSaveAsCollection: TFileSaveAs;
    Saveascollection1: TMenuItem;
    Saveascollection2: TMenuItem;
    aKFCopyAsCollection: TAction;
    Copylinkstoclipboard1: TMenuItem;
	Copylinkstoclipboard2: TMenuItem;
    aKFMoveToCancelledMet: TAction;
	SetascancelledfileseMulemustnotberunning1: TMenuItem;
    SetascancelledfileseMulemustnotberunning2: TMenuItem;
    aKFCopyAsHtmlCollection: TAction;
    CopyHTMLformattedlinkstoclipboard1: TMenuItem;
    CopyHTMLformattedlinkstoclipboard2: TMenuItem;
    aKFRename: TAction;
    RenameeMulemustnotberunningandthefilemustnotbeshared1: TMenuItem;
	RenameeMulemustnotberunningandthefilemustnotbeshared2: TMenuItem;
    mWebServices: TMenuItem;
    mmWebServices: TMenuItem;
    dateTimeBox: TStaticText;
    aRefKF1: TAction;
	N10: TMenuItem;
    N11: TMenuItem;
	Referencefile11: TMenuItem;
    aRefKF2: TAction;
    Referencefile21: TMenuItem;
    aResetRef: TAction;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    Referencefile12: TMenuItem;
    Referencefile22: TMenuItem;
    Resetreferencefiles1: TMenuItem;
    Series21: TBarSeries;
    Series22: TBarSeries;
    aFileRecErrorsLog: TAction;
    N15: TMenuItem;
	Viewrecorderserrorslog1: TMenuItem;
    Editknownmetemulemustnotberunningandtheselecteditemsmustnotbeshared1: TMenuItem;
	Links1: TMenuItem;
    Editknownmet1: TMenuItem;
    ed2klinks1: TMenuItem;
    lastEventBox: TRichEdit;
    aColors: TAction;
    Colors1: TMenuItem;
    Colors2: TMenuItem;
	aCredits: TAction;
    N6: TMenuItem;
    Credits1: TMenuItem;
    aIniCombine: TAction;
    Combinelogs1: TMenuItem;
	N7: TMenuItem;
    N8: TMenuItem;
	Combinelogs2: TMenuItem;
    aGraphOptions: TAction;
    Options1: TMenuItem;
    Options2: TMenuItem;
    graphsPanel: TPanel;
    legendPanel: TPanel;
	graphsSplitter: TSplitter;
    requestsLegend: TRichEdit;
    transfersLegend: TRichEdit;
    aIniSwapGraph: TAction;
    Colors3: TMenuItem;
    Swapfocusedlogbetweengraphs1: TMenuItem;
    legendDockablePanel: TPanel;
    aKFCopyFormat: TAction;
    Copylinkstoclipboardfreeformat1: TMenuItem;
    Copylinkstoclipboardfreeformat2: TMenuItem;
    N9: TMenuItem;
    N16: TMenuItem;
    aRepairKM: TAction;
    Repaitknownmet1: TMenuItem;
    Repaitknownmet2: TMenuItem;
	procedure FormCreate(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure timerTimer(Sender: TObject);
	function knownMetLoaded: boolean;
	procedure logFilesLoaded;
	procedure aKFReloadExecute(Sender: TObject);
	procedure knownFilesListCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
	procedure knownFilesListContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
	procedure knownFilesListColumnRightClick(Sender: TObject; Column: TListColumn; Point: TPoint);
	procedure knownFilesListColumnDragged(Sender: TObject);
	procedure knownFilesListColumnClick(Sender: TObject; Column: TListColumn);
	procedure knownFilesListChanging(Sender: TObject; Item: TListItem; Change: TItemChange; var AllowChange: Boolean);
	procedure knownFilesListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
	procedure knownFilesList_onCheckItem( sender: tObject; item: tListItem );
	procedure eMuleStatsList_onCheckItem( sender: tObject; item: tListItem );
	procedure kfDelThisLog( item: tListItem );
	procedure aKFDelLogExecute(Sender: TObject);
	procedure aKFDelLogUpdate(Sender: TObject);
	procedure aKFShowExecute(Sender: TObject);
	procedure bottomPanelResize(Sender: TObject);
	procedure knownFilesListSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
	procedure drawGraphics; { Don't call this method directly -> set graphsNeedRedraw to true instead }
	procedure showTags; { Don't call this method directly -> set tagsNeedRedraw to true instead }
	procedure listViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
	procedure FormResize(Sender: TObject);
	procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
	procedure redrawGraphs(Sender: TObject);
	procedure aNavNextTabExecute(Sender: TObject);
	procedure aNavPrevTabExecute(Sender: TObject);
	procedure appEventsIdle(Sender: TObject; var Done: Boolean);
	procedure eMuleStatsListCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
	procedure eMuleStatsListColumnRightClick(Sender: TObject; Column: TListColumn; Point: TPoint);
	procedure eMuleStatsListColumnDragged(Sender: TObject);
	procedure eMuleStatsListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
	procedure eMuleStatsListChanging(Sender: TObject; Item: TListItem; Change: TItemChange; var AllowChange: Boolean);
	procedure eMuleStatsListColumnClick(Sender: TObject; Column: TListColumn);
	procedure eMuleStatsListContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
	procedure eMuleStatsListSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
	procedure aIniDelLogUpdate(Sender: TObject);
	procedure iniDelThisLog( item: tListItem );
	procedure aIniDelLogExecute(Sender: TObject);
	procedure topPanelResize(Sender: TObject);
	procedure aIniNewLogExecute(Sender: TObject);
	procedure knownFilesListAdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
	procedure eMuleStatsListAdvancedCustomDrawItem(Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
	procedure aIniEditLogUpdate(Sender: TObject);
	procedure aIniEditLogExecute(Sender: TObject);
	procedure wndProc( var message: tMessage ); override;
	function isEmuleRunning: boolean;
	procedure editKnownMetActionsUpdate(Sender: TObject);
	procedure backupMet( var reply: integer; cancelled: boolean = false );
	procedure delKnownFiles( setAsCancelled: boolean = false );
	procedure aKFDelKnownFileExecute(Sender: TObject);
	procedure zoomBarChange(Sender: TObject);
	procedure scrollBarChange(Sender: TObject);
	procedure aHlpTipsExecute(Sender: TObject);
	procedure compressLogs;
	procedure aFileCompressLogsExecute(Sender: TObject);
	procedure aFileCompressLogsUpdate(Sender: TObject);
	function getIniString( const key, default: string ): string;
	procedure setIniString( const key, value: string );
	function getIniInt( const key: string; default: integer ): integer;
	procedure setIniInt( const key: string; value: integer );
    procedure aHlpBugsExecute(Sender: TObject);
	procedure appEventsActionUpdate(Action: TBasicAction; var Handled: Boolean);
	function getLinksCollection( const formatString: string = '' ): tStringList;
	procedure aKFSaveAsCollectionAccept(Sender: TObject);
	procedure aKFCopyAsCollectionUpdate(Sender: TObject);
    procedure aKFCopyAsCollectionExecute(Sender: TObject);
	procedure aKFMoveToCancelledMetExecute(Sender: TObject);
    procedure aKFCopyAsHtmlCollectionExecute(Sender: TObject);
	procedure knownFilesListEditing(Sender: TObject; Item: TListItem; var AllowEdit: Boolean);
	procedure aKFRenameUpdate(Sender: TObject);
	procedure aKFRenameExecute(Sender: TObject);
	procedure knownFilesListEdited(Sender: TObject; Item: TListItem; var S: String);
	procedure chartMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
	function getDisplayedFile( const hash: string ): tKnownMetRecord;
	procedure showValuesAtCursor( chart: tChart; hide: boolean = false );
	procedure chartDblClick(Sender: TObject);
	procedure editEventsLog( dateTime: tDateTime );
	procedure buildWebServicesMenu( parentMenu: tMenuItem );
	procedure knownFilesPopupPopup(Sender: TObject);
	procedure mWebServicesClick(Sender: TObject);
	procedure knownFilesMenuClick(Sender: TObject);
	procedure aRefKF1Update(Sender: TObject);
	procedure aRefKF1Execute(Sender: TObject);
	procedure aRefKF2Update(Sender: TObject);
	procedure aRefKF2Execute(Sender: TObject);
	procedure aResetRefUpdate(Sender: TObject);
	procedure aResetRefExecute(Sender: TObject);
	procedure aFileRecErrorsLogUpdate(Sender: TObject);
	procedure aFileRecErrorsLogExecute(Sender: TObject);
	procedure mousMoveOutsideCharts(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure eMuleStatsListDblClick(Sender: TObject);
	procedure aColorsExecute(Sender: TObject);
	procedure loadColors;
    procedure aCreditsExecute(Sender: TObject);
	procedure aIniCombineUpdate(Sender: TObject);
    procedure aIniCombineExecute(Sender: TObject);
	procedure aGraphOptionsExecute(Sender: TObject);
    procedure legendPanelResize(Sender: TObject);
    procedure aIniSwapGraphUpdate(Sender: TObject);
    procedure aIniSwapGraphExecute(Sender: TObject);
	procedure legendPanelDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
	procedure legendDockablePanelEndDock(Sender, Target: TObject; X, Y: Integer);
	procedure legendDockablePanelResize(Sender: TObject);
	procedure aKFCopyFormatExecute(Sender: TObject);
	procedure aRepairKMUpdate(Sender: TObject);
	function repairKM( recreateMissing: boolean ): boolean;
	function importMissingKF( const fName: string ): boolean;
	function pasteKF( links: tStrings ): boolean;
	procedure chartClick(Sender: TObject);
	procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
	function delErroneousKF: boolean;
	procedure aRepairKMExecute(Sender: TObject);
	procedure repairKnownMet;
  protected
	legendMinWidth,
	legendDefWidth: integer;
  public
	property displayedFile[ const hash: string ]: tKnownMetRecord read getDisplayedFile; { returns the object only if the log for the specified hash is currently displayed in the graph, nil otherwise or if hash is empty }
  end;

var
	mainForm: tMainForm;
	knownMet: tKnownMet;
	sharedFolders: tSharedFolders;
	backupKnownMetDone: boolean = false;
	backupCancelledMetDone: boolean = false;
	cancelledMetDate: tFileDate = 0;
	refKF1: tListItem = nil;
	refKF2: tListItem = nil;
	updateValuesAtCursor: boolean = false;
	justStarted: boolean = true;
	dontAskSetAsUnknown: boolean = false;
	dontAskSetAsCancelled: boolean = false;
	dontAskRename: boolean = false;

implementation

uses copyFormatUnit, MessageDigests, repairKMUnit;

{$R *.dfm}

procedure tMainForm.FormCreate(Sender: TObject);

	procedure createDefLogFiles;

		function logExists( const aName: string ): boolean;
		begin
			result := fileExists( pnEFSLogs + aName + permLogExt )
				or fileExists( pnEFSLogs + aName + enLogExt )
				or fileExists( pnEFSLogs + aName + disLogExt );
(*			result := fileExists( logsPath + aName + permLogExt )
				or fileExists( logsPath + aName + enLogExt )
				or fileExists( logsPath + aName + disLogExt );
*)		end;

	var
		name: string;
		dw: dWord;
		logCreated,
		firstTime: boolean;
	begin
		logCreated := false;
		firstTime := false;

		{ Statistics > time statistics > cumulative > runtime }
		{ Always create this log if it does not already exist: needed for real dates <-> eMule runtime conversions }
		name := format( iniLogFmt, [fnStatisticsIni, isStatistics, ikRuntime] );
		if not fileExists( pnEFSLogs + name + permLogExt ) then
//		if not fileExists( logsPath + name + permLogExt ) then
			begin
			logFiles.createLogFile( name, lsPermanent, ltInteger, lfCumulativeValue, 24, rsHoursPerDay );
			logCreated := true;
			firstTime := true;
			end;

		{ if the runtime log did not exist, assume this is the first install, and create a few other default logs }
		if firstTime then
			begin

			{ Statistics > uploads > cumulative > uploaded data }
			name := format( iniLogFmt, [fnStatisticsIni, isStatistics, ikTotalULed] );
			if not logExists( name ) then
				begin
				logFiles.createLogFile( name, lsActive, ltInt64, lfCumulativeValue, 1/1024, rsKBytesPerSec );
				logCreated := true;
				end;

			{ Statistics > uploads > cumulative > uploaded data > data source > complete file }
			name := format( iniLogFmt, [fnStatisticsIni, isStatistics, ikUpData_File] );
			if not logExists( name ) then
				begin
				logFiles.createLogFile( name, lsActive, ltInt64, lfCumulativeValue, 1/1024, rsKBytesPerSec );
				logCreated := true;
				end;

			{ Options > connection > upload limit }
			name := format( iniLogFmt, [fnPreferencesIni, isEmule, ikMaxUpload] );
			if not logExists( name ) then
				begin
				logFiles.createLogFile( name, lsActive, ltInteger, lfSavedOnChange, 1, rsKBytesPerSec );
				logCreated := true;
				end;

			{ Options > extended > upload speedSense > find best upload limit automatically }
			name := format( iniLogFmt, [fnPreferencesIni, isEmule, ikUSSEnabled] );
			if not logExists( name ) then
				begin
				logFiles.createLogFile( name, lsActive, ltByte, lfSavedOnChange, 1, rsBoolUnits );
				logCreated := true;
				end;

			if fileExists( pnEFSExe + fnLicense ) then
//			if fileExists( appPath + fnLicense ) then
				begin
				licenseForm := tLicenseForm.create( self );
				with licenseForm do
					begin
					try
						licenseBox.lines.loadFromFile( pnEFSExe + fnLicense );
//						licenseBox.lines.loadFromFile( appPath + fnLicense );
						showModal;
						finally free;
						end;
					end;
				end
			else
				errorMsg( format( errNoLicense, [fnLicense] ) );

			end; { if firstTime }

		{ if any log has been created, ask the recorder to update them as soon as possible }
		if logCreated then
			begin
			dw := bsm_applications;
			broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, newLogsMsg, 0, 0 );
			end;
	end;

var
	i, ii: integer;
	s: string;
	h: tHandle;
	b: boolean;
begin
	{ Do not allow multiple instances from the same eMule folder }
	createMutex( nil, false, pChar( mutexPath + mnViewer ) );
	if (getLastError = error_already_exists) or (getLastError = error_access_denied) then
		halt;

	{ Start the recorder, if not already running }
	h := createMutex( nil, false, pChar( mutexPath + mnRecorder ) );
	b := (getLastError <> error_already_exists) and (getLastError <> error_access_denied);
	if h <> 0 then closeHandle( h );
	if b then
		execCommand( pnEFSExe + fnRecorder, '', sw_showNormal );
//		execCommand( extractFilePath( application.exeName ) + fnRecorder, '', sw_showNormal );

	{ 13 may 07: 0.48a support (new folders): Show eMule config folder path instead of eMule executable folder path >>> }
	{ show the eMule path in the window's caption }
	caption := appFullName + ' - ' + pnEmuleConfig;
(* old code:
	{ show the eMule path in the window's caption }
	caption := appFullName + ' - ' + pnEmuleExe;
//	caption := appFullName + ' - ' + eMulePath;
*)	{ <<< 13 may 07: 0.48a support (new folders): Show eMule config folder path instead of eMule executable folder path }

	tabs.activePageIndex := 0;

	loadColors;

	s := getIniString( ikLastCompressDate, '' );
	if s = '' then setIniString( ikLastCompressDate, format( rsNeverSince, [dateTimeToStr( now )] ) );
	daysCompressThreshold := getIniInt( ikCompressionThreshold, daysCompressThreshold );

	resampleThreshold := getIniInt( ikResampleThreshold, resampleThreshold );

	knownMet := tKnownMet.create( pnEmuleConfig + fnKnownMet );
//	knownMet := tKnownMet.create( eMulePath + dnEmuleConfig + fnKnownMet );
	sharedFolders := tSharedFolders.create;
	logFiles := tLogFiles.create;

	createDefLogFiles;

	{ Initialize the list views sort order from the columns headers images }
	for i := 0 to kfColMax do
		begin
		ii := pred( knownFilesList.columns[ i ].imageIndex );
		if odd( ii ) then kfSortOrder[ ii div 2 ] := - succ( knownFilesList.columns[ i ].tag )
		else kfSortOrder[ ii div 2 ] := succ( knownFilesList.columns[ i ].tag );
		end;

	for i := 0 to iniColMax do
		begin
		ii := pred( eMuleStatsList.columns[ i ].imageIndex );
		if odd( ii ) then iniSortOrder[ ii div 2 ] := - succ( eMuleStatsList.columns[ i ].tag )
		else iniSortOrder[ ii div 2 ] := succ( eMuleStatsList.columns[ i ].tag );
		end;

	registerMessages;

	legendMinWidth := graphsSplitter.minSize;
	legendDefWidth := legendPanel.width;

	{ 02 may 07: Quick zoom and center >>> }
	screen.Cursors[ crZoom ] := loadCursor( hInstance, 'ZOOM' );
	screen.Cursors[ crUnZoom ] := loadCursor( hInstance, 'UNZOOM' );
	{ <<< 02 may 07: Quick zoom and center }

	timer.interval := timer_init;
	timer.enabled := true;
end;

procedure tMainForm.FormDestroy(Sender: TObject);
begin
	if logFiles <> nil then freeAndNil( logFiles );
	if sharedFolders <> nil then freeAndNil( sharedFolders );
	if knownMet <> nil then freeAndNil( knownMet );
end;

procedure tMainForm.logFilesLoaded;
var
	i: integer;
	logFile: tLogFile;
	item: tListItem;
	subItemsText: string;
	s: string;
	cr: tCursor;
begin
	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

		eMuleStatsList.clear;

		for i := 0 to pred( logFiles.count ) do
			begin
			logFile := logFiles.log[ i ];
			if not (logFile.what in [lwIniFile, lwQueuedClients, lwCombinedLogs]) then continue;

			eMuleStatsList.addItem( logFile.iniCaption, logFile );
			item := eMuleStatsList.items[ pred( eMuleStatsList.items.count ) ];
			subItemsText := '';

			case logFile.state of
				lsInactive:	subItemsText := subItemsText + rsInactiveLogCaption + #13;
				lsActive:	subItemsText := subItemsText + rsActiveLogCaption + #13;
				else		subItemsText := subItemsText + rsPermanentLogCaption + #13;
				end;

			case logFile.what of
				lwQueuedClients:	subItemsText := subItemsText + fnOnlineSigDat + #13#13;
				lwCombinedLogs:		begin
									case logFile.operation of
										coAddition:		s := '%1 + %2';
										coSubstract1:	s := '%1 - %2';
										coSubstract2:	s := '%2 - %1';
										coRatio1:		s := '%1 / %2';
										coRatio2:		s := '%2 / %1';
										coPerCent1:		s := '%1 / (%1 + %2)';
										else			s := '%2 / (%1 + %2)';
										end;
									subItemsText := subItemsText + stringReplace( stringReplace( s, '%1', iniLogNameToCaption( logFile.logNames[ 0 ] ), [rfReplaceAll] ), '%2', iniLogNameToCaption( logFile.logNames[ 1 ] ), [rfReplaceAll] ) + #13#13;
									end;
				else				subItemsText := subItemsText + logFile.iniFile + #13 + logFile.iniSection + #13;
				end;

			subItemsText := subItemsText + logFile.units + #13;

			if logFile.flags and lfShowWithRequests <> 0 then subItemsText := subItemsText + rsRequestsGraph + #13
			else subItemsText := subItemsText + rsTransfersGraph + #13;

			item.subItems.text := subItemsText;
			end;

		for i := 0 to pred( eMuleStatsList.items.count ) do
			begin
			if tLogFile( eMuleStatsList.items[ i ].data ).state in [lsActive, lsPermanent] then
				eMuleStatsList.items[ i ].checked := true;
			end;

		iniCompleteSort := true;
		eMuleStatsList.alphaSort;
		iniCompleteSort := false;

		if eMuleStatsList.items.count > 0 then eMuleStatsList.items[ 0 ].focused := true;

		finally screen.cursor := cr;
		end;
end;

function tMainForm.knownMetLoaded: boolean;
type
	pSharedData = ^tSharedData;
	tSharedData = packed record
		path: string;
		dateM,
		dateC: tFileTime;
		attr: integer;
		case integer of
			0:( size: int64 );
			1:( sizeRec: int64Rec );
		end;
var
	shared: tStringList;
	i: integer;
	rec: tKnownMetRecord;
	fName: string;
	fSize: int64;
	isShared: integer;
	item: tListItem;
	subItemsText: string;
	v: double;
	isDownloaded: boolean;
	isDownloaded2: integer;
	s: string;
	dt1, dt2: tDateTime;
	ft1, ft2: tFileTime;
	st: tSystemTime;
	n1, n2, n3: integer;
	dlTime: integer;
	cr: tCursor;

	procedure loadShared;
	var
		sr: tSearchRec;
		i, err: integer;
		path: string;
		n: integer;

		{ 15 feb 09: emule0.49c: Resolve (or ignore) shell links >>> }
		procedure addSharedFile( const path: string; const sr: tSearchRec );
		const
			sfgao_link = $00010000;
		var
			fSize: int64Rec;
			p: pSharedData;
			info: shFileInfo;
			f: tIniFile;
			b: boolean;
			shellLink: iShellLink;
			persistFile: iPersistFile;
			anObj: iUnknown;
			target: array[0..max_path] of char;
			findData: tWin32FindData;
			sr1: tSearchRec;
			err: integer;
		begin
			fSize.lo := sr.findData.nFileSizeLow;
			fSize.hi := sr.findData.nFileSizeHigh;
			if (int64( fSize ) > 0) and (int64( fSize ) <= max_eMule_file_size) then
				begin
				if sameText( extractFileExt( sr.name ), '.lnk' ) then
					begin
					if (shGetFileInfo( pChar( path + sr.name ), 0, info, sizeOf( info ), shgfi_attributes ) <> 0)
					  and (info.dwAttributes and sfgao_link <> 0) then
						begin
						try
							f := tIniFile.create( pnEmuleConfig + fnPreferencesIni );
							try
								b := f.readBool( isEmule, ikResolveLinks, false );
								finally f.free;
								end;
							if b then
								begin
								anObj := createComObject( clsid_shellLink );
								shellLink := anObj as iShellLink;
								persistFile := anObj as iPersistFile;
								persistFile.load( pWChar( wideString( path + sr.name ) ), stgm_read );
								if shellLink.getPath( target, sizeOf( target ), findData, 0 ) = noError then
									begin
									err := findFirst( target, faAnyFile and not (faVolumeId or faDirectory or faSysFile), sr1 );
									try
										if err = 0 then addSharedFile( extractFilePath( target ), sr1 );
										finally findClose( sr1 );
										end;
									end;
								end;
							except ;
							end;
						exit;
						end;
					end;
				new( p );
				p^.sizeRec := fSize;
				p^.dateM := sr.findData.ftLastWriteTime;
				p^.dateC := sr.findData.ftCreationTime;
				p^.path := path;
				p^.attr := sr.attr;
				shared.addObject( sr.name, tObject( p ) );
				end;
		end;
		{ <<< 15 feb 09: emule0.49c: Resolve (or ignore) shell links }

	begin
		shared.sorted := true;
		shared.caseSensitive := false;
		shared.duplicates := dupIgnore;
		for i := 0 to pred( sharedFolders.count ) do
			begin
			path := sharedFolders[ i ];
			{ 15 feb 09: System files are no longer added to the shared files list >>> }
			err := findFirst( path + '*.*', faAnyFile and not (faVolumeId or faDirectory or faSysFile), sr );
			(* err := findFirst( path + '*.*', faAnyFile and not (faVolumeId or faDirectory), sr ); *)
			{ <<< 15 feb 09: System files are no longer added to the shared files list }
			try
				while err = 0 do
					begin
					{ 15 feb 09: emule0.49c: Share/unshare single files >>> }
					if not sharedFolders.excludedFiles.find( path + sr.name, n ) then
						addSharedFile( path, sr );
(*						begin
						new( p );
						p^.sizeRec.lo := sr.findData.nFileSizeLow;
						p^.sizeRec.hi := sr.findData.nFileSizeHigh;
						p^.dateM := sr.findData.ftLastWriteTime;
						p^.dateC := sr.findData.ftCreationTime;
						p^.path := path;
						p^.attr := sr.attr;
						shared.addObject( sr.name, tObject( p ) );
						end;
*)					{ <<< 15 feb 09: emule0.49c: Share/unshare single files }
					err := findNext( sr );
					end;
				finally findClose( sr );
				end;
			end;
		{ 15 feb 09: emule0.49c: Share/unshare single files >>> }
		for i := 0 to pred( sharedFolders.includedFiles.count ) do
			begin
			path := sharedFolders.includedFiles[ i ];
			err := findFirst( path, faAnyFile and not (faVolumeId or faDirectory or faSysFile), sr );
			try
				if err = 0 then addSharedFile( extractFilePath( path ), sr );
				finally findClose( sr );
				end;
			end;
		{ <<< 15 feb 09: emule0.49c: Share/unshare single files }
	end;

	function sameDate( knownMetTime: tCFileDate; sharedData: pSharedData ): boolean;
	var
		dt1, dt2: tDateTime;
		st: tSystemTime;
		n: int64;
	begin
		dt1 := encodeDateTime( 1970, 1, 1, 0, 0, 0, 0 );
		dt1 := incSecond( dt1, knownMetTime );
		fileTimeToSystemTime( sharedData.dateM, st );
		if st.wMilliseconds = 0 then st.wMilliseconds := 1;
		dt2 := systemTimeToDateTime( st );
		n := abs( secondsBetween( dt2, dt1 ) );
		result := (n = 0) or (n = 3600) or (n = 7200) or (n = 10800) or (n = 14400) or (n = 18000) or (n = 21600);
	end;

	function getSharedIndex: integer;
	var
		i, p: integer;
	begin
		result := -1;
		if shared.find( fName, p ) then
			begin
			for i := p to pred( shared.count ) do
				if ((i = p) or sameText( fName, shared[ i ] ))
				and (fSize = pSharedData( shared.objects[ i ] )^.size)
				and sameDate( rec.utcLastModified, pSharedData( shared.objects[ i ] ) )
				{ 15 feb 09: System files are no longer added to the shared files list >>> }
				(*
					{ 11 mar 07: Bug fix: Known files with the System attribute cannot be shared >>> }
					and (pSharedData( shared.objects[ i ] )^.attr and faSysFile = 0)
					{ <<< 11 mar 07: Bug fix: Known files with the System attribute cannot be shared }
				*)
				{ <<< 15 feb 09: System files are no longer added to the shared files list }
				then
					begin
					result := i;
					break;
					end;
			if result < 0 then for i := pred( p ) downTo 0 do
				if sameText( fName, shared[ i ] )
				and (fSize = pSharedData( shared.objects[ i ] )^.size)
				and sameDate( rec.utcLastModified, pSharedData( shared.objects[ i ] ) )
				{ 15 feb 09: System files are no longer added to the shared files list >>> }
				(*
					{ 11 mar 07: Bug fix: Known files with the System attribute cannot be shared >>> }
					and (pSharedData( shared.objects[ i ] )^.attr and faSysFile = 0)
					{ <<< 11 mar 07: Bug fix: Known files with the System attribute cannot be shared }
				*)
				{ <<< 15 feb 09: System files are no longer added to the shared files list }
				then
					begin
					result := i;
					break;
					end;
			end;
	end;

begin
	cr := screen.cursor;
	screen.cursor := crHourGlass;

	refKF1 := nil;
	refKF2 := nil;

	try

		result := true;
		try

			{ 24 sept 07: optimization (thanks to raindrop): } knownFilesList.items.beginUpdate;
			knownFilesList.clear;
			shared := tStringList.create;
			try
				loadShared;

				for i := 0 to pred( knownMet.list.count ) do
					begin
					rec := knownMet.list.records[ i ];

					if (logFiles.state[ rec.hash.hashStr ] = lsNone) and aKFShowLogged.checked then continue;

					fSize := rec.fileSize;
					fName := rec.fileName;

					isShared := getSharedIndex;
					if (isShared < 0) and aKFShowShared.checked then continue;

					isDownloaded := rec.isDownloadedFile;

					knownFilesList.addItem( knownMet.list[ i ], rec );
					item := knownFilesList.items[ pred( knownFilesList.items.count ) ];
					subItemsText := '';

					case logFiles.state[ rec.hash.hashStr ] of
						lsInactive:	subItemsText := subItemsText + rsInactiveLogCaption + #13;
						lsActive:	subItemsText := subItemsText + rsActiveLogCaption + #13;
						else		subItemsText := subItemsText + rsNoLogCaption + #13;
						end;

					v := fSize;
					subItemsText := subItemsText + format( '%.0n', [v] ) + #13;

					if isShared >= 0 then subItemsText := subItemsText + rsYes + #13
					else subItemsText := subItemsText + rsNo + #13;

					v := rec.transferred;
					subItemsText := subItemsText + format( '%.0n', [v] ) + #13;

					subItemsText := subItemsText + rec.hash.hashStr + #13;

					if isShared >= 0 then
						begin
						try
							ft1 := pSharedData( shared.objects[ isShared ] )^.dateM;
							fileTimeToLocalFileTime( ft1, ft2 );
							fileTimeToSystemTime( ft2, st );
							dt1 := systemTimeToDateTime( st );
							except dt1 := 0;
							end;
						try
							ft1 := pSharedData( shared.objects[ isShared ] )^.dateC;
							fileTimeToLocalFileTime( ft1, ft2 );
							fileTimeToSystemTime( ft2, st );
							dt2 := systemTimeToDateTime( st );
							except dt2 :=0;
							end;
						end
					else
						begin
						dt1 := 0;
						dt2 := 0;
						end;

					isDownloaded2 := ord( isDownloaded ) * 3;
					if (dt1 <> 0) and (dt2 <> 0) and not isDownloaded then
						begin
						if compareDateTime( dt1, dt2 ) > 0 then
							begin
							inc( isDownloaded2 );
							if secondsBetween( dt1, dt2 ) >= minDLSecs then
								inc( isDownloaded2 );
							end;
						end;

					case isDownloaded2 of
						0:		subItemsText := subItemsText + rsNo + #13;
						1:		subItemsText := subItemsText + rsMaybeNo + #13;
						2:		subItemsText := subItemsText + rsMaybeYes + #13;
						else	subItemsText := subItemsText + rsYes + #13;
						end;

					s := '';
					if (isShared >= 0) and (dt1 > 0) then
						begin
						try
							s := dateTimeToStr( dt1 );
							except s := '';
							end;
						end;
					subItemsText := subItemsText + s + #13;

					if isShared >= 0 then
						subItemsText := subItemsText + pSharedData( shared.objects[ isShared ] )^.path + #13
					else
						subItemsText := subItemsText + #13;

					s := '';
					dlTime := -1;
					if (isDownloaded2 > 0) and (dt1 <> 0) and (dt2 <> 0) then
						begin
						try

							n1 := daysBetween( dt1, dt2 );
							if n1 > 0 then
								begin
								s := intToStr( n1 ) + ' ' + rsDays + ' ';
								dt2 := incDay( dt2, n1 );
								end;
							n2 := hoursBetween( dt1, dt2 );
							if n2 > 0 then dt2 := incHour( dt2, n2 );
							n3 := round( minuteSpan( dt1, dt2 ) );
							if (n2 > 0) or (n1 > 0) then s := s + format( '%.2d', [n2] ) + ' ' + rsHours + ' ';
							s := s + format( '%.2d', [n3] ) + ' ' + rsMinutes;
							dlTime := (n1 * 24 + n2) * 60 + n3;
							except ;
							end;
						end;
					subItemsText := subItemsText + s + #13;

					item.subItems.text := subItemsText;
					knownFilesList.cellDataFromTag[ item, kfColDLTime ] := pointer( dlTime );
					end;

				finally
					{ 24 sept 07: optimization (thanks to raindrop): } knownFilesList.items.endUpdate;
					for i := 0 to pred( shared.count ) do dispose( pSharedData( shared.objects[ i ] ) );
					shared.free;
				end;

			for i := 0 to pred( knownFilesList.items.count ) do
				begin
				if logFiles.state[ tKnownMetRecord( knownFilesList.items[ i ].data ).hash.hashStr ] = lsActive then
					knownFilesList.items[ i ].checked := true;
				end;

			kfCompleteSort := true;
			knownFilesList.alphaSort;
			kfCompleteSort := false;

			if knownFilesList.items.count > 0 then knownFilesList.items[ 0 ].focused := true;

			except result := false;
			end;

		finally screen.cursor := cr;
		end;
end;

procedure tMainForm.timerTimer(Sender: TObject);
var
	ok: boolean;
	cr: tCursor;
begin
	timer.enabled := false;

	cr := screen.cursor;
	screen.cursor := crHourGlass;
	try

		ok := true;

		{ update sharedFolders list }
		if sharedFolders.needUpdateIncoming then
			begin
			sharedFolders.updateIncoming;
			if not sharedFolders.loadedIncoming then ok := false;
			end;
		if sharedFolders.needUpdateSharedDir then
			begin
			sharedFolders.updateSharedDir;
			if not sharedFolders.loadedSharedDir then ok := false;
			end;
		{ 15 feb 09: emule0.49c: Share/unshare single files >>> }
		if sharedFolders.needUpdateSharedFiles then
			begin
			sharedFolders.updateSharedFiles;
			if not sharedFolders.loadedSharedFiles then ok := false;
			end;
		{ <<< 15 feb 09: emule0.49c: Share/unshare single files }
		if sharedFolders.needUpdateCategory then
			begin
			sharedFolders.updateCategory;
			if not sharedFolders.loadedCategory then ok := false;
			end;

		{ update knownMet list (only if sharedFolders list is uptodate) }
		if ok and knownMet.needUpdate then
			begin
			knownMet.load;
			if knownMet.list = nil then ok := false;
			end;

		if ok then
			begin
			logFiles.load;
			{ populate the listviews }
			ok := knownMetLoaded;
			logFilesLoaded;
			end;
		if not ok then { if at least one list has not been updated, try again in 2 seconds }
			begin
			timer.interval := timer_retry;
			timer.enabled := true;
			end;

		finally screen.cursor := cr;
		end;

	if justStarted and not timer.enabled and (getIniInt( ikShowTips, 1 ) <> 0) then
		begin
		justStarted := false;
		aHlpTips.execute;
		end;
end;

procedure tMainForm.aKFReloadExecute(Sender: TObject);
begin
	timer.interval := timer_init;
	timer.enabled := true;
end;

procedure tMainForm.eMuleStatsListCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
var
	i: integer;
	iCol: integer;
begin
	for i := 0 to iniColMax do
		begin
		iCol := pred( abs( iniSortOrder[ i ] ) );
		if iCol = iniColValue then
			compare := ansiCompareText( item1.caption, item2.caption )
		else if iCol = iniColLog then
			compare := ord( tLogFile( item2.data ).state ) - ord( tLogFile( item1.data ).state )
		else
			compare := ansiCompareText( eMuleStatsList.cellFromTag[ item1, iCol ], eMuleStatsList.cellFromTag[ item2, iCol ] );
		if iniSortOrder[ i ] < 0 then compare := - compare;
		if (compare <> 0) or not iniCompleteSort then exit;
		end;
end;

procedure tMainForm.knownFilesListCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
var
	i: integer;
	iCol: integer;
	s1, s2: string;
	l: int64;
	dt1, dt2: tDateTime;
	d: double;
begin
	for i := 0 to kfColMax do
		begin
		iCol := pred( abs( kfSortOrder[ i ] ) );
		if iCol = kfColName then
			compare := ansiCompareText( item1.caption, item2.caption )
		else
			begin
			if (iCol in [kfColSize, kfColTransferred]) then
				begin
				s1 := stringReplace( knownFilesList.cellFromTag[ item1, iCol ], thousandSeparator, '', [rfReplaceAll] );
				if s1 = '' then s1 := '0';
				s2 := stringReplace( knownFilesList.cellFromTag[ item2, iCol ], thousandSeparator, '', [rfReplaceAll] );
				if s2 = '' then s2 := '0';
				l := strToInt64( s1 ) - strToInt64( s2 );
				if l > 0 then compare := 1
				else if l < 0 then compare := -1
				else compare := 0;
				end
			else if (iCol in [kfColDate]) then
				begin
				s1 := knownFilesList.cellFromTag[ item1, iCol ];
				if s1 = '' then dt1 := 0 else dt1 := strToDateTime( s1 );
				s2 := knownFilesList.cellFromTag[ item2, iCol ];
				if s2 = '' then dt2 := 0 else dt2 := strToDateTime( s2 );
				d := dt1 - dt2;
				if d > 0 then compare := 1
				else if d < 0 then compare := -1
				else compare := 0;
				end
			else if (iCol in [kfColDLTime]) then
				compare := integer( knownFilesList.cellDataFromTag[ item1, iCol ] ) - integer( knownFilesList.cellDataFromTag[ item2, iCol ] )
			else
				compare := ansiCompareText( knownFilesList.cellFromTag[ item1, iCol ], knownFilesList.cellFromTag[ item2, iCol ] );
			end;
		if kfSortOrder[ i ] < 0 then compare := - compare;
		if (compare <> 0) or not kfCompleteSort then exit;
		end;
end;

procedure tMainForm.eMuleStatsListContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
	if iniColumnRightClicked then
		begin
		handled := true;
		iniColumnRightClicked := false;
		end;
end;

procedure tMainForm.knownFilesListContextPopup(Sender: TObject; MousePos: TPoint; var Handled: Boolean);
begin
	if kfColumnRightClicked then
		begin
		handled := true;
		kfColumnRightClicked := false;
		end;
end;

procedure tMainForm.eMuleStatsListColumnRightClick(Sender: TObject; Column: TListColumn; Point: TPoint);
var
	i: integer;
begin
	iniColumnRightClicked := true;
	for i := 0 to iniColMax do
		if pred( abs( iniSortOrder[ i ] ) ) = column.tag then
			begin
			iniSortOrder[ i ] := -iniSortOrder[ i ];
			if iniSortOrder[ i ] < 0 then column.imageIndex := succ( column.imageIndex )
			else column.imageIndex := pred( column.imageIndex );
			iniCompleteSort := true;
			eMuleStatsList.alphaSort;
			iniCompleteSort := false;
			exit;
			end;
end;

procedure tMainForm.knownFilesListColumnRightClick(Sender: TObject; Column: TListColumn; Point: TPoint);
var
	i: integer;
begin
	kfColumnRightClicked := true;
	for i := 0 to kfColMax do
		if pred( abs( kfSortOrder[ i ] ) ) = column.tag then
			begin
			kfSortOrder[ i ] := -kfSortOrder[ i ];
			if kfSortOrder[ i ] < 0 then column.imageIndex := succ( column.imageIndex )
			else column.imageIndex := pred( column.imageIndex );
			kfCompleteSort := true;
			knownFilesList.alphaSort;
			kfCompleteSort := false;
			exit;
			end;
end;

procedure tMainForm.eMuleStatsListColumnDragged(Sender: TObject);
begin
	{ the 1st column must not be moved... }
	if eMuleStatsList.columnFromTag[ iniColValue ].index > 0 then eMuleStatsList.columnFromTag[ iniColValue ].index := 0;
end;

procedure tMainForm.knownFilesListColumnDragged(Sender: TObject);
begin
	{ the 1st column must not be moved... }
	if knownFilesList.columnFromTag[ kfColName ].index > 0 then knownFilesList.columnFromTag[ kfColName ].index := 0;
end;

procedure tMainForm.eMuleStatsListColumnClick(Sender: TObject; Column: TListColumn);
var
	i, ii: integer;
	b: boolean;
	s: integer;
begin
	b := false;
	s := 0;
	for i := iniColMax downTo 1 do
		begin
		if abs( iniSortOrder[ i ] ) = succ( column.tag ) then
			begin
			b := true;
			s := iniSortOrder[ i ];
			end;
		if b then
			iniSortOrder[ i ] := iniSortOrder[ pred( i ) ];
		end;
	if abs( iniSortOrder[ 0 ] ) = succ( column.tag ) then iniSortOrder[ 0 ] := -iniSortOrder[ 0 ]
	else if s <> 0 then iniSortOrder[ 0 ] := s
	else iniSortOrder[ 0 ] := succ( column.tag );
	for i := 0 to iniColMax do
		begin
		ii := i * 2 + 1;
		if iniSortOrder[ i ] < 0 then inc( ii );
		eMuleStatsList.columnFromTag[ pred( abs( iniSortOrder[ i ] ) ) ].imageIndex := ii;
		end;
	eMuleStatsList.alphaSort;
end;

procedure tMainForm.knownFilesListColumnClick(Sender: TObject; Column: TListColumn);
var
	i, ii: integer;
	b: boolean;
	s: integer;
begin
	b := false;
	s := 0;
	for i := kfColMax downTo 1 do
		begin
		if abs( kfSortOrder[ i ] ) = succ( column.tag ) then
			begin
			b := true;
			s := kfSortOrder[ i ];
			end;
		if b then
			kfSortOrder[ i ] := kfSortOrder[ pred( i ) ];
		end;
	if abs( kfSortOrder[ 0 ] ) = succ( column.tag ) then kfSortOrder[ 0 ] := -kfSortOrder[ 0 ]
	else if s <> 0 then kfSortOrder[ 0 ] := s
	else kfSortOrder[ 0 ] := succ( column.tag );
	for i := 0 to kfColMax do
		begin
		ii := i * 2 + 1;
		if kfSortOrder[ i ] < 0 then inc( ii );
		knownFilesList.columnFromTag[ pred( abs( kfSortOrder[ i ] ) ) ].imageIndex := ii;
		end;
	knownFilesList.alphaSort;
end;

procedure tMainForm.eMuleStatsListChanging(Sender: TObject; Item: TListItem; Change: TItemChange; var AllowChange: Boolean);
begin
	if change = ctState then
		begin
		iniChangingListItem := item;
		iniChangingListItemChecked := item.checked;
		end;
end;

procedure tMainForm.knownFilesListChanging(Sender: TObject; Item: TListItem; Change: TItemChange; var AllowChange: Boolean);
begin
	if change = ctState then
		begin
		kfChangingListItem := item;
		kfChangingListItemChecked := item.checked;
		end;
end;

procedure tMainForm.eMuleStatsListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
	if (item <> nil) and (change = ctState) and (item = iniChangingListItem) and (item.checked <> iniChangingListItemChecked) then
		eMuleStatsList_onCheckItem( sender, item );
end;

procedure tMainForm.knownFilesListChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
	if (item <> nil) and (change = ctState) and (item = kfChangingListItem) and (item.checked <> kfChangingListItemChecked) then
		knownFilesList_onCheckItem( sender, item );
end;

procedure tMainForm.eMuleStatsList_onCheckItem( sender: tObject; item: tListItem );
var
	logName: string;
	check: boolean;
	it: tListItem;
	logFile: tLogFile;
begin
	if iniSkipOnCheckItem or (item.data = nil) or (logFiles.count = 0) then exit;
	iniSkipOnCheckItem := true;
	try
		check := item.checked;
		if (eMuleStatsList.selCount > 1) and item.selected then it := eMuleStatsList.selected
		else it := item;
		while it <> nil do
			begin
			logFile := tLogFile( it.data );
			logName := logFile.name;

			if check then
				begin
				if not it.checked or (it = item) then
					begin
					if logFile.state <> lsPermanent then
						begin
						logFiles.state[ logName ] := lsActive;
						eMuleStatsList.cellFromTag[ it, iniColLog ] := rsActiveLogCaption;
						end;
					it.checked := true;
					end;
				end
			else { if not check then }
				begin
				if getKeyState( vk_control ) < 0 then
					begin
					item.checked := true;
					if item.selected then aIniDelLog.execute
					else iniDelThisLog( item );
					break;
					end
				else if it.checked or (it = item) then
					begin
					if logFile.state = lsPermanent then
						it.checked := true
					else
						begin
						logFiles.state[ logName ] := lsInactive;
						eMuleStatsList.cellFromTag[ it, iniColLog ] := rsInactiveLogCaption;
						it.checked := false;
						end;
					end;
				end;

			if (eMuleStatsList.selCount > 1) and item.selected then it := eMuleStatsList.getNextItem( it, sdAll, [isSelected] )
			else break;
			end;
		finally iniSkipOnCheckItem := false;
		end;
end;

procedure tMainForm.knownFilesList_onCheckItem( sender: tObject; item: tListItem );
var
	logName: string;
	check: boolean;
	it: tListItem;
	newLogs: boolean;
	dw: dWord;
begin
	if kfSkipOnCheckItem or (item.data = nil) then exit;
	kfSkipOnCheckItem := true;
	newLogs := false;
	try
		check := item.checked;
		if (knownFilesList.selCount > 1) and item.selected then it := knownFilesList.selected
		else it := item;
		while it <> nil do
			begin
			logName := tKnownMetRecord( it.data ).hash.hashStr;

			if check then
				begin
				if not it.checked or (it = item) then
					begin
					if logFiles.state[ logName ] = lsNone then
						begin
						logFiles.createLogFile( logName, lsActive, ltKnownFile );
						newLogs := true;
						end;
					logFiles.state[ logName ] := lsActive;
					knownFilesList.cellFromTag[ it, kfColLog ] := rsActiveLogCaption;
					it.checked := true;
					end;
				end
			else { if not check then }
				begin
				if getKeyState( vk_control ) < 0 then
					begin
					item.checked := true;
					if item.selected then aKFDelLog.execute
					else kfDelThisLog( item );
					break;
					end
				else if it.checked or (it = item) then
					begin
					logFiles.state[ logName ] := lsInactive;
					knownFilesList.cellFromTag[ it, kfColLog ] := rsInactiveLogCaption;
					it.checked := false;
					end;
				end;

			if (knownFilesList.selCount > 1) and item.selected then it := knownFilesList.getNextItem( it, sdAll, [isSelected] )
			else break;
			end;
		finally
			if newLogs then
				begin
				dw := bsm_applications;
				broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, newLogsMsg, 0, 0 );
				end;
			kfSkipOnCheckItem := false;
		end;
end;

procedure tMainForm.listViewKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
	item: tListItem;
	r: tRect;
	pt: tPoint;
	h: integer;
begin
	item := tListView( sender ).itemFocused;
	if (key = vk_space) and (item <> nil) then
		begin
		if item.selected then
			begin
			item.checked := not item.checked;
			key := 0;
			end
		else
			begin
			item.selected := true;
			key := 0;
			end;
		end
	else if key = vk_apps then
		begin
		item := tListView( sender ).selected;
		if item = nil then
			begin
			pt.x := 0;
			pt.y := 0;
			end
		else
			begin
			r := item.displayRect( drLabel );
			pt.x := r.left + (r.right - r.left) div 2;
			if pt.x < 0 then pt.x := 0
			else if pt.x > tListView( sender ).width - 4 then pt.x := tTreeView( sender ).width - 4;
			h := (r.bottom - r.top) div 2;
			pt.y := r.top + h;
			if pt.y < h then pt.y := h
			else if pt.y > tListView( sender ).height - h then pt.y := tListView( sender ).height - h;
			end;
		windows.clientToScreen( tListView( sender ).handle, pt );
		tListView( sender ).popupMenu.Popup( pt.x, pt.y );
		end;
end;

procedure tMainForm.aIniDelLogExecute(Sender: TObject);
var
	item, it: tListItem;
	logName: string;
	logFile: tLogFile;
begin
	if application.messageBox( pChar( msgAskDeleteLogs ), pChar( appFullName ), mb_OkCancel or mb_iconQuestion ) = idOk then
		begin
		iniSkipOnCheckItem := true;
		try
			item := eMuleStatsList.selected;
			while item <> nil do
				begin
				logFile := tLogFile( item.data );
				if logFile.state <> lsPermanent then
					begin
					logName := logFile.name;
					logFiles.state[ logName ] := lsNone;
					it := item;
					end
				else
					it := nil;
				item := eMuleStatsList.getNextItem( item, sdAll, [isSelected] );
				if it <> nil then eMuleStatsList.Items.delete( it.index );
				end;
			finally iniSkipOnCheckItem := false;
			end;
		graphsNeedRedraw := true;
		end;
end;

procedure tMainForm.iniDelThisLog( item: tListItem );
var
	logName: string;
	logFile: tLogFile;
begin
	if (item = nil) or (item.data = nil) then exit;
	if application.messageBox( pChar( msgAskDeleteLog ), pChar( appFullName ), mb_OkCancel or mb_iconQuestion ) = idOk then
		begin
		iniSkipOnCheckItem := true;
		try
			logFile := tLogFile( item.data );
			if logFile.state <> lsPermanent then
				begin
				logName := logFile.name;
				logFiles.state[ logName ] := lsNone;
				eMuleStatsList.Items.delete( item.index );
				end;
			finally iniSkipOnCheckItem := false;
			end;
		graphsNeedRedraw := true;
		end;
end;

procedure tMainForm.aKFDelLogExecute(Sender: TObject);
var
	item: tListItem;
	logName: string;
begin
	if application.messageBox( pChar( msgAskDeleteLogs ), pChar( appFullName ), mb_OkCancel or mb_iconQuestion ) = idOk then
		begin
		kfSkipOnCheckItem := true;
		try
			item := knownFilesList.selected;
			while item <> nil do
				begin
				item.checked := false;
				logName := tKnownMetRecord( item.data ).hash.hashStr;
				logFiles.state[ logName ] := lsNone;
				knownFilesList.cellFromTag[ item, kfColLog ] := rsNoLogCaption;
				item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
				end;
			finally kfSkipOnCheckItem := false;
			end;
		graphsNeedRedraw := true;
		end;
end;

procedure tMainForm.kfDelThisLog( item: tListItem );
var
	logName: string;
begin
	if (item = nil) or (item.data = nil) then exit;
	if application.messageBox( pChar( msgAskDeleteLog ), pChar( appFullName ), mb_OkCancel or mb_iconQuestion ) = idOk then
		begin
		kfSkipOnCheckItem := true;
		try
			item.checked := false;
			logName := tKnownMetRecord( item.data ).hash.hashStr;
			logFiles.state[ logName ] := lsNone;
			knownFilesList.cellFromTag[ item, kfColLog ] := rsNoLogCaption;
			finally kfSkipOnCheckItem := false;
			end;
		graphsNeedRedraw := true;
		end;
end;

procedure tMainForm.aIniDelLogUpdate(Sender: TObject);
var
	item: tListItem;
	logFile: tLogFile;
	ok: boolean;
begin
	item := eMuleStatsList.selected;
	ok := false;
	while not ok and (item <> nil) do
		begin
		logFile := tLogFile( item.data );
		if not (logFile.state in [lsNone, lsPermanent]) then
			ok := true;
		item := eMuleStatsList.getNextItem( item, sdAll, [isSelected] );
		end;
	tAction( sender ).enabled := ok;
end;

procedure tMainForm.aKFDelLogUpdate(Sender: TObject);
var
	item: tListItem;
	logName: string;
	ok: boolean;
begin
	item := knownFilesList.selected;
	ok := false;
	while not ok and (item <> nil) do
		begin
		logName := tKnownMetRecord( item.data ).hash.hashStr;
		if logFiles.state[ logName ] <> lsNone then
			ok := true;
		item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
		end;
	tAction( sender ).enabled := ok;
end;

procedure tMainForm.aKFShowExecute(Sender: TObject);
begin
	aKFShowAll.checked := false;                                             
	aKFShowShared.checked := false;
	aKFShowLogged.checked := false;
	tAction( sender ).checked := true;
	timer.interval := timer_init;
	timer.enabled := true;
end;

procedure tMainForm.bottomPanelResize(Sender: TObject);
begin
	requestsChart.height := (statsTab.clientHeight - zoomBar.height - scrollBar.height) div 2;
	if not legendDockablePanel.floating then
		begin
		requestsLegend.height := requestsChart.height;
		transfersLegend.height := transferredChart.height;
		end;
end;

procedure tMainForm.appEventsIdle(Sender: TObject; var Done: Boolean);
begin
	if not application.terminated then
		begin
		if graphsNeedRedraw then
			begin
			graphsNeedRedraw := false;
			drawGraphics;
			end;
		if tagsNeedRedraw then
			begin
			tagsNeedRedraw := false;
			showTags;
			end;
		if updateValuesAtCursor then
			begin
			showValuesAtCursor( nil );
			updateValuesAtCursor := false;
			end;
		end;
	done := true;
end;

procedure tMainForm.eMuleStatsListSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
	if not application.terminated then
		begin
		if (logFiles.count > 0) and not item.deleting then tLogFile( item.data ).color := clWindow;
		graphsNeedRedraw := true;
		end;
end;

procedure tMainForm.knownFilesListSelectItem(Sender: TObject; Item: TListItem; Selected: Boolean);
begin
	if not application.terminated then
		begin
		if (knownMet.list <> nil) and not item.deleting then tKnownMetRecord( item.data ).color := clWindow;
		graphsNeedRedraw := true;
		tagsNeedRedraw := true;
		end;
end;

procedure tMainForm.showTags;

	procedure showTagsOf( rec: tKnownMetRecord );
	var
		s: string;
		i: integer;
		v: double;
	begin
		s := 'HASH';
		while length( s ) < 33 do s := s + ' ';
		s := s + 'HASH';
		while length( s ) < 43 do s := s + ' ';
		s := s + rec.hash.hashStr;
		tagsBox.lines.text := tagsBox.lines.text + s + #13#10;

		for i := 0 to pred( rec.tagCount ) do with rec.tag[ i ] do
			begin
			{ tag title }
			s := '';
			if m_uName <> 0 then
				begin
				if tagNames[ m_uName ] <> '' then s :=  s + tagNames[ m_uName ]
				else s := s + intToStr( m_uName );
				end
			else if m_pszName <> nil then
				s := s + m_pszName;
			if length( s ) > 32 then setLength( s, 32 );
			while length( s ) < 33 do s := s + ' ';

			{ tag type }
			case m_uType of
				TAGTYPE_HASH:		s := s + 'HASH';
				TAGTYPE_STRING:		s := s + 'STRING';
				TAGTYPE_UINT32:		s := s + 'UINT32';
				TAGTYPE_FLOAT32:	s := s + 'FLOAT32';
				TAGTYPE_BOOL:		s := s + 'BOOL';
				TAGTYPE_BOOLARRAY:	s := s + 'BOOLARRAY';
				TAGTYPE_BLOB:		s := s + 'BLOB';
				TAGTYPE_UINT16:		s := s + 'UINT16';
				TAGTYPE_UINT8:		s := s + 'UINT8';
				TAGTYPE_BSOB:		s := s + 'BSOB';
				TAGTYPE_UINT64:		s := s + 'UINT64';
				end;
			while length( s ) < 43 do s := s + ' ';

			{ tag value }
			case m_uType of
				TAGTYPE_STRING:		s := s + m_pstrVal;
				TAGTYPE_UINT32:		begin
									v := m_uVal;
									s := s + format( '%.0n', [v] );
									end;
				TAGTYPE_UINT64:		begin
									v := m_uVal;
									s := s + format( '%.0n', [v] );
									end;
				TAGTYPE_FLOAT32:	s := s + floatToStr( m_fVal );
				end;

			tagsBox.lines.text := tagsBox.lines.text + s + #13#10;
			end;
	end;

var
	item: tListItem;
	rec: tKnownMetRecord;
	n: integer;
	step: integer;
begin 
	tagsBox.lines.text := '';
	n := 0;
	step := 0;
	item := refKF1;
	while ((item <> nil) or (step < 2)) and (n < maxDisplayedTags) do
		begin
		if (item <> nil) and ((item <> refKF1) and (item <> refKF2) or (step < 2)) then
			begin
			rec := tKnownMetRecord( item.data );
			inc( n );
			if n > 1 then tagsBox.lines.text := tagsBox.lines.text + #13#10 + stringOfChar( '-', 200 ) + #13#10#13#10;
			showTagsOf( rec );
			end;
		case step of
			0: item := refKF2;
			1: item := knownFilesList.selected;
			else item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
			end;
		inc( step );
		end;
end;

procedure tMainForm.drawGraphics;
var
	eMuleTime: boolean; { true if "eMule runtime days" is selected; false otherwise }
	kfLogsList,
	iniLogsList: tList; { the lists of displayed logs }
	fdBeg, fdEnd: tFileDate; { first and last dates of the selected knownFiles logs, or, if none is selected, first and last dates of the selected iniFiles logs }
	dtBeg, dtEnd: tDateTime; { first and last dates to be displayed on the graphs, depending on the scrollbars positions; Only valid if "real date" is selected }
	etBeg, etEnd: tEmuleRuntime; { first and last dates to be displayed on the graphs, depending on the scrollbars positions; Only valid if "eMule runtime days" is selected }
	logDates: tLogDates; { the dates for each point in the graph; Only valid if "real date" is selected }
	logTimes: tLogTimes; { the dates for each point in the graph; Only valid if "eMule runtime days" is selected }
	points: integer; { the number of points in the graph }
	indexReq, indexTrn: integer;
	i: integer;
	cr: tCursor;

	procedure clearSeries;
	var
		i: integer;
	begin
		requestsLegend.clear;
		transfersLegend.clear;
		for i := pred( requestsChart.seriesCount ) downTo 0 do
			begin
			requestsChart.series[ i ].clear;
			requestsChart.series[ i ].xValues.dateTime := not eMuleTime;
			end;

		for i := pred( transferredChart.seriesCount ) downTo 0 do
			begin
			transferredChart.series[ i ].clear;
			transferredChart.series[ i ].xValues.dateTime := not eMuleTime;
			end;

		if eMuleTime then transferredChart.bottomAxis.title.caption := rsRuntimeXAxis
		else transferredChart.bottomAxis.title.caption := rsDateXAxis;
	end;

	procedure kfLoadLogs; { load the selected knownFiles logs which will be displayed -> kfLogsList }
	var
		item: tListItem;
		rec: tKnownMetRecord;
		logFile: tLogFile;
		i: integer;
		step: integer;

		procedure addLegend( rec: tKnownMetRecord; reqColor, accColor: tColor );
		begin
			requestsLegend.selAttributes.color := rec.color;
			requestsLegend.selText := format( rsKFLegendReq1, [rec.fileName] );
			requestsLegend.selAttributes.color := reqColor;
			requestsLegend.selText := rsKFLegendReq2;
			requestsLegend.selAttributes.color := rec.color;
			requestsLegend.selText := rsKFLegendReq3;
			requestsLegend.selAttributes.color := accColor;
			requestsLegend.selText := rsKFLegendReq4;
			requestsLegend.selAttributes.color := rec.color;
			requestsLegend.selText := rsKFLegendReq5;

			transfersLegend.selAttributes.color := rec.color;
			transfersLegend.selText := format( rsKFLegendTransferred, [rec.fileName] );
		end;

	begin
		for i := 0 to pred( knownMet.list.count ) do { mark all the logs as "not displayed" }
			knownMet.list.records[ i ].color := clWindow;

		step := 0;
		item := nil;
		repeat
			case step of
				0: item := refKF1; { 1st reference file }
				1: item := refKF2; { 2nd reference file }
				2: item := knownFilesList.selected; { 1st selected file }
				else item := knownFilesList.getNextItem( item, sdAll, [isSelected] ); { next selected file }
				end;
			if (item <> nil) and ((item <> refKF1) or (step = 0)) and ((item <> refKF2) or (step = 1)) then
				begin
				rec := tKnownMetRecord( item.data );
				logFile := logFiles.logFromName[ rec.hash.hashStr ];
				if logFile <> nil then
					begin
					if kfLogsList.count < maxDisplayedKF then
						begin
						logFile.load;
						if (logFile.logLen < 4) then { ignore logs with less than 4 points -> nothing would be displayed }
							logFile.unload
						else { add the log to the displayed logs list }
							begin
							kfLogsList.add( logFile );
							rec.color := transferredChart.series[ kfLogsList.count ].seriesColor;
							addLegend( rec, requestsChart.series[ kfLogsList.count * 2 - 1 ].seriesColor, requestsChart.series[ kfLogsList.count * 2 ].seriesColor );
							end;
						end;
					end;
				end;
			inc( step );
		until ((item = nil) and (step >= 3)) or (kfLogsList.count >= maxDisplayedKF);

		knownFilesList.repaint; { show the colors of the displayed files }
	end;

	procedure iniLoadLogs; { load the selected iniFiles logs which will be displayed -> iniLogsList }
	var
		item: tListItem;
		logFile: tLogFile;
		nReq, nTrn: integer;
		pn: pInteger;
		i: integer;

		procedure addLegend( logFile: tLogFile; legend: tRichEdit );
		begin
			legend.selAttributes.color := logFile.color;
			legend.selText := format( rsIniLegend, [logFile.iniCaption, logFile.units] );
		end;

	begin
		for i := 0 to pred( logFiles.count ) do { mark all the logs as "not displayed" }
			logFiles.log[ i ].color := clWindow;

		{ one counter for each chart }
		nReq := 0;
		nTrn := 0;

		item := eMuleStatsList.selected;
		while (item <> nil) and ((nReq < maxDisplayedIni) or (nTrn < maxDisplayedIni)) do
			begin
			logFile := tLogFile( item.data );
			if logFile.flags and lfShowWithRequests <> 0 then pn := @nReq else pn := @nTrn;
			if pn^ < maxDisplayedIni then
				begin
				logFile.load;
				if ((logFile.what <> lwCombinedLogs) and (logFile.logLen < 4))
				or ((logFile.what = lwCombinedLogs) and ((logFile.logs[ 0 ] = nil) or (logFile.logs[ 0 ].logLen < 4) or (logFile.logs[ 1 ] = nil) or (logFile.logs[ 1 ].logLen < 4))) then
				{ ignore logs with less than 4 points -> nothing would be displayed }
					begin
					if logFile <> logFiles.runtimeLog then
						logFile.unload;
					end
				else { add the log to the displayed logs list }
					begin
					iniLogsList.add( logFile );
					if logFile.flags and lfShowWithRequests <> 0 then
						begin
						logFile.color := requestsChart.series[ 1 + nReq + maxDisplayedKF * 2 ].seriesColor;
						addLegend( logFile, requestsLegend );
						end
					else
						begin
						logFile.color := transferredChart.series[ 1 + nTrn + maxDisplayedKF ].seriesColor;
						addLegend( logFile, transfersLegend );
						end;
					inc( pn^ );
					end;
				end;
			item := eMuleStatsList.getNextItem( item, sdAll, [isSelected] );
			end;

		eMuleStatsList.repaint; { show the colors of the displayed files }
	end;

	procedure getBegEnd; { calculate the first and last dates to be displayed on the graphs }
	var
		logFile: tLogFile;
		date: tFileDate;
		i: integer;
		recInt: pLogRecInteger;

		procedure testDates( logFile: tLogFile );
		begin
			{ first point in the log }
			date := pLogRec( logFile.log )^.date;
			if (date < fdBeg) or (fdBeg = -1) then
				fdBeg := date;
			{ last point in the log }
			case logFile.dataType of
				ltByte:		date := pLogRec( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecByte ) )^.date;
				ltWord:		date := pLogRec( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecWord ) )^.date;
				ltInteger:	date := pLogRec( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecInteger ) )^.date;
				ltInt64:	date := pLogRec( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecInt64 ) )^.date;
				else		date := pLogRec( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecReal ) )^.date;
				end;
			if (date > fdEnd) or (fdEnd = -1) then
				fdEnd := date;
		end;

	begin
		fdBeg := -1;
		fdEnd := -1;

		{ get the first and last dates from the displayed known files logs }
		for i := 0 to pred( kfLogsList.count ) do
			begin
			logFile := tLogFile( kfLogsList[ i ] );
			{ first point in the log }
			date := pLogRec( logFile.log ).date;
			if (date < fdBeg) or (fdBeg = -1) then
				fdBeg := date;
			{ last point in the log }
			date := pLogRec( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecKnownMet ) )^.date;
			if (date > fdEnd) or (fdEnd = -1) then
				fdEnd := date;
			end;

		{ if no known files log is displayed, get the first and last dates from the displayed ini files logs }
		if fdBeg = -1 then
			for i := 0 to pred( iniLogsList.count ) do
				begin
				logFile := tLogFile( iniLogsList[ i ] );
				if logFile.what <> lwCombinedLogs then
					testDates( logFile )
				else
					begin
					testDates( logFile.logs[ 0 ] );
					testDates( logFile.logs[ 1 ] );
					end;
				end;

		if eMuleTime then
			begin
			{ make sure that the first and last dates can be converted to emule runtime }
			logFile := logFiles.runtimeLog;
			{ first date in the runtime log }
			recInt := pLogRecInteger( logFile.log );
			if fdBeg < recInt^.date then fdBeg := recInt^.date;
			{ last date in the runtime log }
			recInt := pLogRecInteger( dWord( logFile.log ) + dWord( logFile.logSize ) - sizeOf( tLogRecInteger ) );
			if fdEnd > recInt^.date then fdEnd := recInt^.date;
			end;

		{ convert dates from tFileDate to tEmuleRuntime or tDateTime }
		if fdBeg <> -1 then
			begin
			if eMuleTime then etBeg := logFiles.runtimeAt[ fdBeg ]
			else dtBeg := fileDateToDateTime( fdBeg );
			end;
		if fdEnd <> -1 then
			begin
			if eMuleTime then etEnd := logFiles.runtimeAt[ fdEnd ]
			else dtEnd := fileDateToDateTime( fdEnd );
			end;
	end;

	{ returns the number of points to get a nice graph. if zoomed = false -> initializes the zoom scrollBar max position }
	function getPointsCount( zoomed: boolean ): integer;
	var
		secs: int64;
		r: tRect;
		w: integer;
		res: integer;
	begin
		if emuleTime then secs := etEnd - etBeg
		else secs := secondsBetween( dtEnd, dtBeg );
		res := round( secs / (11 * 60) ); { small logs -> 1 point every 11 min (known.met save period) }

		r := requestsChart.chartBounds;
		w := (r.right - r.left) div resampleThreshold; { large logs -> 1 point every resampleThreshold pixels }

		if res >= w then result := pred( w ) else result := res;
		if result = 0 then result := 1;

		if not zoomed then { initializes the zoom scrollBar max position }
			begin
			if res = 0 then zoomBar.max := zoomBar.min
			else zoomBar.max := res div result;
			end;
	end;

	{ calculates the first and last dates to be displayed, depending on the zoom and scroll scrollbars postions }
	procedure zoomAndScroll;
	var
		secs: int64;
	begin
		if eMuleTime then
			begin
			secs := etEnd - etBeg;
			etBeg := etBeg + round( (secs div zoomBar.position) * scrollBar.position / 10 );
			etEnd := etBeg + secs div zoomBar.position;
			end
		else
			begin
			secs := secondsBetween( dtEnd, dtBeg );
			dtBeg := incSecond( dtBeg, round( (secs div zoomBar.position) * scrollBar.position / 10 ) );
			dtEnd := incSecond( dtBeg, secs div zoomBar.position );
			end;
	end;

	{ calculate the dates for each point in the graph }
	procedure calcDates( points: integer );
	var
		dt: tDateTime;
		interval: int64;
		i: integer;
		et: tEmuleRuntime;
	begin
		if eMuleTime then
			begin
			setLength( logTimes, points );
			interval := (etEnd - etBeg) div points;
			et := etBeg;
			for i := 0 to pred( points ) do
				begin
				logTimes[ i ] := et;
				inc( et, interval );
				end;
			end
		else
			begin
			setLength( logDates, points );
			interval := secondsBetween( dtEnd, dtBeg ) div points;
			dt := dtBeg;
			for i := 0 to pred( points ) do
				begin
				logDates[ i ] := dateTimeToFileDate( dt );
				dt := incSecond( dt, interval );
				end;
			end;
	end;

	{ Calculate the values at each date in logTimes/logDates for each displayed knownFile log, and add them to the graphs }
	procedure kfCalcValues( index, points: integer );
	var
		i, j, p, pp: integer;
		logFile: tLogFile;
		logData: pLogDataKnownMet;
		logCount: integer;
		dt1, dt3: tDateTime;
		et1, et2: tEmuleRuntime;
		dw1, dw2: dWord;
		l1, l2: int64;
	begin
		logFile := tLogFile( kfLogsList[ index ] );
		logData := pLogDataKnownMet( logFile.log );
		logCount := logFile.logLen;

		{$R-}
		for j := 0 to 2 do { requests, accepted, transferred }
			begin
			p := 0;

			if eMuleTime then
				begin

				{ search for the log value at point 0 }
				repeat
					inc( p );
					et1 := logFiles.runtimeAt[ logData^[ p ].date ];
				until (p >= logCount) or (et1 >= logTimes[ 0 ]);
				if p > 0 then dec( p );

				for i := 0 to pred( points ) do
					begin
					if (logTimes[ i ] >= logFiles.runtimeAt[ logData^[ 0 ].date ]) and (logTimes[ i ] <= logFiles.runtimeAt[ logData^[ pred( logCount ) ].date ]) then
						begin
						{ search for the log value at point i }
						pp := p;
						et1 := logFiles.runtimeAt[ logData^[ p ].date ];
						repeat
							inc( pp );
							et2 := logFiles.runtimeAt[ logData^[ pp ].date ];
						until (pp >= logCount) or ((et2 > logTimes[ i ]) and (et2 > et1));

						if pp < logCount then
							begin
							case j of
								{ requests rate per hour }
								0:		{ 28 apr 07: bug fix: support for corrupted known.met (lost known file stats) >>> }
										{ same change for accepted and transferred graphs below }
										begin
										dw1 := logData^[ p ].data.requested;
										dw2 := logData^[ pp ].data.requested;
										if dw1 > dw2 then dw1 := 0;
										requestsChart.series[ 1 + index * 2 ].AddXY(
											logTimes[ i ] / (3600 * 24),
											3600 * (dw2 - dw1) / (et2 - et1),
											'', clTeeColor
										);
										end;
{ old code:
										requestsChart.series[ 1 + index * 2 ].AddXY(
											logTimes[ i ] / (3600 * 24),
											3600 * (logData^[ pp ].data.requested - logData^[ p ].data.requested) / (et2 - et1),
											'', clTeeColor
										);
}										{ <<< 28 apr 07: bug fix: support for corrupted known.met (lost known file stats) }
								1:		begin
										dw1 := logData^[ p ].data.accepted;
										dw2 := logData^[ pp ].data.accepted;
										if dw1 > dw2 then dw1 := 0;
										requestsChart.series[ 1 + index * 2 + 1 ].AddXY(
											logTimes[ i ] / (3600 * 24),
											3600 * (dw2 - dw1) / (et2 - et1),
											'', clTeeColor
										);
										end;
								{ transfer rate in kByte/sec }
								else	begin
										l1 := logData^[ p ].data.transferred;
										l2 := logData^[ pp ].data.transferred;
										if l1 > l2 then l1 := 0;
										transferredChart.series[ 1 + index ].AddXY(
											logTimes[ i ] / (3600 * 24),
											((l2 - l1) / (et2 - et1)) / 1024,
											'', clTeeColor
										);
										end;
								end;
							end;

						if (i < pred( points )) and (et2 > logTimes[ succ( i ) ]) then
							p := pred( pp ) { if there are more points on the graph than in the log... }
						else
							p := pp;
						end;
					end;
				end

			else { if not eMuleTime }
				begin

				{ search for the log value at point 0 }
				repeat
					inc( p );
				until (p >= logCount) or (logData^[ p ].date >= logDates[ 0 ]);
				if p > 0 then dec( p );

				for i := 0 to pred( points ) do
					begin
					if (logDates[ i ] >= logData^[ 0 ].date) and (logDates[ i ] <= logData^[ pred( logCount ) ].date) then
						begin
						{ search for the log value at point i }
						pp := p;
						repeat
							inc( pp );
						until (pp >= logCount) or ((logData^[ pp ].date > logDates[ i ]) and (logData^[ pp ].date > logData^[ p ].date));

						if pp < logCount then
							begin
							dt1 := fileDateToDateTime( logData^[ p ].date );
							dt3 := fileDateToDateTime( logData^[ pp ].date );
							case j of
								{ requests rate per hour }
								0:		{ 28 apr 07: bug fix: support for corrupted known.met (lost known file stats) >>> }
										{ same change for accepted and transferred graphs below }
										begin
										dw1 := logData^[ p ].data.requested;
										dw2 := logData^[ pp ].data.requested;
										if dw1 > dw2 then dw1 := 0;
										requestsChart.series[ 1 + index * 2 ].AddXY(
											fileDateToDateTime( logDates[ i ] ),
											3600 * (dw2 - dw1) / secondsBetween( dt3, dt1 ),
											'', clTeeColor
										);
										end;
{ old code:
										requestsChart.series[ 1 + index * 2 ].AddXY(
											fileDateToDateTime( logDates[ i ] ),
											3600 * (logData^[ pp ].data.requested - logData^[ p ].data.requested) / secondsBetween( dt3, dt1 ),
											'', clTeeColor
										);
}										{ <<< 28 apr 07: bug fix: support for corrupted known.met (lost known file stats) }
								1:		begin
										dw1 := logData^[ p ].data.accepted;
										dw2 := logData^[ pp ].data.accepted;
										if dw1 > dw2 then dw1 := 0;
										requestsChart.series[ 1 + index * 2 + 1 ].AddXY(
											fileDateToDateTime( logDates[ i ] ),
											3600 * (dw2 - dw1) / secondsBetween( dt3, dt1 ),
											'', clTeeColor
										);
										end;
								{ transfer rate in kByte/sec }
								else	begin
										l1 := logData^[ p ].data.transferred;
										l2 := logData^[ pp ].data.transferred;
										if l1 > l2 then l1 := 0;
										transferredChart.series[ 1 + index ].AddXY(
											fileDateToDateTime( logDates[ i ] ),
											((l2 - l1) / secondsBetween( dt3, dt1 ) / 1024),
											'', clTeeColor
										);
										end;
								end;
							end;

						if (i < pred( points )) and (logData^[ pp ].date > logDates[ succ( i ) ]) then p := pred( pp ) { if there are more points on the graph than in the log... }
						else p := pp;
						end;
					end;
				end;
			end;
		{$IFDEF debug} {$R+} {$ENDIF}
	end;

	{ Calculate the values at each date in logTimes/logDates for each displayed iniFile log, and add them to the graphs }
	procedure iniCalcValues( index, points: integer );
	type
		tLogData = packed record
			date: tFileDate;
			case tLogType of
				ltByte:(	dataByte: shortInt );
				ltWord:(	dataWord: smallInt );
				ltInteger:(	dataInt: integer );
				ltInt64:(	dataInt64: int64 );
				ltReal:(	dataReal: double );
			end;
	var
		j, jMax: integer;
		lf: tLogFile;
		i: integer;
		p, pp: array[0..1] of integer;
		logFile: array[0..1] of tLogFile;
		logCount: array[0..1] of integer;
		dt1, dt2: tDateTime;
		et1, et2: array[0..1] of tEmuleRuntime;
		v: array[0..1] of double;
		b: boolean;
		b1, b2: shortInt;
		w1, w2: smallInt;
		i1, i2: integer;
		l1, l2: int64;
		r1, r2: double;

		function logData( j, index: integer ): tLogData; { returns the log data at given index }
		var
			logDataByte: pLogDataByte;
			logDataWord: pLogDataWord;
			logDataInt: pLogDataInteger;
			logDataInt64: pLogDataInt64;
			logDataReal: pLogDataReal;
		begin
			{$R-}
			case logFile[ j ].dataType of
				ltByte:
					begin
					logDataByte := pLogDataByte( logFile[ j ].log );
					result.date := logDataByte^[ index ].date;
					result.dataByte := logDataByte^[ index ].data;
					end;
				ltWord:
					begin
					logDataWord := pLogDataWord( logFile[ j ].log );
					result.date := logDataWord^[ index ].date;
					result.dataWord := logDataWord^[ index ].data;
					end;
				ltInteger:
					begin
					logDataInt := pLogDataInteger( logFile[ j ].log );
					result.date := logDataInt^[ index ].date;
					result.dataInt := logDataInt^[ index ].data;
					end;
				ltInt64:
					begin
					logDataInt64 := pLogDataInt64( logFile[ j ].log );
					result.date := logDataInt64^[ index ].date;
					result.dataInt64 := logDataInt64^[ index ].data;
					end;
				else
					begin
					logDataReal := pLogDataReal( logFile[ j ].log );
					result.date := logDataReal^[ index ].date;
					result.dataReal := logDataReal^[ index ].data;
					end;
				end;
			{$IFDEF debug} {$R+} {$ENDIF}
		end;

	begin
		{ for combined logs, the values from the two source logs are first treated separately before they are combined }
		lf := tLogFile( iniLogsList[ index ] );
		if lf.what = lwCombinedLogs then
			begin { two source logs }
			jMax := 1;
			for j := 0 to jMax do logFile[ j ] := lf.logs[ j ];
			end
		else
			begin { one log }
			jMax := 0;
			logFile[ 0 ] := lf;
			end;
		for j := 0 to jMax do
			begin
			logCount[ j ] := logFile[ j ].logLen;
			p[ j ] := 0;
			end;

		if eMuleTime then
			begin

			{ search for the log value at point 0 }
			for j := 0 to jMax do
				begin
				repeat
					inc( p[ j ] );
					et1[ j ] := logFiles.runtimeAt[ logData( j, p[ j ] ).date ];
				until (p[ j ] >= logCount[ j ]) or (et1[ j ] >= logTimes[ 0 ]);
				if p[ j ] > 0 then dec( p[ j ] );
				end;

			for i := 0 to pred( points ) do
				begin
				b := true;
				for j := 0 to jMax do
					b := b and (logTimes[ i ] >= logFiles.runtimeAt[ logData( j, 0 ).date ]) and (logTimes[ i ] <= logFiles.runtimeAt[ logData( j, pred( logCount[ j ] ) ).date ]);
				if b then
					begin

					{ search for the log value at point i }
					for j := 0 to jMax do
						begin
						pp[ j ] := p[ j ];
						et1[ j ] := logFiles.runtimeAt[ logData( j, p[ j ] ).date ];
						repeat
							inc( pp[ j ] );
							et2[ j ] := logFiles.runtimeAt[ logData( j, pp[ j ] ).date ];
						until (pp[ j ] >= logCount[ j ]) or (et2[ j ] > logTimes[ i ]) and (et2[ j ] > et1[ j ]);
						end;

					if (pp[ 0 ] < logCount[ 0 ]) and ((jMax = 0) or (pp[ 1 ] < logCount[ 1 ])) then
						begin
						for j := 0 to jMax do
							begin
							if logFile[ j ].flags and lfCumulativeValue <> 0 then
								begin
								{ calculate the (delta value / delta time) rate }
								{ 06 may 07: bug fix: support for eMule statistics reset >>> }
								case logFile[ j ].dataType of
									ltByte:		begin
												b1 := logData( j, pp[ j ] ).dataByte;
												b2 := logData( j, p[ j ] ).dataByte;
												if b2 > b1 then b2 := 0;
												v[ j ] := logFile[ j ].multiplier * (b1 - b2) / (et2[ j ] - et1[ j ]);
												end;
									ltWord:		begin
												w1 := logData( j, pp[ j ] ).dataWord;
												w2 := logData( j, p[ j ] ).dataWord;
												if w2 > w1 then w2 := 0;
												v[ j ] := logFile[ j ].multiplier * (w1 - w2) / (et2[ j ] - et1[ j ]);
												end;
									ltInteger:	begin
												i1 := logData( j, pp[ j ] ).dataInt;
												i2 := logData( j, p[ j ] ).dataInt;
												if i2 > i1 then i2 := 0;
												v[ j ] := logFile[ j ].multiplier * (i1 - i2) / (et2[ j ] - et1[ j ]);
												end;
									ltInt64:	begin
												l1 := logData( j, pp[ j ] ).dataInt64;
												l2 := logData( j, p[ j ] ).dataInt64;
												if l2 > l1 then l2 := 0;
												v[ j ] := logFile[ j ].multiplier * (l1 - l2) / (et2[ j ] - et1[ j ]);
												end;
									else		begin
												r1 := logData( j, pp[ j ] ).dataReal;
												r2 := logData( j, p[ j ] ).dataReal;
												if r2 > r1 then r2 := 0;
												v[ j ] := logFile[ j ].multiplier * (r1 - r2) / (et2[ j ] - et1[ j ]);
												end;
									end;
{ old code:
								case logFile[ j ].dataType of
									ltByte:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataByte - logData( j, p[ j ] ).dataByte) / (et2[ j ] - et1[ j ]);
									ltWord:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataWord - logData( j, p[ j ] ).dataWord) / (et2[ j ] - et1[ j ]);
									ltInteger:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt - logData( j, p[ j ] ).dataInt) / (et2[ j ] - et1[ j ]);
									ltInt64:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt64 - logData( j, p[ j ] ).dataInt64) / (et2[ j ] - et1[ j ]);
									else		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataReal - logData( j, p[ j ] ).dataReal) / (et2[ j ] - et1[ j ]);
									end;
}								{ <<< 06 may 07: bug fix: support for eMule statistics reset }
								end
							else
								begin
								{ calculate the average value from the two points
								note: it would be more accurate to use all the values between the two points, but this would take more time }
								case logFile[ j ].dataType of
									ltByte:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataByte + logData( j, p[ j ] ).dataByte) / 2;
									ltWord:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataWord + logData( j, p[ j ] ).dataWord) / 2;
									ltInteger:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt + logData( j, p[ j ] ).dataInt) / 2;
									ltInt64:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt64 + logData( j, p[ j ] ).dataInt64) / 2;
									else		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataReal + logData( j, p[ j ] ).dataReal) / 2;
									end;
								end;
							end;
						{ Add to the graph }
						if jMax = 0 then { single log }
							begin
							if (logFile[ 0 ].flags and lfShowWithRequests <> 0) then
								requestsChart.series[ 1 + maxDisplayedKF * 2 + indexReq ].AddXY(
									logTimes[ i ] / (3600 * 24),
									v[ 0 ],
									'', clTeeColor
								)
							else
								transferredChart.series[ 1 + maxDisplayedKF + indexTrn ].AddXY(
									logTimes[ i ] / (3600 * 24),
									v[ 0 ],
									'', clTeeColor
								);
							end
						else { combined logs }
							begin
							case lf.operation of
								coAddition:		v[ 0 ] := v[ 0 ] + v[ 1 ];
								coSubstract1:	v[ 0 ] := v[ 0 ] - v[ 1 ];
								coSubstract2:	v[ 0 ] := v[ 1 ] - v[ 0 ];
								coRatio1:		if v[ 1 ] <> 0 then v[ 0 ] := v[ 0 ] / v[ 1 ] else v[ 0 ] := nan;
								coRatio2:		if v[ 0 ] <> 0 then v[ 0 ] := v[ 1 ] / v[ 0 ] else v[ 0 ] := nan;
								coPerCent1:		if v[ 0 ] + v[ 1 ] <> 0 then v[ 0 ] := v[ 0 ] / (v[ 0 ] + v[ 1 ]) else v[ 0 ] := nan;
								coPerCent2:		if v[ 0 ] + v[ 1 ] <> 0 then v[ 0 ] := v[ 1 ] / (v[ 0 ] + v[ 1 ]) else v[ 0 ] := nan;
								end;
							if not isNAN( v[ 0 ] ) then
								begin
								v[ 0 ] := lf.multiplier * v[ 0 ];
								if not isNAN( lf.maxValue ) and (v[ 0 ] > lf.maxValue) then v[ 0 ] := lf.maxValue;
								if (lf.flags and lfShowWithRequests <> 0) then
									requestsChart.series[ 1 + maxDisplayedKF * 2 + indexReq ].AddXY(
										logTimes[ i ] / (3600 * 24),
										v[ 0 ],
										'', clTeeColor
									)
								else
									transferredChart.series[ 1 + maxDisplayedKF + indexTrn ].AddXY(
										logTimes[ i ] / (3600 * 24),
										v[ 0 ],
										'', clTeeColor
									);
								end;
							end;
						end;

					if (i < pred( points )) and (et2[ 0 ] > logTimes[ succ( i ) ]) then
						for j := 0 to jMax do p[ j ] := pred( pp[ j ] ) { if there are more points on the graph than in the log... }
					else
						for j := 0 to jMax do p[ j ] := pp[ j ];
					end;
				end;
			end

		else { if not eMuleTime }
			begin

			{ search for the log value at point 0 }
			for j := 0 to jMax do
				begin
				repeat
					inc( p[ j ] );
				until (p[ j ] >= logCount[ j ]) or (logData( j, p[ j ] ).date >= logDates[ 0 ]);
				if p[ j ] > 0 then dec( p[ j ] );
				end;

			for i := 0 to pred( points ) do
				begin
				b := true;
				for j := 0 to jMax do
					b := b and (logDates[ i ] >= logData( j, 0 ).date) and (logDates[ i ] <= logData( j, pred( logCount[ j ] ) ).date);
				if b then
					begin

					{ search for the log value at point i }
					for j := 0 to jMax do
						begin
						pp[ j ] := p[ j ];
						repeat
							inc( pp[ j ] );
						until (pp[ j ] >= logCount[ j ]) or (logData( j, pp[ j ] ).date > logDates[ i ]) and (logData( j, pp[ j ] ).date > logData( j, p[ j ] ).date);
						end;

					if (pp[ 0 ] < logCount[ 0 ]) and ((jMax = 0) or (pp[ 1 ] < logCount[ 1 ])) then
						begin
						for j := 0 to jMax do
							begin
							if logFile[ j ].flags and lfCumulativeValue <> 0 then
								begin
								{ calculate the (delta value / delta time) rate }
								dt1 := fileDateToDateTime( logData( j, p[ j ] ).date );
								dt2 := fileDateToDateTime( logData( j, pp[ j ] ).date );
								{ 06 may 07: bug fix: support for eMule statistics reset >>> }
								case logFile[ j ].dataType of
									ltByte:		begin
												b1 := logData( j, pp[ j ] ).dataByte;
												b2 := logData( j, p[ j ] ).dataByte;
												if b2 > b1 then b2 := 0;
												v[ j ] := logFile[ j ].multiplier * (b1 - b2) / secondsBetween( dt2, dt1 );
												end;
									ltWord:		begin
												w1 := logData( j, pp[ j ] ).dataWord;
												w2 := logData( j, p[ j ] ).dataWord;
												if w2 > w1 then w2 := 0;
												v[ j ] := logFile[ j ].multiplier * (w1 - w2) / secondsBetween( dt2, dt1 );
												end;
									ltInteger:	begin
												i1 := logData( j, pp[ j ] ).dataInt;
												i2 := logData( j, p[ j ] ).dataInt;
												if i2 > i1 then i2 := 0;
												v[ j ] := logFile[ j ].multiplier * (i1 - i2) / secondsBetween( dt2, dt1 );
												end;
									ltInt64:	begin
												l1 := logData( j, pp[ j ] ).dataInt64;
												l2 := logData( j, p[ j ] ).dataInt64;
												if l2 > l1 then l2 := 0;
												v[ j ] := logFile[ j ].multiplier * (l1 - l2) / secondsBetween( dt2, dt1 );
												end;
									else		begin
												r1 := logData( j, pp[ j ] ).dataReal;
												r2 := logData( j, p[ j ] ).dataReal;
												if r2 > r1 then r2 := 0;
												v[ j ] := logFile[ j ].multiplier * (r1 - r2) / secondsBetween( dt2, dt1 );
												end;
									end;
{ old code:
								case logFile[ j ].dataType of
									ltByte:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataByte - logData( j, p[ j ] ).dataByte) / secondsBetween( dt2, dt1 );
									ltWord:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataWord - logData( j, p[ j ] ).dataWord) / secondsBetween( dt2, dt1 );
									ltInteger:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt - logData( j, p[ j ] ).dataInt) / secondsBetween( dt2, dt1 );
									ltInt64:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt64 - logData( j, p[ j ] ).dataInt64) / secondsBetween( dt2, dt1 );
									else		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataReal - logData( j, p[ j ] ).dataReal) / secondsBetween( dt2, dt1 );
									end;
}								{ <<< 06 may 07: bug fix: support for eMule statistics reset }
								end
							else
								begin
								{ calculate the average value from the two points
								note: it would be more accurate to use all the values between the two points, but this would take more time }
								b := false;
								if (logFiles.runtimeLog <> nil) and (logFiles.runtimeLog.logSize > 0) then { show 0 when eMule was off }
									begin
									dt1 := fileDateToDateTime( logData( j, p[ j ] ).date );
									dt2 := fileDateToDateTime( logData( j, pp[ j ] ).date );
									et1[ j ] := logFiles.runtimeAt[ logData( j, p[ j ] ).date ];
									et2[ j ] := logFiles.runtimeAt[ logData( j, pp[ j ] ).date ];
									if (secondsBetween( dt2, dt1 ) > (et2[ j ] - et1[ j ]) * 2) and (logFile[ j ].flags and lfSavedOnChange = 0) then
										begin
										v[ j ] := 0;
										b := true;
										end;
									end;
								if not b then case logFile[ j ].dataType of
									ltByte:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataByte + logData( j, p[ j ] ).dataByte) / 2;
									ltWord:		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataWord + logData( j, p[ j ] ).dataWord) / 2;
									ltInteger:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt + logData( j, p[ j ] ).dataInt) / 2;
									ltInt64:	v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataInt64 + logData( j, p[ j ] ).dataInt64) / 2;
									else		v[ j ] := logFile[ j ].multiplier * (logData( j, pp[ j ] ).dataReal + logData( j, p[ j ] ).dataReal) / 2;
									end;
								end;
							end;
						{ Add to the graph }
						if jMax = 0 then { single log }
							begin
							if (logFile[ 0 ].flags and lfShowWithRequests <> 0) then
								requestsChart.series[ 1 + maxDisplayedKF * 2 + indexReq ].AddXY(
									fileDateToDateTime( logDates[ i ] ),
									v[ 0 ],
									'', clTeeColor
								)
							else
								transferredChart.series[ 1 + maxDisplayedKF + indexTrn ].AddXY(
									fileDateToDateTime( logDates[ i ] ),
									v[ 0 ],
									'', clTeeColor
								);
							end
						else { combined logs }
							begin
							b := false;
							if (logFiles.runtimeLog <> nil) and (logFiles.runtimeLog.logSize > 0) then { show 0 when eMule was off }
								begin
								dt1 := fileDateToDateTime( logData( 0, p[ 0 ] ).date );
								dt2 := fileDateToDateTime( logData( 0, pp[ 0 ] ).date );
								et1[ 0 ] := logFiles.runtimeAt[ logData( 0, p[ 0 ] ).date ];
								et2[ 0 ] := logFiles.runtimeAt[ logData( 0, pp[ 0 ] ).date ];
								if (secondsBetween( dt2, dt1 ) > (et2[ 0 ] - et1[ 0 ]) * 2) and (logFile[ 0 ].flags and lfSavedOnChange = 0) then
									begin
									v[ 0 ] := 0;
									b := true;
									end;
								end;
							if not b then case lf.operation of
								coAddition:		v[ 0 ] := v[ 0 ] + v[ 1 ];
								coSubstract1:	v[ 0 ] := v[ 0 ] - v[ 1 ];
								coSubstract2:	v[ 0 ] := v[ 1 ] - v[ 0 ];
								coRatio1:		if v[ 1 ] <> 0 then v[ 0 ] := v[ 0 ] / v[ 1 ] else v[ 0 ] := nan;
								coRatio2:		if v[ 0 ] <> 0 then v[ 0 ] := v[ 1 ] / v[ 0 ] else v[ 0 ] := nan;
								coPerCent1:		if v[ 0 ] + v[ 1 ] <> 0 then v[ 0 ] := v[ 0 ] / (v[ 0 ] + v[ 1 ]) else v[ 0 ] := nan;
								coPerCent2:		if v[ 0 ] + v[ 1 ] <> 0 then v[ 0 ] := v[ 1 ] / (v[ 0 ] + v[ 1 ]) else v[ 0 ] := nan;
								end;
							if not isNAN( v[ 0 ] ) then
								begin
								v[ 0 ] := lf.multiplier * v[ 0 ];
								if not isNAN( lf.maxValue ) and (v[ 0 ] > lf.maxValue) then v[ 0 ] := lf.maxValue;
								if (lf.flags and lfShowWithRequests <> 0) then
									requestsChart.series[ 1 + maxDisplayedKF * 2 + indexReq ].AddXY(
										fileDateToDateTime( logDates[ i ] ),
										v[ 0 ],
										'', clTeeColor
									)
								else
									transferredChart.series[ 1 + maxDisplayedKF + indexTrn ].AddXY(
										fileDateToDateTime( logDates[ i ] ),
										v[ 0 ],
										'', clTeeColor
									);
								end;
							end;
						end;

					if (i < pred( points )) and (logData( 0, pp[ 0 ] ).date > logDates[ succ( i ) ]) then
						for j := 0 to jMax do p[ j ] := pred( pp[ j ] ) { if there are more points on the graph than in the log... }
					else
						for j := 0 to jMax do p[ j ] := pp[ j ];
					end;
				end;
			end;
		if (lf.flags and lfShowWithRequests <> 0) then inc( indexReq ) else inc( indexTrn );
	end;

	{ set the bottom axis min/max }
	procedure setHScale;
	var
		dt1, dt2: tDateTime;
		days1, days2: double;

		procedure setIt( d1, d2: double; chart: tChart );
		begin
			if d1 <= chart.bottomAxis.maximum then
				begin
				chart.bottomAxis.minimum := d1;
				chart.bottomAxis.maximum := d2;
				end
			else
				begin
				chart.bottomAxis.maximum := d2;
				chart.bottomAxis.minimum := d1;
				end;
		end;

	begin
		if eMuleTime then
			begin
			days1 := logTimes[ 0 ] / (3600 * 24);
			days2 := logTimes[ pred( length( logTimes ) ) ] / (3600 * 24);
			setIt( days1, days2, requestsChart );
			setIt( days1, days2, transferredChart );
			end
		else
			begin
			dt1 := fileDateToDateTime( logDates[ 0 ] );
			dt2 := fileDateToDateTime( logDates[ pred( length( logDates ) ) ] );
			setIt( dt1, dt2, requestsChart );
			setIt( dt1, dt2, transferredChart );
			end;
	end;

	{ set the bottom axis min/max to 0 }
	procedure resetHScale;

		procedure setIt( chart: tChart );
		begin
			if 0 <= chart.bottomAxis.maximum then
				begin
				chart.bottomAxis.minimum := 0;
				chart.bottomAxis.maximum := 0;
				end
			else
				begin
				chart.bottomAxis.maximum := 0;
				chart.bottomAxis.minimum := 0;
				end;
		end;

	begin
		setIt( requestsChart );
		setIt( transferredChart );
	end;

	{ Add a bar for each event }
	procedure addEvents;
	var
		evtLog: tEventsLog;
		min, max: double;
		p: integer;
		dt: tDateTime;
		hash: string;
		kf: tKnownMetRecord;
	begin
		min := requestsChart.bottomAxis.minimum;
		max := requestsChart.bottomAxis.maximum;
		if eMuleTime then
			begin
			min := fileDateToDateTime( logFiles.realTimeAt[ round( min * (3600 * 24) ) ] );
			max := fileDateToDateTime( logFiles.realTimeAt[ round( max * (3600 * 24) ) ] );
			end;

		evtLog := tEventsLog.create;
		try
			evtLog.load;
			evtLog.find( dateTimeToStr( min ), p );
			repeat
				if (p >= 0) and (p < evtLog.count) then
					begin
					dt := evtLog.dates[ p ];
					if compareDateTime( dt, max ) <= 0 then
						begin
						hash := evtLog.hashes[ p ];
						kf := displayedFile[ hash ];
						if (hash = '') or (kf <> nil) then { only add the event if it's not attached to a known file, or if this file's log is actually displayed }
							begin
							if eMuleTime then requestsChart.series[ 0 ].AddXY( logFiles.runtimeAt[ dateTimeToFileDate( dt ) ] / (3600 * 24), 1, '', clTeeColor )
							else requestsChart.series[ 0 ].AddXY( dt, 1, '', clTeeColor );
							if eMuleTime then transferredChart.series[ 0 ].AddXY( logFiles.runtimeAt[ dateTimeToFileDate( dt ) ] / (3600 * 24), 1, '', clTeeColor )
							else transferredChart.series[ 0 ].AddXY( dt, 1, '', clTeeColor );
							end;
						end
					else
						break;
					inc( p );
					end;
			until (p < 0) or (p >= evtLog.count);
			finally evtLog.free;
			end;
	end;

	{ unload logs, delete the various dynamic arrays... }
	procedure cleanUp;
	var
		i: integer;
	begin
		logDates := nil;
		logTimes := nil;
		for i := 0 to pred( kfLogsList.count ) do
			tLogFile( kfLogsList[ i ] ).unload;
		kfLogsList.free;
		for i := 0 to pred( iniLogsList.count ) do
			tLogFile( iniLogsList[ i ] ).unload;
		iniLogsList.free;
		if logFiles.runtimeLog <> nil then logFiles.runtimeLog.unload;
	end;

begin { drawGraphics }

	if (logFiles = nil) or (logFiles.count = 0) or (knownMet = nil) or (knownMet.list = nil) then
		begin
		clearSeries;
		exit;
		end;

	cr := screen.cursor;
	screen.cursor := crHourGlass;
	try

		if logFiles.runtimeLog <> nil then logFiles.runtimeLog.load;
		eMuleTime := aGrEmuleRuntime.checked;
		if eMuleTime then
			begin
			if (logFiles.runtimeLog = nil) or (logFiles.runtimeLog.logSize <= 0) then
				begin
				aGrEmuleRuntime.checked := false;
				eMuleTime := false;
				end;
			end;
		clearSeries;
		kfLogsList := tList.create;
		iniLogsList := tList.create;
		try
			{ load the selected logs which will be displayed }
			kfLoadLogs; { -> kfLogsList }
			iniLoadLogs; { -> iniLogsList }

			getBegEnd;{ calculate the first and last dates to be displayed on the graphs }

			if (fdBeg <> -1) and (fdEnd <> -1) then
				begin
				getPointsCount( false ); { initializes the zoom scrollBar max position }
				zoomAndScroll; { calculates the first and last dates to be displayed, depending on the zoom and scroll scrollbars postions }
				points := getPointsCount( true ); { calculate the number of points to get a nice graph }

				calcDates( points ); { calculate the dates for each point in the graph }

				{ calculate and display the points for the knownFiles logs }
				for i := 0 to pred( kfLogsList.count ) do kfCalcValues( i, points );

				{ calculate and display the points for the iniFiles logs }
				indexReq := 0;
				indexTrn := 0;
				for i := 0 to pred( iniLogsList.count ) do iniCalcValues( i, points );

				setHScale; { set the bottom axis min/max }
				addEvents; { Add a bar for each event }
				end
			else
				resetHScale; { set the bottom axis min/max to 0 }
			finally cleanUp; { unload logs, delete the various dynamic arrays... }
			end;

		finally
			updateValuesAtCursor := true;
			screen.cursor := cr;
		end;
end;

procedure tMainForm.topPanelResize(Sender: TObject);
begin
	knownFilesList.height := (topPanel.clientHeight - listsSplitter.height) div 2;
	listsSplitter.top := knownFilesList.height;
	if topPanel.height < mainSplitter.minSize then
		begin
		mainSplitter.align := alNone;
		topPanel.height := 1;
		mainSplitter.top := topPanel.height;
		mainSplitter.align := alTop;
		end;
	graphsSplitter.left := legendPanel.left - graphsSplitter.width;
end;

procedure tMainForm.FormResize(Sender: TObject);
begin
	if topPanel.height < mainSplitter.minSize then
		begin
		mainSplitter.align := alNone;
		topPanel.height := 1;
		mainSplitter.top := topPanel.height;
		mainSplitter.align := alTop;
		end
	else
		begin
		topPanel.height := clientHeight div 2;
		mainSplitter.top := topPanel.height;
		end;
	if (graphsPanel.width < graphsSplitter.minSize) or (statsTab.width - legendPanel.width - graphsSplitter.width < graphsSplitter.minSize) then
		begin
		if statsTab.width - graphsSplitter.minSize - graphsSplitter.width < graphsSplitter.minSize then
			legendPanel.width := 0
		else
			legendPanel.width := statsTab.width - graphsSplitter.minSize - graphsSplitter.width;
		end;
	graphsSplitter.left := legendPanel.left - graphsSplitter.width;
	graphsNeedRedraw := true;
end;

procedure tMainForm.legendPanelResize(Sender: TObject);
begin
	graphsNeedRedraw := true;
end;

procedure tMainForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
	if (key = vk_space) and (ssAlt in shift) then key := 0;
	{ 02 may 07: Quick zoom and center >>> }
	if (key = vk_shift) or (key = vk_control) then showValuesAtCursor( nil );
	{ <<< 02 may 07: Quick zoom and center }
end;

{ 02 may 07: Quick zoom and center >>> }
procedure tMainForm.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
	if (key = vk_shift) or (key = vk_control) then showValuesAtCursor( nil );
end;
{ <<< 02 may 07: Quick zoom and center }

procedure tMainForm.redrawGraphs(Sender: TObject);
begin
	graphsNeedRedraw := true;
end;

procedure tMainForm.aNavNextTabExecute(Sender: TObject);
begin
	tabs.selectNextPage( true );
end;

procedure tMainForm.aNavPrevTabExecute(Sender: TObject);
begin
	tabs.selectNextPage( false );
end;

procedure tMainForm.aIniEditLogUpdate(Sender: TObject);
var
	item, selItem: tListItem;
	ok: boolean;
begin
	ok := false;
	selItem := eMuleStatsList.selected;
	if selItem <> nil then
		begin
		item := eMuleStatsList.getNextItem( selItem, sdAll, [isSelected] );
		ok := (item = nil);
		end;
	tAction( sender ).enabled := ok;
end;

procedure tMainForm.aIniCombineExecute(Sender: TObject);
var
	item: tListItem;
	lf: tLogFile;
begin
	combineForm := tCombineForm.create( self );
	with combineForm do
		begin
		try
			item := eMuleStatsList.selected;
			logs[ 0 ] := tLogFile( item.data );
			item := eMuleStatsList.getNextItem( item, sdAll, [isSelected] );
			logs[ 1 ] := tLogFile( item.data );
			operation := coAddition;
			fileName := '';
			multiplier := 1;
			flags := 0;
			units := '';
			maxValue := nan;
			if showModal = mrOk then
				begin
				logFiles.createLogFile( fileName, lsActive, ltReal, flags, multiplier, units, operation, log1, log2, maxValue );
				lf := tLogFile.create( fileName );
				if lf.dataType > ltNone then
					logFiles.addObject( fileName, lf )
				else
					lf.free;
				logFilesLoaded;
				item := eMuleStatsList.findData( 0, lf, true, false );
				if item <> nil then
					begin
					item.selected := true;
					item.focused := true;
					item.makeVisible( false );
					end;
				end;
			finally
				free;
			end;
		end;
end;

procedure tMainForm.aIniEditLogExecute(Sender: TObject);
var
	item: tListItem;
begin
	if tLogFile( eMuleStatsList.selected.data ).what = lwCombinedLogs then
		begin
		combineForm := tCombineForm.create( self );
		with combineForm do
			begin
			try
				logFile := tLogFile( eMuleStatsList.selected.data );
				operation := logFile.operation;
				fileName := logFile.name;
				multiplier := logFile.multiplier;
				flags := logFile.flags;
				units := logFile.units;
				maxValue := logFile.maxValue;
				if showModal = mrOk then
					begin
					logFiles.setLogName( logFile.name, fileName );
					logFile.setProperties( flags, multiplier, units, operation, maxValue );
					logFilesLoaded;
					item := eMuleStatsList.findData( 0, logFile, true, false );
					if item <> nil then
						begin
						item.selected := true;
						item.focused := true;
						item.makeVisible( false );
						end;
					end;
				finally
					free;
				end;
			end;
		end
	else
		begin
		newLogWizard := tNewLogWizard.create( self );
		with newLogWizard do
			begin
			try
				logFile := tLogFile( eMuleStatsList.selected.data );
				if showModal = mrOk then
					begin
					logFile.setProperties( flags, multiplier, units );
					logFilesLoaded;
					item := eMuleStatsList.findData( 0, logFile, true, false );
					if item <> nil then
						begin
						item.selected := true;
						item.focused := true;
						item.makeVisible( false );
						end;
					end;
				finally free;
				end;
			end;
		end;
end;

procedure tMainForm.aIniNewLogExecute(Sender: TObject);
var
	lf: tLogFile;
	dw: dWord;
	item: tListItem;
begin
	newLogWizard := tNewLogWizard.create( self );
	with newLogWizard do
		begin
		try
			logFile := nil;
			if showModal = mrOk then
				begin
				logFiles.createLogFile( fileName, lsActive, dataType, flags, multiplier, units );
				lf := tLogFile.create( fileName );
				if lf.dataType > ltNone then
					logFiles.addObject( fileName, lf )
				else
					lf.free;
				logFilesLoaded;
				item := eMuleStatsList.findData( 0, lf, true, false );
				if item <> nil then
					begin
					item.selected := true;
					item.focused := true;
					item.makeVisible( false );
					end;
				dw := bsm_applications;
				broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, newLogsMsg, 0, 0 );
				end;
			finally free;
			end;
		end;
end;

procedure tMainForm.knownFilesListAdvancedCustomDrawItem( Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var
	list: tListView;
	r: tRect;
begin
	if application.terminated then
		begin
		DefaultDraw := false;
		exit;
		end;
	if (stage = cdPrePaint) then
		begin
		list := tListView( sender );
		r := item.displayRect( drIcon );
		with list.canvas do
			begin
			if item.selected or (item = refKF1) or (item = refKF2) then
				begin
				if (knownMet <> nil) and (knownMet.list <> nil) and (item.data <> nil) then
					begin
					pen.color := tKnownMetRecord( item.data ).color;
					if (item = refKF1) or (item = refKF2) then
						pen.width := 3;
					moveTo( r.left, r.top + (r.bottom - r.top) div 2 );
					lineTo( r.right - 1, r.top + (r.bottom - r.top) div 2 );
					pen.width := 1;
					end;
				end;
			pen.onChange( list.canvas );
			end;
		end;
end;

procedure tMainForm.eMuleStatsListAdvancedCustomDrawItem( Sender: TCustomListView; Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage; var DefaultDraw: Boolean);
var                                            
	list: tListView;
	r: tRect;
begin
	if application.terminated then
		begin
		DefaultDraw := false;
		exit;
		end;
	if (stage = cdPrePaint) then
		begin
		list := tListView( sender );
		r := item.displayRect( drIcon );
		with list.canvas do
			begin
			if item.selected then
				begin
				if (logFiles.count > 0) and (item.data <> nil) then
					begin
					pen.color := tLogFile( item.data ).color;
					moveTo( r.left, r.top + (r.bottom - r.top) div 2 );
					lineTo( r.right - 1, r.top + (r.bottom - r.top) div 2 );
					end;
				end;
			pen.onChange( list.canvas );
			end;
		end;
end;

procedure tMainForm.wndProc( var message: tMessage );
var
	dw: dWord;
begin
	if message.msg = closeMsg then
		application.terminate
	else if message.msg = suspendedMsg then
		begin
		try
			{ 29 apr 07: bug fix: Support for ConnRunTime reset >>> }
			case message.wParam of
				0:	compressLogs;
				1:	logFiles.runtimeLog.save( logFiles.runtimeLog.log, logFiles.runtimeLog.logSize );
				2:	repairKnownMet; { 05 may 07: Repair known.met }
				end;
{ old code:
			compressLogs;
}			{ <<< 29 apr 07: bug fix: Support for ConnRunTime reset }
			finally
				{ resume log recorder }
				dw := bsm_applications;
				{ 29 apr 07: bug fix: Support for ConnRunTime reset >>> }
				broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, resumeMsg, message.wParam, 0 );
{ old code:
				broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, resumeMsg, 0, 0 );
}				{ <<< 29 apr 07: bug fix: Support for ConnRunTime reset }
				end;
		end
	else if message.msg = resumedMsg then
		begin
		{ nothing to do here... }
		end;
	inherited wndProc( message );
	if (legendPanel <> nil) and (legendDockablePanel <> nil) then
		begin
		if not legendDockablePanel.visible then
			begin
			if legendDockablePanel.floating then legendDockablePanel.manualDock( legendPanel );
			legendDockablePanel.visible := true;
			end
		else if not legendDockablePanel.floating and legendPanel.dockSite then
			begin
			legendPanel.dockSite := false;
			legendDockablePanel.align := alClient;
			end;
		end;
end;

function tMainForm.isEmuleRunning: boolean;
var
	h: tHandle;
	ini: tIniFile;
	port: string;
	fa: integer;
	fn: string;
begin
	fn := pnEmuleConfig + fnPreferencesIni;
//	fn := eMulePath + dnEmuleConfig + fnPreferencesIni;
	fa := fileAge( fn );
	try
		ini := tIniFile.create( fn );
		try
			port := ini.readString( isEmule, ikTCPPort, '' );
			finally ini.free;
			end;
		except
			result := true; { access denied? -> emule is probably running }
			exit;
		end;
	if fa <> fileAge( fn ) then
		result := true { file has been modified while we were reading it? -> eMule is probably running }
	else if port = '' then
		result  := false { no port entry? -> eMule is probably not running }
	else
		begin
		h := createMutex( nil, false, pChar( eMuleGuid + ':' + port ) );
		result := (getLastError = error_already_exists) or (getLastError = error_access_denied);
		if h <> 0 then closeHandle( h );
		end;
end;

function needCancelledMetBackup: boolean;
var
	fa: integer;
begin
	fa := fileAge( pnEmuleConfig + fnCancelledMet );
	result := (fa <> cancelledMetDate);
end;

procedure tMainForm.editKnownMetActionsUpdate(Sender: TObject);
var
	emuleRunning: boolean;
	b: boolean;
	item: tListItem;
begin
	emuleRunning := isEmuleRunning;
	b := true;
	item := knownFilesList.selected;
	while b and (item <> nil) do
		begin
		if (knownFilesList.cellFromTag[ item, kfColShared ] = rsYes) then b := false;
		item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
		end;
	tAction( sender ).enabled :=
		b
		and (knownFilesList.selected <> nil)
		and not emuleRunning
		and (knownMet.list <> nil)
		and not timer.enabled
		{ 08 may 07: Bug fix: disable known.met editing features if known.met has been modified since last reload >>> }
		and knownMet.isUpTodate
		{ <<< 08 may 07: Bug fix: disable known.met editing features if known.met has been modified since last reload }
		;
	{ 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) >>> }
	if not knownMet.isUpTodate then backupKnownMetDone := false;
	if needCancelledMetBackup then backupCancelledMetDone := false;
(* old code:
	if eMuleRunning then
		begin { new backups may be needed }
		backupKnownMetDone := false;
		backupCancelledMetDone := false;
		end;
*)	{ <<< 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) }
end;

procedure tMainForm.aKFDelKnownFileExecute(Sender: TObject);
begin
	delKnownFiles;
end;

{ 29 apr 07: Optimizations >>> }
procedure tMainForm.backupMet( var reply: integer; cancelled: boolean = false );//cancelledMet: tCancelledMet = nil );
var
	s1, s2: string;
begin
	reply := idOk; { 04 may 07: bug fix }
//	if cancelledMet = nil then s1 := knownMet.path
//	else s1 := cancelledMet.path;
	if cancelled then s1 := pnEmuleConfig + fnCancelledMet
//	if cancelled then s1 := eMulePath + dnEmuleConfig + fnCancelledMet
	else s1 := knownMet.path;
	s2 := changeFileExt( s1, '.~met' );
	if promptForFileName( s2, rsBackupFilesFilter + '|' + rsAllFilesFilter, '~met', format( rsBackupMetDlgTitle, [extractFileName( s1 )] ), '', true ) then
		begin
		if copyFile( pChar( s1 ), pChar( s2 ), false ) then
			begin
//			if cancelledMet = nil *then backupKnownMetDone := true
//			else backupCancelledMetDone := true;
			{ 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) >>> }
			if cancelled then
				begin
				backupCancelledMetDone := true;
				cancelledMetDate := fileAge( pnEmuleConfig + fnCancelledMet );
				end
			else
				backupKnownMetDone := true;
{ old code:
			if cancelled then backupCancelledMetDone := true
			else backupKnownMetDone := true;
}			{ <<< 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) }
			end
		else
			begin
			application.messageBox( pChar( msgBackupFailed ), pChar( appFullName ), mb_ok or mb_iconWarning );
			reply := idCancel;
			end;
		end
	else
		reply := idCancel;
end;
{ <<< 29 apr 07: Optimizations }

procedure tMainForm.delKnownFiles( setAsCancelled: boolean = false );
var
	item: tListItem;
	p: integer;
	logName: string;
//	reply,
//	reply2: integer;
	s, s1: string;
	cancelledMet: tCancelledMet;
	delLog: boolean;
	dontAsk: pBoolean;

	{ 29 apr 07: Optimizations >>> }
{	procedure backup( known: boolean );
	var
		s1, s2: string;
	begin
		if known then s1 := knownMet.path else s1 := cancelledMet.path;
		s2 := changeFileExt( s1, '.~met' );
		if promptForFileName( s2, rsBackMetFilesFilter + '|' + rsAllFilesFilter, '~met', '', '', true ) then
			begin
			if copyFile( pChar( s1 ), pChar( s2 ), false ) then
				begin
				if known then backupKnownMetDone := true
				else backupCancelledMetDone := true;
				end
			else
				begin
				application.messageBox( pChar( msgBackupFailed ), pChar( appFullName ), mb_ok or mb_iconWarning );
				reply := idCancel;
				end;
			end
		else
			reply := idCancel;
	end;
}	{ <<< 29 apr 07: Optimizations }

begin
	{ 05 may 07: Reworked interface for edit known.met confirmations >>> }
	delLog := true;
	if setAsCancelled then
		begin
		s := msgConfirmSetAsCancelledFile;
		s1 := stringReplace( aKFMoveToCancelledMet.caption, '&', '', [] );
		dontAsk := @dontAskSetAsCancelled;
		end
	else
		begin
		s := msgConfirmSetAsUnknownFile;
		s1 := stringReplace( aKFDelKnownFile.caption, '&', '', [] );
		dontAsk := @dontAskSetAsUnknown;
		end;
	if not dontAsk^ and not confirmKMEdit( s1, s, setAsCancelled, delLog, dontAsk^ ) then
		exit;

(* oldCode:
	if setAsCancelled then s := msgConfirmSetAsCancelledFile else s := msgConfirmSetAsUnknownFile;
	reply := application.messageBox( pChar( s ), pChar( appFullName ), mb_okCancel or mb_iconQuestion );

	{ 29 apr 07: Repair known.met >>> }
	s := msgAskEditKnownMet1 + msgAskEditKnownMet2;
{ old code:
	s := msgAskEditKnownMet;
}	{ <<< 29 apr 07: Repair known.met }
	if (reply <> idCancel) and not backupKnownMetDone then
		begin
		reply := application.messageBox( pChar( s + msgAskKnownMetBackup ), pChar( appFullName ), mb_YesNoCancel or mb_iconWarning );
		s := '';
		end;

	{ 29 apr 07: Optimizations >>> }
	if reply = idYes then backupMet( reply );
{ old code:
	if reply = idYes then backup( true );
}	{ <<< 29 apr 07: Optimizations }

	if setAsCancelled and (reply <> idCancel) and not backupCancelledMetDone then
		begin
		reply2 := application.messageBox( pChar( s + msgAskCancelledMetBackup ), pChar( appFullName ), mb_YesNoCancel or mb_iconWarning );
		if reply2 = idCancel then reply := idCancel;
		end
	else
		reply2 := idNo;
*)	{ <<< 05 may 07: Reworked interface interface for edit known.met confirmations }

	{ 05 may 07: Reworked interface interface for edit known.met confirmations >>> }
	if setAsCancelled then
{ old code:
	if (reply <> idCancel) and setAsCancelled then
}	{ <<< 05 may 07: Reworked interface interface for edit known.met confirmations }
		cancelledMet := tCancelledMet.create( pnEmuleConfig + fnCancelledMet )
//		cancelledMet := tCancelledMet.create( eMulePath + dnEmuleConfig + fnCancelledMet )
	else
		cancelledMet := nil;

	try
		if cancelledMet <> nil then cancelledMet.load;

		try

			{ 05 may 07: Reworked interface interface for edit known.met confirmations >>> }
(* old code:
			{ 29 apr 07: Optimizations >>> }
			if reply2 = idYes then backupMet( reply, true );//cancelledMet );
{ old code:
			if reply2 = idYes then backup( false );
}			{ <<< 29 apr 07: Optimizations }

			{ 30 apr 07: bug fix: don't reload known files list if a known files deletion have been canceled >>> }
			if reply = idCancel then exit;

{ old code:
			if reply <> idCancel then
				begin
}			{ 30 apr 07: bug fix: don't reload known files list if a known files deletion have been canceled >>> }
*)	{ <<< 05 may 07: Reworked interface interface for edit known.met confirmations }
				item := knownFilesList.selected;
				while item <> nil do
					begin
					logName := tKnownMetRecord( item.data ).hash.hashStr;
					{ 05 may 07: Reworked interface interface for edit known.met confirmations >>> }
					if (logFiles.state[ logName ] <> lsNone) and delLog then
{ old code:
					if logFiles.state[ logName ] <> lsNone then
}					{ <<< 05 may 07: Reworked interface interface for edit known.met confirmations }
						logFiles.state[ logName ] := lsNone; { delete log file }
					{ 28 apr 07: bug fix >>> }
					{ Not a real bug, actually, since a match should always be found... }
					if knownMet.list.findByHash( logName, p ) then
{ old code:
					knownMet.list.findByHash( logName, p );
					if p >= 0 then
}					{ <<< 28 apr 07: bug fix }
						begin
						knownMet.list.records[ p ].free;
						knownMet.list.delete( p );
						end;
					if setAsCancelled then
						cancelledMet.add( logName );
					item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
					end;
				if setAsCancelled then cancelledMet.save;
				knownMet.save;
			{ 30 apr 07: bug fix: don't reload known files list if a known files deletion have been canceled >>> }
{ old code:
				end;
}			{ <<< 30 apr 07: bug fix: don't reload known files list if a known files deletion have been canceled }

			except
				knownMet.date := -1;
				aKFReload.execute;
				raise;
			end;

		knownMetLoaded;

		finally if cancelledMet <> nil then cancelledMet.free;
		end;

	graphsNeedRedraw := true;
	tagsNeedRedraw := true;
end;

procedure tMainForm.zoomBarChange(Sender: TObject);
var
	b: boolean;
	v: double;
begin
	b := (scrollBar.position = scrollBar.max);
	if not b then v := scrollBar.position / scrollBar.max else v := 1;
	scrollBar.max := pred( zoomBar.position ) * 10;
	scrollBar.largeChange := 10;
	if b then scrollBar.position := scrollBar.max
	else scrollBar.position := round( scrollBar.max * v );
	graphsNeedRedraw := true;
end;

procedure tMainForm.scrollBarChange(Sender: TObject);
begin
	graphsNeedRedraw := true;
end;

procedure tMainForm.aHlpTipsExecute(Sender: TObject);
var
	mr: tModalResult;
begin
	tipsForm := tTipsForm.create( self );
	with tipsForm do
		begin
		try
			showAtStartupBox.checked := (getIniInt( ikShowTips, 1 ) <> 0);
			mr := showModal;
			setIniInt( ikShowTips, ord( showAtStartupBox.checked ) );
			finally free;
			end;
		end;
	if mr = mrOk then aHlpBugs.execute;
end;

procedure tMainForm.aFileCompressLogsUpdate(Sender: TObject);
begin
	aFileCompressLogs.enabled := (logFiles <> nil) and (logFiles.count > 0);
end;

function tMainForm.getIniString( const key, default: string ): string;
var
	ini: tIniFile;
begin
	ini := tIniFile.create( pnEFSConfig + fnEFSConfig );
//	ini := tIniFile.create( extractFilePath( application.exeName ) + fnEFSConfig );
	try
		result := ini.readString( isEFS, key, default );
		finally ini.free;
		end;
end;

procedure tMainForm.setIniString( const key, value: string );
var
	ini: tIniFile;
begin
	ini := tIniFile.create( pnEFSConfig + fnEFSConfig );
//	ini := tIniFile.create( extractFilePath( application.exeName ) + fnEFSConfig );
	try
		ini.writeString( isEFS, key, value );
		finally ini.free;
		end;
end;

function tMainForm.getIniInt( const key: string; default: integer ): integer;
var
	ini: tIniFile;
begin
	ini := tIniFile.create( pnEFSConfig + fnEFSConfig );
//	ini := tIniFile.create( extractFilePath( application.exeName ) + fnEFSConfig );
	try
		result := ini.readInteger( isEFS, key, default );
		finally ini.free;
		end;
end;

procedure tMainForm.setIniInt( const key: string; value: integer );
var
	ini: tIniFile;
begin
	ini := tIniFile.create( pnEFSConfig + fnEFSConfig );
//	ini := tIniFile.create( extractFilePath( application.exeName ) + fnEFSConfig );
	try
		ini.writeInteger( isEFS, key, value );
		finally ini.free;
		end;
end;

procedure tMainForm.aFileCompressLogsExecute(Sender: TObject);
var
	s: string;
	dw: dWord;
begin
	compressForm := tCompressForm.create( self );
	with compressForm do
		begin
		try
			s := getIniString( ikLastCompressDate, rsNever );
			blablaBox.text := format( msgAskCompressLogs, [hoursCompressMax, s] );
			compressThresholdBox.value := daysCompressThreshold;
			if showModal = mrOk then
				begin
				daysCompressThreshold := compressThresholdBox.value;
				setIniInt( ikCompressionThreshold, daysCompressThreshold );
				{ suspend the log recorder before compressing the logs }
				dw := bsm_applications;
				broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, suspendMsg, 0, 0 );
				end;
			finally free;
			end;
		end;
end;

procedure tMainForm.compressLogs;
var
	i, j, p: integer;
	logFile: tLogFile;
	ldByte1, ldByte2, ldByte3: pLogDataByte;
	ldWord1, ldWord2, ldWord3: pLogDataWord;
	ldInt1, ldInt2, ldInt3: pLogDataInteger;
	ldLong1, ldLong2, ldLong3: pLogDataInt64;
	ldReal1, ldReal2, ldReal3: pLogDataReal;
	ldKM1, ldKM2, ldKM3: pLogDataKnownMet;
	dt, dtNow, dtLast: tDateTime;
	when: integer;
	secs: int64;
	cr: tCursor;
begin
	cr := screen.cursor;
	screen.cursor := crHourGlass;
	setIniString( ikLastCompressDate, dateTimeToStr( now ) );

		try

			dtNow := now;
			dtLast := dtNow;
			for i := 0 to pred( logFiles.count ) do
				begin
				logFile := logFiles.log[ i ];
				logFile.load;
				try
					if logFile.logLen > 1 then
						begin
						case logFile.dataType of

							ltByte:
								begin
								ldByte1 := pLogDataByte( logFile.log );
								getMem( ldByte2, logFile.logSize );
								try
									p := 0;
									for j := pred( logFile.logLen ) downTo 0 do
										begin
										{$R-}
										{ note: unlike dtNow, the file date have been converted to utc,
										so there's a small inaccuracy, but that's not a real problem here;
										the compression may just start 1 or 2 hours sooner or later than expected... }
										dt := fileDateToDateTime( ldByte1^[ j ].date );
										when := secondsBetween( dtNow, dt ) div (daysCompressThreshold * 24 * 3600);
										secs := secondsBetween( dtLast, dt );
										if (secs >= when * (11 * 60)) or (secs >= hoursCompressMax * 3600) then
											begin
											ldByte2^[ p ] := ldByte1^[ j ];
											inc( p );
											dtLast := dt;
											end;
										{$IFDEF debug} {$R+} {$ENDIF}
										end;
									getMem( ldByte3, p * sizeOf( tLogRecByte ) );
									try
										for j := 0 to pred( p ) do
											{$R-}
											ldByte3^[ j ] := ldByte2^[ pred( p ) - j ];
											{$IFDEF debug} {$R+} {$ENDIF}
										logFile.save( ldByte3, p * sizeOf( tLogRecByte ) );
										finally freeMem( ldByte3 );
										end;
									finally freeMem( ldByte2 );
									end;
								end;

							ltWord:
								begin
								ldWord1 := pLogDataWord( logFile.log );
								getMem( ldWord2, logFile.logSize );
								try
									p := 0;
									for j := pred( logFile.logLen ) downTo 0 do
										begin
										{$R-}
										dt := fileDateToDateTime( ldWord1^[ j ].date );
										when := secondsBetween( dtNow, dt ) div (daysCompressThreshold * 24 * 3600);
										secs := secondsBetween( dtLast, dt );
										if (secs >= when * (11 * 60)) or (secs >= hoursCompressMax * 3600) then
											begin
											ldWord2^[ p ] := ldWord1^[ j ];
											inc( p );
											dtLast := dt;
											end;
										{$IFDEF debug} {$R+} {$ENDIF}
										end;
									getMem( ldWord3, p * sizeOf( tLogRecWord ) );
									try
										for j := 0 to pred( p ) do
											{$R-}
											ldWord3^[ j ] := ldWord2^[ pred( p ) - j ];
											{$IFDEF debug} {$R+} {$ENDIF}
										logFile.save( ldWord3, p * sizeOf( tLogRecWord ) );
										finally freeMem( ldWord3 );
										end;
									finally freeMem( ldWord2 );
									end;
								end;

							ltInteger:
								begin
								ldInt1 := pLogDataInteger( logFile.log );
								getMem( ldInt2, logFile.logSize );
								try
									p := 0;
									for j := pred( logFile.logLen ) downTo 0 do
										begin
										{$R-}
										dt := fileDateToDateTime( ldInt1^[ j ].date );
										when := secondsBetween( dtNow, dt ) div (daysCompressThreshold * 24 * 3600);
										secs := secondsBetween( dtLast, dt );
										if (secs >= when * (11 * 60)) or (secs >= hoursCompressMax * 3600) then
											begin
											ldInt2^[ p ] := ldInt1^[ j ];
											inc( p );
											dtLast := dt;
											end;
										{$IFDEF debug} {$R+} {$ENDIF}
										end;
									getMem( ldInt3, p * sizeOf( tLogRecInteger ) );
									try
										for j := 0 to pred( p ) do
											{$R-}
											ldInt3^[ j ] := ldInt2^[ pred( p ) - j ];
											{$IFDEF debug} {$R+} {$ENDIF}
										logFile.save( ldInt3, p * sizeOf( tLogRecInteger ) );
										finally freeMem( ldInt3 );
										end;
									finally freeMem( ldInt2 );
									end;
								end;

							ltInt64:
								begin
								ldLong1 := pLogDataInt64( logFile.log );
								getMem( ldLong2, logFile.logSize );
								try
									p := 0;
									for j := pred( logFile.logLen ) downTo 0 do
										begin
										{$R-}
										dt := fileDateToDateTime( ldLong1^[ j ].date );
										when := secondsBetween( dtNow, dt ) div (daysCompressThreshold * 24 * 3600);
										secs := secondsBetween( dtLast, dt );
										if (secs >= when * (11 * 60)) or (secs >= hoursCompressMax * 3600) then
											begin
											ldLong2^[ p ] := ldLong1^[ j ];
											inc( p );
											dtLast := dt;
											end;
										{$IFDEF debug} {$R+} {$ENDIF}
										end;
									getMem( ldLong3, p * sizeOf( tLogRecInt64 ) );
									try
										for j := 0 to pred( p ) do
											{$R-}
											ldLong3^[ j ] := ldLong2^[ pred( p ) - j ];
											{$IFDEF debug} {$R+} {$ENDIF}
										logFile.save( ldLong3, p * sizeOf( tLogRecInt64 ) );
										finally freeMem( ldLong3 );
										end;
									finally freeMem( ldLong2 );
									end;
								end;

							ltReal:
								begin
								ldReal1 := pLogDataReal( logFile.log );
								getMem( ldReal2, logFile.logSize );
								try
									p := 0;
									for j := pred( logFile.logLen ) downTo 0 do
										begin
										{$R-}
										dt := fileDateToDateTime( ldReal1^[ j ].date );
										when := secondsBetween( dtNow, dt ) div (daysCompressThreshold * 24 * 3600);
										secs := secondsBetween( dtLast, dt );
										if (secs >= when * (11 * 60)) or (secs >= hoursCompressMax * 3600) then
											begin
											ldReal2^[ p ] := ldReal1^[ j ];
											inc( p );
											dtLast := dt;
											end;
										{$IFDEF debug} {$R+} {$ENDIF}
										end;
									getMem( ldReal3, p * sizeOf( tLogRecReal ) );
									try
										for j := 0 to pred( p ) do
											{$R-}
											ldReal3^[ j ] := ldReal2^[ pred( p ) - j ];
											{$IFDEF debug} {$R+} {$ENDIF}
										logFile.save( ldReal3, p * sizeOf( tLogRecReal ) );
										finally freeMem( ldReal3 );
										end;
									finally freeMem( ldReal2 );
									end;
								end;

							ltKnownFile:
								begin
								ldKM1 := pLogDataKnownMet( logFile.log );
								getMem( ldKM2, logFile.logSize );
								try
									p := 0;
									for j := pred( logFile.logLen ) downTo 0 do
										begin
										{$R-}
										dt := fileDateToDateTime( ldKM1^[ j ].date );
										when := secondsBetween( dtNow, dt ) div (daysCompressThreshold * 24 * 3600);
										secs := secondsBetween( dtLast, dt );
										if (secs >= when * (11 * 60)) or (secs >= hoursCompressMax * 3600) then
											begin
											ldKM2^[ p ] := ldKM1^[ j ];
											inc( p );
											dtLast := dt;
											end;
										{$IFDEF debug} {$R+} {$ENDIF}
										end;
									getMem( ldKM3, p * sizeOf( tLogRecKnownMet ) );
									try
										for j := 0 to pred( p ) do
											{$R-}
											ldKM3^[ j ] := ldKM2^[ pred( p ) - j ];
											{$IFDEF debug} {$R+} {$ENDIF}
										logFile.save( ldKM3, p * sizeOf( tLogRecKnownMet ) );
										finally freeMem( ldKM3 );
										end;
									finally freeMem( ldKM2 );
									end;
								end;

							end;
						end;
					finally logFile.unload;
					end;
				end;

			finally
				graphsNeedRedraw := true;
				screen.cursor := cr;
			end;
end;

procedure tMainForm.aHlpBugsExecute(Sender: TObject);
var
	mr: tModalResult;
begin
	bugsForm := tBugsForm.create( self );
	with bugsForm do
		begin
		try
			mr := showModal;
			finally free;
			end;
		end;
	if mr = mrOk then aHlpTips.execute;
end;

procedure tMainForm.appEventsActionUpdate(Action: TBasicAction; var Handled: Boolean);
begin
	if action = aKFSaveAsCollection then
		begin
		aKFSaveAsCollection.enabled := (knownFilesList.selected <> nil) and (knownMet.list <> nil);
		handled := true;
		end;
end;

{ 28 apr 07: copy user formatted links >>> }
function tMainForm.getLinksCollection( const formatString: string = '' ): tStringList;

	function urlEncode( const s: string ): string;
	var
		i: integer;
		c: char;
	begin
		result := '';
		for i := 1 to length( s ) do
			begin
			c := s[ i ];
			if (c in ['0'..'9', 'a'..'z', 'A'..'Z', '$', '-', '_', '.', '+', '!', '*', '''', '(', ')', ',']) then result := result + c
			else result := result + '%' + intToHex( ord( c ), 2 );
			end;
	end;

	{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
	{ an AICH property is now defined... }
{ old code:
	function getAICH( rec: tKnownMetRecord ): string;
	var
		tag: tKnownMetTag;
	begin
		tag := rec.namedTag[ FT_AICH_HASH ];
		if tag <> nil then result := tag.m_pstrVal
		else result := '';
	end;
}	{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }

var
	item: tListItem;
	rec: tKnownMetRecord;
	link: string;
begin
	result := tStringList.create;
	try
		result.sorted := false;
		item := knownFilesList.selected;
		while item <> nil do
			begin
			rec := tKnownMetRecord( item.data );
			{ 08 may 07: ed2k links: Always add AICH hash if available >>> }
			link := 'ed2k://|file|' + urlEncode( rec.fileName ) + '|' + intToStr( rec.fileSize ) + '|' + rec.hash.hashStr + '|';
			if rec.AICH <> '' then link := link + 'h=' + rec.AICH + '|/'
			else link := link + '/';
			{ <<< 08 may 07: ed2k links: Always add AICH hash if available }
			if formatString = '' then
				{ 08 may 07: ed2k links: Always add AICH hash if available >>> }
				result.add( link )
{ old code:
				result.add( 'ed2k://|file|' + urlEncode( rec.fileName ) + '|' + intToStr( rec.fileSize ) + '|' + rec.hash.hashStr + '|/' )
}				{ <<< 08 may 07: ed2k links: Always add AICH hash if available }
			else
				result.add(
					stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( stringReplace( formatString,
						{ 08 may 07: ed2k links: Always add AICH hash if available >>> }
						'<link>', link, [rfReplaceAll, rfIgnoreCase] ),
						'<htmlLink>', '<a href=' + link + '>' + rec.fileName + '</a>', [rfReplaceAll, rfIgnoreCase] ),
{ old code:
						'<link>', 'ed2k://|file|' + urlEncode( rec.fileName ) + '|' + intToStr( rec.fileSize ) + '|' + rec.hash.hashStr + '|/', [rfReplaceAll, rfIgnoreCase] ),
						'<htmlLink>', '<a href=ed2k://|file|' + urlEncode( rec.fileName ) + '|' + intToStr( rec.fileSize ) + '|' + rec.hash.hashStr + '|/>' + rec.fileName + '</a>', [rfReplaceAll, rfIgnoreCase] ),
}						{ <<< 08 may 07: ed2k links: Always add AICH hash if available }
						'<name>', rec.fileName, [rfReplaceAll, rfIgnoreCase] ),
						'<urlName>', urlEncode( rec.fileName ), [rfReplaceAll, rfIgnoreCase] ),
						'<folder>', knownFilesList.cellFromTag[ item, kfColPath ], [rfReplaceAll, rfIgnoreCase] ),
						'<urlFolder>', urlEncode( knownFilesList.cellFromTag[ item, kfColPath ] ), [rfReplaceAll, rfIgnoreCase] ),
						'<hash>', rec.hash.hashStr, [rfReplaceAll, rfIgnoreCase] ),
						{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
						{ an AICH property is now defined... }
						'<aich>', rec.AICH, [rfReplaceAll, rfIgnoreCase] ),
{ old code:
						'<aich>', getAICH( rec ), [rfReplaceAll, rfIgnoreCase] ),
}						{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
						'<size>', intToStr( rec.fileSize ), [rfReplaceAll, rfIgnoreCase] ),
						'<transferred>', intToStr( rec.transferred ), [rfReplaceAll, rfIgnoreCase] ),
						'<requested>', intToStr( rec.requested ), [rfReplaceAll, rfIgnoreCase] ),
						'<accepted>', intToStr( rec.accepted ), [rfReplaceAll, rfIgnoreCase] ),
						'\n', #13#10, [rfReplaceAll] ),
						'\t', #9, [rfReplaceAll] )
				);
			item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
			end;
		except freeAndNil( result );
		end;
end;
{ old code:
function tMainForm.getLinksCollection( asHTML: boolean = false ): tStringList;

	function urlEncode( const s: string ): string;
	var
		i: integer;
		c: char;
	begin
		result := '';
		for i := 1 to length( s ) do
			begin
			c := s[ i ];
			if (c in ['0'..'9', 'a'..'z', 'A'..'Z', '$', '-', '_', '.', '+', '!', '*', '''', '(', ')', ',']) then result := result + c
			else result := result + '%' + intToHex( ord( c ), 2 );
			end;
	end;

var
	item: tListItem;
	rec: tKnownMetRecord;
begin
	result := tStringList.create;
	try
		result.sorted := false;
		item := knownFilesList.selected;
		while item <> nil do
			begin
			rec := tKnownMetRecord( item.data );
			if asHTML then result.add( '<a href=ed2k://|file|' + urlEncode( rec.fileName ) + '|' + intToStr( rec.fileSize ) + '|' + rec.hash.hashStr + '|/>' + rec.fileName + '</a>' )
			else result.add( 'ed2k://|file|' + urlEncode( rec.fileName ) + '|' + intToStr( rec.fileSize ) + '|' + rec.hash.hashStr + '|/' );
			item := knownFilesList.getNextItem( item, sdAll, [isSelected] );
			end;
		except freeAndNil( result );
		end;
end;
}{ <<< 28 apr 07: copy user formatted links }

procedure tMainForm.aKFSaveAsCollectionAccept(Sender: TObject);
var
	col: tStringList;
begin
	col := getLinksCollection;
	try
		col.saveToFile( aKFSaveAsCollection.dialog.fileName );
		finally col.free;
		end;
end;

procedure tMainForm.aKFCopyAsCollectionUpdate(Sender: TObject);
begin
	tAction( sender ).enabled := (knownFilesList.selected <> nil) and (knownMet.list <> nil);
end;

procedure tMainForm.aKFCopyAsCollectionExecute(Sender: TObject);
var
	col: tStringList;
begin
	col := getLinksCollection;
	try
		if col.count = 1 then clipBoard.asText := col[ 0 ]
		else clipBoard.asText := col.text;
		finally col.free;
		end;
end;

procedure tMainForm.aKFCopyAsHtmlCollectionExecute(Sender: TObject);
var
	col: tStringList;
begin
	{ 28 apr 07: copy user formatted links >>> }
	col := getLinksCollection( '<htmlLink>' );
{ old code:
	col := getLinksCollection( true );
}	{ <<< 28 apr 07: copy user formatted links }
	try
		if col.count = 1 then clipBoard.asText := col[ 0 ]
		else clipBoard.asText := stringReplace( col.text, #13#10, '<br>'#13#10, [rfReplaceAll] );
		finally col.free;
		end;
end;

{ 28 apr 07: copy user formatted links >>> }
procedure tMainForm.aKFCopyFormatExecute(Sender: TObject);
var
	col: tStringList;
begin
	copyFormatForm := tCopyFormatForm.create( self );
	with copyFormatForm do
		begin
		try
			formatBox.text := getIniString( ikCopyFormat, '' );
			if showModal = mrOk then
				begin
				setIniString( ikCopyFormat, formatBox.text );
				col := getLinksCollection( formatBox.text );
				try
					if col.count = 1 then clipBoard.asText := col[ 0 ]
					else clipBoard.asText := col.text;
					finally col.free;
					end;
				end;
			finally free;
			end;
		end;
end;
{ <<< 28 apr 07: copy user formatted links }

procedure tMainForm.aKFMoveToCancelledMetExecute(Sender: TObject);
begin
	delKnownFiles( true );
end;

procedure tMainForm.knownFilesListEditing(Sender: TObject; Item: TListItem; var AllowEdit: Boolean);
begin
	allowEdit := not isEmuleRunning and (knownFilesList.cellFromTag[ item, kfColShared ] <> rsYes);
end;

procedure tMainForm.aKFRenameUpdate(Sender: TObject);
begin
	aKFRename.enabled :=
		(knownFilesList.selCount = 1)
		and not isEmuleRunning
		and (knownMet.list <> nil)
		and not timer.enabled
		and (knownFilesList.cellFromTag[ knownFilesList.selected, kfColShared ] <> rsYes)
		{ 08 may 07: Bug fix: disable known.met editing features if known.met has been modified since last reload >>> }
		and knownMet.isUpTodate
		{ <<< 08 may 07: Bug fix: disable known.met editing features if known.met has been modified since last reload }
		;
	{ 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) >>> }
	if not knownMet.isUpTodate then backupKnownMetDone := false;
	if needCancelledMetBackup then backupCancelledMetDone := false;
	{ <<< 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) }
end;

procedure tMainForm.aKFRenameExecute(Sender: TObject);
begin
	knownFilesList.selected.editCaption;
end;

procedure tMainForm.knownFilesListEdited(Sender: TObject; Item: TListItem; var S: String);
var
	i: integer;
	b: boolean;
//	reply: integer;
	hash: string;
	p: integer;

	{ 29 apr 07: Optimizations >>> }
{	procedure backup;
	var
		s1, s2: string;
	begin
		s1 := knownMet.path;
		s2 := changeFileExt( s1, '.~met' );
		if promptForFileName( s2, rsBackMetFilesFilter + '|' + rsAllFilesFilter, '~met', '', '', true ) then
			begin
			if copyFile( pChar( s1 ), pChar( s2 ), false ) then
				backupKnownMetDone := true
			else
				begin
				application.messageBox( pChar( msgBackupFailed ), pChar( appFullName ), mb_ok or mb_iconWarning );
				reply := idCancel;
				end;
			end
		else
			reply := idCancel;
	end;
}	{ <<< 29 apr 07: Optimizations }

begin
	b := false;
	for i := length( s ) downTo 1 do
		if s[ i ] in ['\', '/', ':', '?', '*', '"', '<', '>', '|'] then
			begin
			delete( s, i, 1 );
			b := true;
			end;
	if b then application.messageBox( pChar( msgInvalidChars ), pChar( appFullName ), mb_Ok or mb_iconWarning );

	{ 05 may 07: Reworked interface interface for edit known.met confirmations >>> }
	if not backupKnownMetDone and not dontAskRename then
		begin
		b := false;
		if not confirmKMEdit( stringReplace( aKFRename.caption, '&', '', [] ), msgConfirmRename, false, b, dontAskRename ) then
			begin
			s := item.caption;
			exit;
			end;
		end;

(* old code:
	if not backupKnownMetDone then
		{ 29 apr 07: Repair known.met >>> }
		reply := application.messageBox( pChar( msgAskEditKnownMet1 + msgAskEditKnownMet2 + msgAskKnownMetBackup ), pChar( appFullName ), mb_YesNoCancel or mb_iconWarning )
{ old code:
		reply := application.messageBox( pChar( msgAskEditKnownMet + msgAskKnownMetBackup ), pChar( appFullName ), mb_YesNoCancel or mb_iconWarning )
}		{ <<< 29 apr 07: Repair known.met }
	else
		reply := idNo;

	{ 29 apr 07: Optimizations >>> }
	if reply = idYes then backupMet( reply );
{ old code
	if reply = idYes then backup;
}	{ <<< 29 apr 07: Optimizations }

	if reply = idCancel then
		s := item.caption
	else
		begin
*)	{ <<< 05 may 07: Reworked interface interface for edit known.met confirmations }
		try
			hash := tKnownMetRecord( item.data ).hash.hashStr;
			{ 28 apr 07: bug fix >>> }
			{ Not a real bug, actually, since a match should always be found... }
			if knownMet.list.findByHash( hash, p ) then
{ old code:
			knownMet.list.findByHash( hash, p );
			if p >= 0 then
}			{ <<< 28 apr 07: bug fix }
				begin
				knownMet.list[ p ] := s;
				knownMet.list.records[ p ].fileName := s;
				end;
			knownMet.save;
			except
				knownMet.date := -1;
				aKFReload.execute;
				raise;
			end;
	{ 05 may 07: Reworked interface interface for edit known.met confirmations >>> }
{ old code:
		end;
}	{ <<< 05 may 07: Reworked interface interface for edit known.met confirmations }
	tagsNeedRedraw := true;
end;

procedure tMainForm.chartMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
	showValuesAtCursor( tChart( sender ) );
end;

procedure tMainForm.mousMoveOutsideCharts(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
	showValuesAtCursor( nil, true );
end;

function tMainForm.getDisplayedFile( const hash: string ): tKnownMetRecord;
var
	p: integer;
begin
	if (hash <> '') and knownMet.list.findByHash( hash, p ) and (knownMet.list.records[ p ].color <> clWindow) then
		result := knownMet.list.records[ p ]
	else
		result := nil;
end;

procedure tMainForm.showValuesAtCursor( chart: tChart; hide: boolean = false );

	procedure getTimesAtPos( pt: tPoint; var realTime: tDateTime; var runtime: tEmuleRunTime );
	var
		r: double;
	begin
		{ calculate the time at mouse position, with current horizontal axis units (real date / runtime days) }
		with chart.chartRect do r := (pt.x - left + 1) / (right - left);
		with chart.bottomAxis do r := minimum + r * (maximum - minimum);
		if aGrEmuleRuntime.checked then runTime := round( r * (3600 * 24) )
		else realTime := r;

		{ real date <-> runtime days conversion }
		if (logFiles.runtimeLog <> nil) and (logFiles.runtimeLog.logSize > 0) then
			begin
			if aGrEmuleRuntime.checked then
				realTime := fileDateToDateTime( logFiles.realTimeAt[ runtime ] )
			else
				runtime := logFiles.runtimeAt[ dateTimeToFileDate( realTime ) ];
			end
		else
			begin
			if aGrEmuleRuntime.checked then
				realTime := -1
			else
				runtime := -1;
			end;
	end;

	procedure addEventText( const newText: string; color: tColor = clWindowText );
	begin
		lastEventBox.selAttributes.color := color;
		lastEventBox.selText := newText;
	end;

var
	pt: tPoint;
	r: double;
	s: string;
	realTime1, realTime2, realTime3: tDateTime;
	runtime1, runtime2, runTime3: tEmuleRunTime;
	evtLog: tEventsLog;
	p: integer;
	b: boolean;
	c: tColor;
	kf: tKnownMetRecord;
begin
	if chart = nil then { test both }
		begin
		chart := requestsChart;
		pt := chart.getCursorPos;
		if not ptInRect( chart.chartRect, pt ) then chart := transferredChart;
		end;
	pt := chart.getCursorPos;
	if not hide and ptInRect( chart.chartRect, pt ) then
		begin
		{ 02 may 07: Quick zoom and center >>> }
		if getAsyncKeyState( vk_shift ) < 0 then screen.cursor := crZoom
		else if getAsyncKeyState( vk_control ) < 0 then screen.cursor := crUnZoom
		else screen.cursor := crCross;
{ old code:
		screen.cursor := crCross;
}		{ <<< 02 may 07: Quick zoom and center }
		if logFiles.runtimeLog <> nil then
			{ since only the runtime log is reloaded, if the same graph has been displayed for a long time, the converted time will be erroneous }
			logFiles.runtimeLog.load;
		try
			getTimesAtPos( pt, realTime1, runTime1 );
			pt.x := pt.x - 5;
			getTimesAtPos( pt, realTime2, runTime2 );
			pt.x := pt.x + 10;
			getTimesAtPos( pt, realTime3, runTime3 );
			finally
				if logFiles.runtimeLog <> nil then logFiles.runtimeLog.unload;
			end;

		if runtime1 <> -1 then s := format( '%f ' + rsRuntimeXAxis, [runtime1 / (3600 * 24)] ) else s := '';
		if realTime1 <> -1 then
			begin
			if s <> '' then s := s + '  |  ';
			s := s + dateTimeToStr( realTime1 );
			end;

		{ calculate the value at mouse position }
		with chart.chartRect do r := (pt.y - top - 1) / (bottom - top);
		with chart.leftAxis do r := maximum - r * (maximum - minimum);
		s := s + '  |  ' + format( '%f', [r] );

		dateTimeBox.caption := s;

		lastEventBox.clear;
		addEventText( rsEvents + ': ' );
		b := false;
		evtLog := tEventsLog.create;
		try
			evtLog.load;
			evtLog.find( dateTimeToStr( realTime2 ), p );
			while (p >= 0) and (p < evtLog.count) and (compareDateTime( strToDateTime( evtLog.names[ p ] ), realTime3 ) <= 0) do
				begin
				kf := displayedFile[ evtLog.hashes[ p ] ];
				if (evtLog.hashes[ p ] = '') or (kf <> nil) then
					begin
					if b then addEventText( '  |  ' );
					if kf <> nil then c := kf.color else c := clWindowText;
					addEventText( dateTimeToStr( evtLog.dates[ p ] ) + ' = ' + evtLog.events[ p ], c );
					b := true;
					end;
				inc( p );
				end;
			finally evtLog.free;
			end;
		if not b then addEventText( rsNoLastEvent );
		end
	else
		begin
		screen.cursor := crDefault;
		dateTimeBox.caption := '';
		lastEventBox.clear;
		end;
end;

procedure tMainForm.chartDblClick(Sender: TObject);
var
	chart: tChart;
	pt: tPoint;
	r: double;
begin
	{ 02 may 07: Quick zoom and center >>> }
	if (getKeyState( vk_shift ) < 0) or (getKeyState( vk_control ) < 0) then exit;
	{ <<< 02 may 07: Quick zoom and center }

	chart := tChart( sender );
	pt := chart.getCursorPos;
	if ptInRect( chart.chartRect, pt ) then
		begin
		{ calculate the time at mouse position, with current horizontal axis units (real date / runtime days) }
		with chart.chartRect do r := (pt.x - left + 1) / (right - left);
		with chart.bottomAxis do r := minimum + r * (maximum - minimum);

		if aGrEmuleRuntime.checked then { runtime days -> real date conversion }
			begin
			if (logFiles.runtimeLog <> nil) then
				begin
				{ since only the runtime log is reloaded, if the same graph has been displayed for a long time, the converted time will be erroneous }
				logFiles.runtimeLog.load;
				try
					if (logFiles.runtimeLog.logSize > 0) then
						r := fileDateToDateTime( logFiles.realTimeAt[ round( r * (3600 * 24) ) ] )
					else
						exit; { no error msg: this should never happen }
					finally logFiles.runtimeLog.unload;
					end;
				end
			else
				exit; { no error msg: this should never happen }
			end;
		editEventsLog( r );
		end;
end;

procedure tMainForm.editEventsLog( dateTime: tDateTime );
begin
	eventsLogEditForm := tEventsLogEditForm.create( self );
	with eventsLogEditForm do
		begin
		dateTimeBox.text := dateTimeToStr( dateTime );
		if showModal = mrOk then
			graphsNeedRedraw := true;
		try
			finally free;
			end;
		end;
end;

procedure tMainForm.buildWebServicesMenu( parentMenu: tMenuItem );
var
	sl: tStringList;
	i: integer;
	s: string;
	m: tMenuItem;
	p: integer;
begin
	sl := tStringList.create;
	try
		sl.sorted := false;
		{ 06 may 07: bug fix: don't try to load webservices.dat if it does not exist... >>> }
		if fileExists( pnEmuleConfig + fnWebServicesDat ) then
//		if fileExists( eMulePath + dnEmuleConfig + fnWebServicesDat ) then
		{ <<< 06 may 07: bug fix: don't try to load webservices.dat if it does not exist... }
			sl.loadFromFile( pnEmuleConfig + fnWebServicesDat );
//			sl.loadFromFile( eMulePath + dnEmuleConfig + fnWebServicesDat );
		for i := pred( sl.count ) downTo 0 do
			begin
			s := trim( lowerCase( sl[ i ] ) );
			if (s = '') or (s[ 1 ] in ['#', '/']) or
			  (pos( '#filename', s ) = 0)
			  and (pos( '#cleanfilename', s ) = 0)
			  and (pos( '#name', s ) = 0)
			  and (pos( '#cleanname', s ) = 0)
			  and (pos( '#hashid', s ) = 0)
			  and (pos( '#filesize', s ) = 0)
				then sl.delete( i );
			end;
		parentMenu.clear;
		{ 06 may 07: bug fix: Add a "None" submenu if there are no webServices >>> }
		if sl.count = 0 then
			begin
			m := tMenuItem.create( self );
			m.caption := rsNoWebServices;
			m.enabled := false;
			parentMenu.add( m );
			end
		else
		{ <<< 06 may 07: bug fix: Add a "None" submenu if there are no webServices }
		for i := 0 to pred( sl.count ) do
			begin
			s := trim( sl[ i ] );
			p := pos( ',', s );
			if p > 0 then
				begin
				m := tMenuItem.create( self );
				m.caption := trimRight( copy( s, 1, pred( p ) ) );
				m.hint := trimLeft( copy( s, succ( p ), maxInt ) );
				m.enabled := (knownFilesList.selCount = 1);
				m.onClick := mWebServicesClick;
				parentMenu.add( m );
				end;
			end;
		finally sl.free;
		end;
end;

procedure tMainForm.knownFilesPopupPopup(Sender: TObject);
begin
	buildWebServicesMenu( mWebServices );
end;

procedure tMainForm.knownFilesMenuClick(Sender: TObject);
begin
	buildWebServicesMenu( mmWebServices );
end;

procedure tMainForm.mWebServicesClick(Sender: TObject);

	function encodeUrlQueryParam( const s: string ): string;
	var
		k: char;
		i: integer;
	begin
		result := '';
		for i := 1 to length( s ) do
			begin
			k := s[ i ];
			if k in ['0'..'9', 'a'..'z', 'A'..'Z'] then result := result + k
			else if k = ' ' then result := result + '+'
			else result := result + '%' + intToHex( ord( k ), 2 );
			end;
	end;

var
	s: string;
	rec: tKnownMetRecord;
begin
	s := tMenuItem( sender ).hint;
	rec := tKnownMetRecord( knownFilesList.selected.data );
	s := stringReplace( s, '#filename', encodeUrlQueryParam( rec.fileName ), [rfReplaceAll, rfIgnoreCase] );
	s := stringReplace( s, '#cleanfilename', encodeUrlQueryParam( rec.fileName ), [rfReplaceAll, rfIgnoreCase] );
	s := stringReplace( s, '#name', encodeUrlQueryParam( changeFileExt( rec.fileName, '' ) ), [rfReplaceAll, rfIgnoreCase] );
	s := stringReplace( s, '#cleanname', encodeUrlQueryParam( changeFileExt( rec.fileName, '' ) ), [rfReplaceAll, rfIgnoreCase] );
	s := stringReplace( s, '#hashid', rec.hash.hashStr, [rfReplaceAll, rfIgnoreCase] );
	s := stringReplace( s, '#filesize', intToStr( rec.fileSize ), [rfReplaceAll, rfIgnoreCase] );
	shellExecute( application.handle, 'open', pChar( s ), '', '', sw_showDefault );
end;

procedure tMainForm.aRefKF1Update(Sender: TObject);
begin
	aRefKF1.enabled := (knownFilesList.selCount = 1) and (
		(tKnownMetRecord( knownFilesList.selected.data ).color <> clWindow)
		or (knownFilesList.selected = refKF1) { just in case the log file has been deleted while it was set as reference }
	);
	aRefKF1.checked := (knownFilesList.selected = refKF1);
end;

procedure tMainForm.aRefKF1Execute(Sender: TObject);
begin
	if aRefKF1.checked then
		begin
		refKF1 := knownFilesList.selected;
		if refKF2 = refKF1 then refKF2 := nil;
		end
	else
		refKF1 := nil;
	graphsNeedRedraw := true;
	tagsNeedRedraw := true;
end;

procedure tMainForm.aRefKF2Update(Sender: TObject);
begin
	aRefKF2.enabled := (knownFilesList.selCount = 1) and (
		(tKnownMetRecord( knownFilesList.selected.data ).color <> clWindow)
		or (knownFilesList.selected = refKF2) { just in case the log file has been deleted while it was set as reference }
	);
	aRefKF2.checked := (knownFilesList.selected = refKF2);
end;

procedure tMainForm.aRefKF2Execute(Sender: TObject);
begin
	if aRefKF2.checked then
		begin
		refKF2 := knownFilesList.selected;
		if refKF1 = refKF2 then refKF1 := nil;
		end
	else
		refKF2 := nil;
	graphsNeedRedraw := true;
	tagsNeedRedraw := true;
end;

procedure tMainForm.aResetRefUpdate(Sender: TObject);
begin
	aResetRef.enabled := (refKF1 <> nil) or (refKF2 <> nil);
end;

procedure tMainForm.aResetRefExecute(Sender: TObject);
begin
	refKF1 := nil;
	refKF2 := nil;
	graphsNeedRedraw := true;
	tagsNeedRedraw := true;
end;

procedure tMainForm.aFileRecErrorsLogUpdate(Sender: TObject);
begin
	aFileRecErrorsLog.enabled := fileExists( pnEFSConfig  + fnRecErrorsLog );
//	aFileRecErrorsLog.enabled := fileExists( appPath + fnRecErrorsLog );
end;

procedure tMainForm.aFileRecErrorsLogExecute(Sender: TObject);
var
	sl: tStringList;
	i: integer;
	fs: tFormatSettings;
	s: string;
	p: integer;
	dw: dWord;
begin
	errorsLogForm := tErrorsLogForm.create( self );
	with errorsLogForm do
		begin
		sl := tStringList.create;
		try
			sl.sorted := false;
			sl.caseSensitive := false;
			sl.loadFromFile( pnEFSConfig + fnRecErrorsLog );
//			sl.loadFromFile( appPath + fnRecErrorsLog );
			getLocaleFormatSettings( $409, fs );
			for i := pred( sl.count ) downTo 0 do
				begin
				try
					s := sl[ i ];
					p := pos( '|', s );
					if p <= 1 then
						sl.delete( i )
					else
						sl[ i ] := dateTimeToStr( strToDateTime( copy( s, 1, pred( p ) ), fs ) ) + '   ' + copy( s, succ( p ), maxInt );
					except { erroneous lines are just ignored };
					end;
				end;
			logBox.lines.assign( sl );
			finally sl.free;
			end;
		dw := bsm_applications;
		broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, errorsViewedMsg, 0, 0 );
		showModal;
		try
			finally free;
			end;
		end;
end;

procedure tMainForm.eMuleStatsListDblClick(Sender: TObject);
begin
	aIniEditLog.execute;
end;

procedure tMainForm.aColorsExecute(Sender: TObject);
var
	i: integer;
	bColor, rColor, aColor: tColor;
	fs: tFormatSettings;
begin
	colorForm := tColorForm.create( self );
	with colorForm do
		begin
		try
			lumBar.position := round( deltaLum * 100 );
			for i := 0 to pred( transferredChart.seriesCount ) do
				seriesBox.items.objects[ i ] := tObject( transferredChart.series[ i ].seriesColor );
			if showModal = mrOk then
				begin
				deltaLum := lumBar.position / 100;
				getLocaleFormatSettings( $409, fs );
				setIniString( ikDeltaLum, floatToStr( deltaLum, fs ) );
				for i := 0 to pred( transferredChart.seriesCount ) do
					begin
					bColor := tColor( seriesBox.items.objects[ i ] );
					setIniString( format( ikColor, [i] ), intToHex( bColor, 6 ) );
					transferredChart.series[ i ].seriesColor := bColor;
					if i = 0 then
						requestsChart.series[ i ].seriesColor := bColor
					else if i <= maxDisplayedKF then
						begin
						getRequestsColors( bColor, rColor, aColor, deltaLum );
						requestsChart.series[ i * 2 - 1 ].seriesColor := rColor;
						requestsChart.series[ i * 2 ].seriesColor := aColor;
						end
					else
						requestsChart.series[ i + maxDisplayedKF ].seriesColor := bColor;
					end;
				graphsNeedRedraw := true;
				end;
			finally free;
			end;
		end;
end;

procedure tMainForm.loadColors;
var
	i: integer;
	bColor, rColor, aColor: tColor;
	fs: tFormatSettings;
begin
	getLocaleFormatSettings( $409, fs );
	deltaLum := strToFloat( getIniString( ikDeltaLum, floatToStr( deltaLum, fs ) ), fs );
	for i := 0 to pred( transferredChart.seriesCount ) do
		begin
		bColor := strToInt( '$' + getIniString( format( ikColor, [i] ), intToHex( transferredChart.series[ i ].seriesColor, 8 ) ) );
		transferredChart.series[ i ].seriesColor := bColor;
		if i = 0 then
			requestsChart.series[ i ].seriesColor := bColor
		else if i <= maxDisplayedKF then
			begin
			getRequestsColors( bColor, rColor, aColor, deltaLum );
			requestsChart.series[ i * 2 - 1 ].seriesColor := rColor;
			requestsChart.series[ i * 2 ].seriesColor := aColor;
			end
		else
			requestsChart.series[ i + maxDisplayedKF ].seriesColor := bColor;
		end;
end;

procedure tMainForm.aCreditsExecute(Sender: TObject);
begin
	creditsForm := tCreditsForm.create( self );
	try
		creditsForm.showModal;
		finally creditsForm.free;
		end;
end;

procedure tMainForm.aIniCombineUpdate(Sender: TObject);
var
	item: tListItem;
	n: integer;
begin
	n := 0;
	item := eMuleStatsList.selected;
	while (item <> nil) and (tLogFile( item.data ).what <> lwCombinedLogs) do
		begin
		inc( n );
		item := eMuleStatsList.getNextItem( item, sdAll, [isSelected] );
		if (n = 2) and (item = nil) then
			begin
			tAction( sender ).enabled := true;
			exit;
			end;
		end;
	tAction( sender ).enabled := false;
end;

procedure tMainForm.aGraphOptionsExecute(Sender: TObject);
begin
	graphOptionsForm := tGraphOptionsForm.create( self );
	with graphOptionsForm do
		begin
		try
			resampleBox.value := resampleThreshold;
			if showModal = mrOk then
				begin
				resampleThreshold := resampleBox.value;
				setIniInt( ikResampleThreshold, resampleThreshold );
				graphsNeedRedraw := true;
				end;
			finally
				free;
			end;
		end;
end;

procedure tMainForm.aIniSwapGraphUpdate(Sender: TObject);
begin
	aIniSwapGraph.enabled := eMuleStatsList.focused and (eMuleStatsList.itemFocused <> nil);
end;

procedure tMainForm.aIniSwapGraphExecute(Sender: TObject);
var
	logFile: tLogFile;
begin
	logFile := tLogFile( eMuleStatsList.itemFocused.data );
	if logFile.what = lwCombinedLogs then
		logFile.setProperties( logFile.flags xOr lfShowWithRequests, logFile.multiplier, logFile.units, logFile.operation, logFile.maxValue )
	else
		logFile.setProperties( logFile.flags xOr lfShowWithRequests, logFile.multiplier, logFile.units );
	if logFile.flags and lfShowWithRequests <> 0 then eMuleStatsList.cellFromTag[ eMuleStatsList.itemFocused, iniColGraphic ] := rsRequestsGraph
	else eMuleStatsList.cellFromTag[ eMuleStatsList.itemFocused, iniColGraphic ] := rsTransfersGraph;
	graphsNeedRedraw := true;
end;

procedure tMainForm.legendPanelDockDrop(Sender: TObject; Source: TDragDockObject; X, Y: Integer);
begin
	graphsSplitter.minSize := legendMinWidth;
	legendPanel.width := legendDefWidth;
	graphsSplitter.left := legendPanel.left - graphsSplitter.width;
	requestsLegend.height := requestsChart.height;
	transfersLegend.height := transferredChart.height;
end;

procedure tMainForm.legendDockablePanelEndDock(Sender, Target: TObject; X, Y: Integer);
begin
	if legendDockablePanel.floating then
		begin
		legendPanel.width := 0;
		graphsSplitter.left := legendPanel.left - graphsSplitter.width;
		graphsSplitter.minSize := 32767;
		legendPanel.dockSite := true;
		tCustomDockForm( legendDockablePanel.hostDockSite ).caption := rsLegendCaption;
		end;
end;

procedure tMainForm.legendDockablePanelResize(Sender: TObject);
begin
	if legendDockablePanel.floating then
		begin
		requestsLegend.height := legendDockablePanel.height div 2;
		transfersLegend.height := legendDockablePanel.height - legendDockablePanel.height div 2;
		end;
end;

{ Repair known.met >>> }
procedure tMainForm.aRepairKMUpdate(Sender: TObject);
var
	emuleRunning: boolean;
begin
	emuleRunning := isEmuleRunning;
	tAction( sender ).enabled :=
		not emuleRunning
		and (knownMet.list <> nil)
		and not timer.enabled
		{ 08 may 07: Bug fix: disable known.met editing features if known.met has been modified since last reload >>> }
		and knownMet.isUpTodate
		{ <<< 08 may 07: Bug fix: disable known.met editing features if known.met has been modified since last reload }
		;
	{ 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) >>> }
	if not knownMet.isUpTodate then backupKnownMetDone := false;
	if needCancelledMetBackup then backupCancelledMetDone := false;
(* old code:
	if eMuleRunning then
		begin { new backups may be needed }
		backupKnownMetDone := false;
		backupCancelledMetDone := false;
		end;
*)	{ <<< 12 may 08: Reset "backup done" flags whenever known.met or cancelled.met have been modified by another app (not only by eMule) }
end;

function tMainForm.repairKM( recreateMissing: boolean ): boolean;
var
	p, i, j: integer;
	logFile: tLogFile;
	logData: pLogDataKnownMet;
	logCount: integer;
	logIndex: integer;
	cr: tCursor;
	rec: tKnownMetRecord;
	bt, br, ba, bk: boolean;
	dt: int64;
	dr: dWord;
begin
	result :=false;

	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

		try

			bk := false;
			for logIndex := 0 to pred( logFiles.count ) do
				begin
				logFile := logFiles.log[ logIndex ];
				if (logFile.what = lwKnownFile) then
					begin
					if knownMet.list.findByHash( logFile.name, p ) then { known file -> recalculate stats if needed }
						begin
						logFile.load;
						try
							logData := pLogDataKnownMet( logFile.log );
							logCount := logFile.logLen;
							rec := knownMet.list.records[ p ];
							bt := false;
							br := false;
							ba := false;
							{ 04 may 07: bug fix >>> }
							if (logCount > 0) then
								begin
								if (logData^[ pred( logCount ) ].data.transferred > rec.transferred) then
									begin
									rec.transferred := rec.transferred + logData^[ pred( logCount ) ].data.transferred;
									bk := true;
									end;
								if (logData^[ pred( logCount ) ].data.requested > rec.requested) then
									begin
									rec.requested := rec.requested + logData^[ pred( logCount ) ].data.requested;
									bk := true;
									end;
								if (logData^[ pred( logCount ) ].data.accepted > rec.accepted) then
									begin
									rec.accepted := rec.accepted + logData^[ pred( logCount ) ].data.accepted;
									bk := true;
									end;
								end;
							{ <<< 04 may 07: bug fix }
							for i := pred( logCount ) downTo 1 do
								begin
								if (logData^[ pred( i ) ].data.transferred > logData^[ i ].data.transferred) then
									begin
									dt := logData^[ pred( i ) ].data.transferred;
									rec.transferred := rec.transferred + dt;
									bk := true;
									for j := i to pred( logCount ) do { update the end of the log }
										logData^[ j ].data.transferred := logData^[ j ].data.transferred + dt;
									bt := true;
									end;
								if (logData^[ pred( i ) ].data.requested > logData^[ i ].data.requested) then
									begin
									dr := logData^[ pred( i ) ].data.requested;
									rec.requested := rec.requested + dr;
									bk := true;
									for j := i to pred( logCount ) do { update the end of the log }
										logData^[ j ].data.requested := logData^[ j ].data.requested + dr;
									br := true;
									end;
								if (logData^[ pred( i ) ].data.accepted > logData^[ i ].data.accepted) then
									begin
									dr := logData^[ pred( i ) ].data.accepted;
									rec.accepted := rec.accepted + dr;
									bk := true;
									for j := i to pred( logCount ) do { update the end of the log }
										logData^[ j ].data.accepted := logData^[ j ].data.accepted + dr;
									ba := true;
									end;
								end;
							if bt or br or ba then logFile.save( logFile.log, logFile.logSize );
							finally logFile.unload;
							end;
						end
					else if recreateMissing then { unknown file -> add to known.met }
						begin
						logFile.load;
						try
							logData := pLogDataKnownMet( logFile.log );
							logCount := logFile.logLen;
							if logCount > 0 then with logData^[ pred( logCount ) ].data do
								rec := tKnownMetRecord.reCreate( rsRepairedKF, logFile.name, transferred, requested, accepted )
							else
								rec := tKnownMetRecord.reCreate( rsRepairedKF, logFile.name, 0, 0, 0 );
							knownMet.list.insertObject( p, rsRepairedKF, rec );
							bk := true;
							bt := false;
							br := false;
							ba := false;
							for i := pred( logCount ) downTo 1 do
								begin
								if (logData^[ pred( i ) ].data.transferred > logData^[ i ].data.transferred) then
									begin
									dt := logData^[ pred( i ) ].data.transferred;
									rec.transferred := rec.transferred + dt;
									for j := i to pred( logCount ) do { update the end of the log }
										logData^[ j ].data.transferred := logData^[ j ].data.transferred + dt;
									bt := true;
									end;
								if (logData^[ pred( i ) ].data.requested > logData^[ i ].data.requested) then
									begin
									dr := logData^[ pred( i ) ].data.requested;
									rec.requested := rec.requested + dr;
									for j := i to pred( logCount ) do { update the end of the log }
										logData^[ j ].data.requested := logData^[ j ].data.requested + dr;
									br := true;
									end;
								if (logData^[ pred( i ) ].data.accepted > logData^[ i ].data.accepted) then
									begin
									dr := logData^[ pred( i ) ].data.accepted;
									rec.accepted := rec.accepted + dr;
									for j := i to pred( logCount ) do { update the end of the log }
										logData^[ j ].data.accepted := logData^[ j ].data.accepted + dr;
									ba := true;
									end;
								end;
							if bt or br or ba then logFile.save( logFile.log, logFile.logSize );
							finally logFile.unload;
							end;
						end;
					end;
				end;

			if bk then
				begin
				knownMet.save;
				result := true;
				end;

			except
				knownMet.date := -1;
				aKFReload.execute;
				raise;
			end;

		finally screen.cursor := cr;
		end;
end;


function tMainForm.importMissingKF( const fName: string ): boolean;
var
	km: tKnownMet;
	cr: tCursor;
	i, p: integer;
	rec, rec2: tKnownMetRecord;
	b: boolean;
begin
	result := false;

	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

		try

			b := false;
			km := tKnownMet.create( fName );
			try
				km.load;

				for i := 0 to pred( km.list.count ) do
					begin
					rec := km.list.records[ i ];
					if not knownMet.list.findByHash( rec.hash.hashStr, p ) then { unknown file -> add to known.met }
						begin
						knownMet.list.insertObject( p, rec.fileName, rec );
						km.list.records[ i ] := nil; { don't destroy this record with km }
						b := true;
						end
					else { known file -> update fileName & fileSize tags if previously re-created from EFS logs }
						begin
						rec2 := knownMet.list.records[ p ];
						if rec2.fileSize = 0 then
							begin
							knownMet.list[ p ] := rec.fileName;
							knownMet.list.records[ p ] := rec;
							rec.transferred := rec2.transferred;
							rec.requested := rec2.requested;
							rec.accepted := rec2.accepted;
							rec2.free;
							km.list.records[ i ] := nil; { don't destroy this record with km }
							b := true;
							end;
						end;
					end;

				finally km.free;
				end;

			if b then
				begin
				knownMet.save;
				result := true;
				end;

			except
				knownMet.date := -1;
				aKFReload.execute;
				raise;
			end;

		finally screen.cursor := cr;
		end;
end;

function tMainForm.pasteKF( links: tStrings ): boolean;

	function urlDecode( const s: string ): string;
	var
		p, n: integer;
	begin
		result := s;
		p := 0;
		repeat
			p := posEx( '%', result, succ( p ) );
			if (p > 0) and (p <= length( result ) - 2) then
				begin
				try
					n := strToInt( '$' + copy( result, succ( p ), 2 ) );
					result := copy( result, 1, pred( p ) ) + chr( n ) + copy( result, p + 3, maxInt );
					except ;
					end;
				end;
		until (p = 0) or (p > length( result ) - 2);
	end;

var
	b: boolean;
	cr: tCursor;
	i, p: integer;
	p1, p2, p3: integer;
	s, h, n, aich: string;
	rec: tKnownMetRecord;
begin
	result := false;

	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

		try

			b := false;
			for i := 0 to pred( links.count ) do
				begin
				s := links[ i ];
				if s = '' then continue;

				p2 := pos( '|', s );
				p1 := posEx( '|', s, succ( p2 ) );
				p2 := posEx( '|', s, succ( p1 ) );
				p3 := posEx( '|', s, succ( p2 ) );
				h := copy( s, succ( p3 ), 32 );
				{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
				aich := copy( s, p3 + 36, 32 );
				{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
				if not knownMet.list.findByHash( h, p ) then { unknown file -> add to known.met }
					begin
					n := urlDecode( copy( s, succ( p1 ), pred( p2 - p1 ) ) );
					{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
					knownMet.list.insertObject( p, n,
						tKnownMetRecord.reCreate( n, h, 0, 0, 0, strToInt64( copy( s, succ( p2 ), pred( p3 - p2 ) ) ), aich )
					);
{ old code:
					knownMet.list.insertObject( p, n,
						tKnownMetRecord.reCreate( n, h, 0, 0, 0, strToInt64( copy( s, succ( p2 ), pred( p3 - p2 ) ) ) )
					);
}					{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
					b := true;
					end
				else { known file -> update fileName & fileSize tags if previously re-created from EFS logs }
					begin
					rec := knownMet.list.records[ p ];
					if rec.fileSize = 0 then
						begin
						n := urlDecode( copy( s, succ( p1 ), pred( p2 - p1 ) ) );
						knownMet.list[ p ] := n;
						rec.fileName := n;
						rec.fileSize := strToInt64( copy( s, succ( p2 ), pred( p3 - p2 ) ) );
						{ 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH >>> }
						rec.AICH := aich;
						{ <<< 08 may 07: bug fix: Import missing known files from ed2k links -> support for links with AICH }
						b := true;
						end;
					end;
				end;

			if b then
				begin
				knownMet.save;
				result := true;
				end;

			except
				knownMet.date := -1;
				aKFReload.execute;
				raise;
			end;

		finally screen.cursor := cr;
		end;
end;
{ <<< Repair known.met }

{ 02 may 07: Quick zoom and center >>> }
procedure tMainForm.chartClick(Sender: TObject);
var
	shift, ctrl: boolean;
	chart: tChart;
	pt: tPoint;
	oldZoom: integer;
	t0, t1, t2, t3: double;
begin
  	shift := (getKeyState( vk_shift ) < 0);
	ctrl := (getKeyState( vk_control ) < 0);
	if shift or ctrl then
		begin

		if (shift and (zoomBar.position = zoomBar.max)) or (ctrl and (zoomBar.position = 0)) then
			exit;

		chart := tChart( sender );
		pt := chart.getCursorPos;
		if ptInRect( chart.chartRect, pt ) then
			begin
			t1 := chart.bottomAxis.minimum;
			t3 := chart.bottomAxis.maximum;
			t0 := t1 - (t3 - t1) * (scrollBar.position / 10);
			with chart.chartRect do t2 := t1 + (t3 - t1) * ((pt.x - left) / (right - left));

			oldZoom := zoomBar.position;
			if shift then zoomBar.position := zoomBar.position + 1
			else zoomBar.position := zoomBar.position - 1;
			scrollBar.position := round( 10 * ( (t2 - ((t3 - t1) * oldZoom / zoomBar.position) / 2 - t0) / ((t3 - t1) * oldZoom / zoomBar.position) ) );
			end;
		end;
end;
{ <<< 02 may 07: Quick zoom and center }


{ Repair known.met >>> }
function tMainForm.delErroneousKF: boolean;
var
	i: integer;
	rec: tKnownMetRecord;
	b: boolean;
	cr: tCursor;
begin
	result := false;

	cr := screen.cursor;
	screen.cursor := crHourglass;
	try

		try

			b := false;
			for i := pred( knownMet.list.count ) downTo 0 do
				begin
				rec := knownMet.list.records[ i ];
				if (rec.fileName = '') or ((rec.hash.hash.lo = 0) and (rec.hash.hash.hi = 0)) then
					begin
					knownMet.list.delete( i );
					b := true;
					end;
				end;

			if b then
				begin
				knownMet.save;
				result := true;
				end;

			except
				knownMet.date := -1;
				aKFReload.execute;
				raise;
			end;

		finally screen.cursor := cr;
		end;
end;

procedure tMainForm.aRepairKMExecute(Sender: TObject);
var
	dw: dWord;
begin
	{ suspend the log recorder before proceeding }
	dw := bsm_applications;
	broadcastSystemMessage( bsf_ignoreCurrentTask, @dw, suspendMsg, 2, 0 );
	{ on suspendedMsg reception, repairKnownMet will be called }
end;

procedure tMainForm.repairKnownMet;
var
	b: boolean;
begin
	repairKMForm := tRepairKMForm.create( self );
	with repairKMForm do
		begin
		try
			if showModal = mrOk then
				begin
				b := false;
				{$B+}
				if importFromBackupBox.checked then b := importMissingKF( importFrom );
				if importFromLinksBox.checked then b := b or pasteKF( importLinks );
				if recalculateStatsBox.checked then b := b or repairKM( importFromLogsBox.checked );
				if deleteErroneousBox.checked then b := b or delErroneousKF;
				{$B-}
				if b then
					begin
					knownMetLoaded;
					graphsNeedRedraw := true;
					tagsNeedRedraw := true;
					end;
				end;
			finally free;
			end;
		end;
end;
{ <<< Repair known.met }

end.

